#ifndef lint
static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";
#endif
#define YYBYACC 1
#line 2 "pars.yacc"

/* $Id: pars.yacc,v 1.3 1994/07/23 03:33:48 pturner Exp pturner $
 * 
 * evaluate expressions, commands, parameter files
 * 
 */

#define PARS			/* to overide some defines in defines.h */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <ctype.h>
#include <sys/param.h>

#include "globals.h"

#ifndef M_PI
#     define M_PI  3.14159265358979323846
#endif

#ifndef TRUE
#     define TRUE 1
#endif

#ifndef FALSE
#     define FALSE 0
#endif

double result, resx, resy;	/* return value if expression */
double nonl_parms[10];

double drand48(void);
long lrand48(void);
double erf(double arg); /* doesn't seem to be in ANSI C */
double erfc(double arg); /* doesn't seem to be in ANSI C */
double rnorm(double mean, double sdev);
double fx(double x);
double normp(double b, double *s);
double invnorm(double p);
double invt(double p, int n);
double *getvptr(int gno, int setno, int v);
double vmin(double *x, int n);
double vmax(double *x, int n);
void yyerror(char *s);

static int interr;

static double *freelist[100]; 	/* temporary vectors */
static int fcnt;		/* number allocated */

int naxis = 0;	/* current axis */
int curline, curbox, curstring, curleg, curgrid;

int gotbatch, gotparams, gotread; /* these guys attempt to avoid reentrancy problems */
int readtype, readsrc;
char batchfile[256], paramfile[256], readfile[256];

static char f_string[512];	/* buffer for string to parse */
static int pos = 0;
static double *aa, *bb, *cc, *dd, *xx, *yy;
static int setindex, lxy, ls;
static int setsetno;
static int whichgraph;
static int whichset;

extern int change_gno;
extern int change_type;

#line 73 "pars.yacc"
typedef union {
    double val;
    long ival;
    double *ptr;
    long func;
    long pset;
    char *str;
} YYSTYPE;
#line 85 "y.tab.c"
#define ABS 257
#define ACOS 258
#define ASIN 259
#define ATAN 260
#define ATAN2 261
#define CEIL 262
#define COS 263
#define DEG 264
#define DX 265
#define DY 266
#define ERF 267
#define ERFC 268
#define EXP 269
#define FLOOR 270
#define HYPOT 271
#define INDEX 272
#define INT 273
#define INVN 274
#define INVT 275
#define IRAND 276
#define LGAMMA 277
#define LN 278
#define LOG 279
#define LOGISTIC 280
#define MAXP 281
#define MINP 282
#define MOD 283
#define NORM 284
#define NORMP 285
#define PI 286
#define RAD 287
#define RAND 288
#define RNORM 289
#define SETNO 290
#define SIN 291
#define SQR 292
#define SQRT 293
#define TAN 294
#define INUM 295
#define VX1 296
#define VX2 297
#define VY1 298
#define VY2 299
#define WX1 300
#define WX2 301
#define WY1 302
#define WY2 303
#define DELAYP 304
#define DOUBLEBUFFER 305
#define DOWN 306
#define ABSOLUTE 307
#define ABORT 308
#define ACTIVATE 309
#define ACTIVE 310
#define ALT 311
#define ALTERNATE 312
#define ALTXAXIS 313
#define ALTYAXIS 314
#define ANGLE 315
#define ANNOTATE 316
#define APPEND 317
#define AREA 318
#define ARROW 319
#define AUTO 320
#define AUTOSCALE 321
#define AUTOTICKS 322
#define AVG 323
#define AXIS 324
#define AXES 325
#define BACKBUFFER 326
#define BACKGROUND 327
#define BAR 328
#define BATCH 329
#define BLOCK 330
#define BIN 331
#define BOTH 332
#define BOTTOM 333
#define BOX 334
#define BOXPLOT 335
#define CD 336
#define CELLS 337
#define CENTER 338
#define CHAR 339
#define CHRSTR 340
#define CLEAR 341
#define CLICK 342
#define CMAP 343
#define COLOR 344
#define COMMENT 345
#define COPY 346
#define CYCLE 347
#define DECIMAL 348
#define DEF 349
#define DEFAULT 350
#define DELETE 351
#define DEVICE 352
#define DFT 353
#define DIFFERENCE 354
#define DISK 355
#define DRAW2 356
#define DROP 357
#define DXDX 358
#define DXP 359
#define DYDY 360
#define DYP 361
#define ECHO 362
#define EDIT 363
#define ELSE 364
#define END 365
#define ERRORBAR 366
#define EXIT 367
#define EXPONENTIAL 368
#define FALSEP 369
#define FFT 370
#define FILEP 371
#define FILL 372
#define FIND 373
#define FIXEDPOINT 374
#define FLUSH 375
#define FOCUS 376
#define FOLLOWS 377
#define FONTP 378
#define FOREGROUND 379
#define FORMAT 380
#define FRONTBUFFER 381
#define FRAMEP 382
#define GETP 383
#define GRAPH 384
#define GRAPHNO 385
#define GRAPHS 386
#define GRAPHTYPE 387
#define GRID 388
#define HARDCOPY 389
#define HBAR 390
#define HBOXPLOT 391
#define HGAP 392
#define HIDDEN 393
#define HORIZONTAL 394
#define HPGLL 395
#define HPGLP 396
#define HISTO 397
#define IF 398
#define IGNORE 399
#define IHL 400
#define IMAGE 401
#define IN 402
#define INIT 403
#define INITGRAPHICS 404
#define INOUT 405
#define INTEGRATE 406
#define INTERP 407
#define INVDFT 408
#define INVFFT 409
#define JUST 410
#define KILL 411
#define LABEL 412
#define LAYOUT 413
#define LEAVE 414
#define LEAVEGRAPHICS 415
#define LEFT 416
#define LEGEND 417
#define LENGTH 418
#define LEVEL 419
#define LEVELS 420
#define LINE 421
#define LINESTYLE 422
#define LINETO 423
#define LINEWIDTH 424
#define LINK 425
#define LOAD 426
#define LOCATOR 427
#define LOCTYPE 428
#define LOGX 429
#define LOGY 430
#define LOGXY 431
#define MAJOR 432
#define MIFL 433
#define MIFP 434
#define MINOR 435
#define MISSINGP 436
#define MOVE 437
#define MOVE2 438
#define MOVETO 439
#define NEGATE 440
#define NO 441
#define NONE 442
#define NORMAL 443
#define NXY 444
#define OFF 445
#define OFFSETX 446
#define OFFSETY 447
#define ON 448
#define OP 449
#define ORIENT 450
#define OUT 451
#define PAGE 452
#define PARA 453
#define PARALLEL 454
#define PARAMETERS 455
#define PARAMS 456
#define PATTERN 457
#define PERIMETER 458
#define PERP 459
#define PERPENDICULAR 460
#define PIE 461
#define PIPE 462
#define PLACE 463
#define POINT 464
#define POLAR 465
#define POWER 466
#define PREC 467
#define PREPEND 468
#define PRINT 469
#define PS 470
#define PSCOLORP 471
#define PSMONOP 472
#define PSCOLORL 473
#define PSMONOL 474
#define PUSH 475
#define POP 476
#define PUTP 477
#define RAWSPICE 478
#define READ 479
#define REDRAW 480
#define REGRESS 481
#define REGNUM 482
#define REGIONS 483
#define RENDER 484
#define REVERSE 485
#define RIGHT 486
#define RISER 487
#define ROT 488
#define RUNAVG 489
#define RUNMED 490
#define RUNSTD 491
#define RUNMIN 492
#define RUNMAX 493
#define SAMPLE 494
#define SAVEALL 495
#define SCALE 496
#define SCIENTIFIC 497
#define SET 498
#define SETNUM 499
#define SETS 500
#define SIGN 501
#define SIZE 502
#define SKIP 503
#define SLEEP 504
#define SLICE 505
#define SOURCE 506
#define SPEC 507
#define SPECIFIED 508
#define SPECTRUM 509
#define STACK 510
#define STACKEDBAR 511
#define STACKEDHBAR 512
#define STACKEDLINE 513
#define STAGGER 514
#define START 515
#define STARTTYPE 516
#define STATUS 517
#define STOP 518
#define STRING 519
#define SUBTITLE 520
#define SWAPBUFFER 521
#define SYMBOL 522
#define TICKP 523
#define TICKLABEL 524
#define TICKMARKS 525
#define TITLE 526
#define TO 527
#define TOP 528
#define TRUEP 529
#define TYPE 530
#define UP 531
#define VELOCITY 532
#define VERTICAL 533
#define VGAP 534
#define VIEW 535
#define WITH 536
#define WORLD 537
#define WRITE 538
#define X 539
#define X0 540
#define X1 541
#define XAXES 542
#define XAXIS 543
#define XCOR 544
#define XMAX 545
#define XMIN 546
#define XY 547
#define XYARC 548
#define XYBOX 549
#define XYBOXPLOT 550
#define XYFIXED 551
#define XYHILO 552
#define XYRT 553
#define XYSEG 554
#define XYSTRING 555
#define XYDX 556
#define XYDY 557
#define XYDXDX 558
#define XYDYDY 559
#define XYDXDY 560
#define XYX2Y2 561
#define XYXX 562
#define XYYY 563
#define XYZ 564
#define XYZW 565
#define XYUV 566
#define Y 567
#define Y0 568
#define Y1 569
#define Y2 570
#define Y3 571
#define Y4 572
#define Y5 573
#define YAXES 574
#define YAXIS 575
#define YES 576
#define YMAX 577
#define YMIN 578
#define ZEROXAXIS 579
#define ZEROYAXIS 580
#define ABOVE 581
#define BELOW 582
#define POLYI 583
#define POLYO 584
#define GENERAL 585
#define DDMMYY 586
#define MMDDYY 587
#define MMYY 588
#define MMDD 589
#define MONTHDAY 590
#define DAYMONTH 591
#define MONTHS 592
#define MONTHL 593
#define DAYOFWEEKS 594
#define DAYOFWEEKL 595
#define DAYOFYEAR 596
#define HMS 597
#define MMDDHMS 598
#define MMDDYYHMS 599
#define DEGREESLON 600
#define DEGREESMMLON 601
#define DEGREESMMSSLON 602
#define MMSSLON 603
#define DEGREESLAT 604
#define DEGREESMMLAT 605
#define DEGREESMMSSLAT 606
#define MMSSLAT 607
#define DOT 608
#define STAR 609
#define PLUS 610
#define CROSS 611
#define CIRCLE 612
#define SQUARE 613
#define DIAMOND 614
#define TRIANGLE1 615
#define TRIANGLE2 616
#define TRIANGLE3 617
#define TRIANGLE4 618
#define SPLINE 619
#define LANDSCAPE 620
#define PORTRAIT 621
#define FREE 622
#define FIXED 623
#define STATUSBAR 624
#define LOCATORBAR 625
#define TOOLBAR 626
#define VAR 627
#define NUMBER 628
#define FITPARM 629
#define OR 630
#define AND 631
#define GT 632
#define LT 633
#define LE 634
#define GE 635
#define EQ 636
#define NE 637
#define UMINUS 638
#define NOT 639
#define YYERRCODE 256
short yylhs[] = {                                        -1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   34,   34,   34,   34,   34,   34,   34,
   17,   17,   17,   17,   17,   17,   17,   17,   18,   18,
   18,   18,   18,   18,   18,   18,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   22,   22,   22,   22,   22,   22,   22,   27,
   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
   27,   27,   27,   27,   27,   27,   27,   27,   27,   27,
   27,   20,   20,   20,   20,   20,   20,   20,   20,   20,
   20,   20,   20,   31,   31,   31,   31,   19,   19,   19,
   19,   19,   19,   33,   35,   35,   35,   35,   35,   35,
   35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
   35,   35,   35,   35,   35,   35,   35,   35,   35,   35,
   35,   35,   35,   32,   32,   32,   32,   32,   32,   36,
   36,   36,   36,   36,   36,   38,   38,   38,   39,   39,
   39,   39,   39,   39,   39,   37,   37,   37,   37,   37,
   40,   40,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   44,   44,   44,   44,   44,   44,   44,
   44,   44,   44,   41,   41,   45,   45,   45,   45,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
   45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
   45,   45,   45,   45,   45,   42,   42,   42,   42,   42,
   42,   42,   42,   42,   42,   42,   43,   43,   43,   43,
   21,   21,   21,   21,   21,   21,   24,   24,   24,   24,
   24,    7,    7,    8,    8,   28,   28,   28,   28,   28,
   29,   29,   29,   29,   26,   26,   25,   25,   25,   15,
   15,   15,   15,   15,   14,   14,   14,   30,   30,    9,
    9,   12,   12,   12,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   13,   13,   13,   16,   16,   16,   16,   16,   16,   10,
   10,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    3,    3,    3,    3,    3,    5,    4,    4,    4,    4,
    4,    4,    4,    4,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,
};
short yylen[] = {                                         2,
    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    3,    4,    3,    2,    3,    1,    3,
    1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
    3,    3,    3,    9,    5,    4,    1,    3,    2,    2,
    3,    8,    1,    3,    2,    2,    2,    4,    4,    6,
    2,    2,    2,    7,    2,    2,    3,    3,    2,    2,
    2,    1,    2,    2,    2,    2,    2,    2,    2,    4,
    6,    3,    5,    3,    5,    7,    5,    7,    4,    8,
    4,    8,    2,    2,    2,    2,    1,    7,    6,    6,
    6,   10,   10,    6,    4,    1,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    3,    3,
    4,    3,    3,    4,    3,    3,    5,    2,    4,    4,
    6,    2,    1,    1,    1,    2,   17,    2,    2,    2,
    3,    2,    2,    8,    3,    3,    3,    3,    3,    4,
    4,    2,    2,    3,    2,    2,    2,    8,    3,    3,
    3,    3,    3,    4,    4,    2,    2,    2,    3,    2,
    2,    4,    3,    3,    3,    3,    3,    3,    4,    3,
    3,    3,    3,    4,    3,    4,    4,    8,    3,    3,
    3,    3,    8,    3,    3,    3,    3,    2,    3,    3,
    3,    3,    2,    3,    3,    3,    3,    4,    2,    3,
    3,    3,    3,    3,    3,    4,    5,    5,    4,    4,
    4,    4,    3,    3,    4,    3,    3,    3,    3,    4,
    2,    3,    3,    3,    3,    3,    4,    2,    3,    4,
    4,    3,    3,    3,    4,    4,    3,    5,    6,    6,
    4,    4,    3,    3,    3,    3,    3,    3,    4,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    2,    1,    1,    2,    2,    2,    2,
    2,    3,    3,    3,    3,    3,    3,    3,    3,    2,
    2,    3,    3,    2,    3,    3,    3,    3,    3,    4,
    4,    4,    2,    1,    2,    1,    2,    3,    2,    1,
    1,    1,    1,    1,    1,    2,    2,    2,    1,    2,
    2,    2,    2,    3,    2,    2,    2,    2,    2,    1,
    1,    2,    1,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    1,    2,    2,    3,    3,    2,    2,
    3,    3,    3,    3,    3,    3,    3,    3,    2,    2,
    2,    2,    3,    1,    2,    1,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    3,    3,    3,    3,    2,    2,
    3,    2,    2,    2,    3,    1,    2,    2,    2,    2,
    4,    2,    3,    2,    2,    2,    1,    2,    2,    2,
    3,    1,    1,    2,    2,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    6,    6,    8,    5,   10,    5,    3,    3,    5,    7,
    3,    3,    5,    7,    1,    1,    3,    5,    1,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    4,
    4,    4,    4,    4,    6,    4,    4,    1,    4,    4,
    4,    4,    6,    6,    6,    6,    1,    1,    4,    4,
    6,    6,    4,    4,    4,    4,    8,    6,    6,    6,
    4,    4,    1,    1,    1,    6,    6,    6,    6,    4,
    4,    4,    4,    5,    3,    3,    3,    3,    3,    3,
    3,    3,    2,    3,    2,    1,    1,    4,    3,    4,
    6,    8,    5,    7,    3,    5,    3,    3,    3,    3,
    3,    3,    4,    4,    4,    4,    6,    4,    4,    1,
    4,    4,    4,    4,    6,    3,    3,    3,    3,    3,
    3,    3,    3,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    4,    4,    6,    4,    4,
    4,    4,    8,    6,    6,    6,    4,    4,    1,    1,
    1,    6,    4,    4,    4,    4,    5,    3,    3,    3,
    3,    3,    3,    3,    3,    2,    3,    2,
};
short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  662,
  663,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  654,
  655,  656,  657,  658,  659,  660,  661,    0,    0,    0,
    0,  332,  333,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  125,    0,    0,  451,    0,
    0,    0,   43,  452,   87,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  453,  454,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  123,
  124,    0,    0,   37,    0,    0,  446,  448,  447,  450,
  449,    0,    0,  433,    0,    0,    0,    0,    0,   62,
    0,    0,    0,    0,    0,    0,    0,    0,  512,  514,
    0,  330,  513,  515,  516,  517,  518,  519,  520,    0,
  331,  334,  335,    0,    0,    0,    0,    0,  616,  617,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  326,   13,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   64,  471,  470,   59,   65,    0,    0,   99,
   97,   98,    0,    0,    0,    0,    0,    0,  443,  442,
  339,  336,   61,    0,  270,  269,  271,  250,  251,  252,
  253,  254,  255,  256,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,    0,    0,    0,    0,
    0,    0,    0,    0,  640,    0,    0,    0,    0,    0,
  664,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  679,  680,  681,    0,  665,    0,
    0,    0,    0,    0,  142,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  132,   39,
  129,  145,  128,  157,    0,   51,    0,    0,    0,    0,
    0,    0,    0,    0,   17,    0,    0,    0,   40,  105,
  104,  101,  103,  102,   60,    0,    0,    0,    0,    0,
    0,  221,   66,    0,    0,    0,    0,    0,    0,  434,
    0,    0,    0,  228,    0,  436,  435,    0,  329,    0,
    0,    0,   85,   86,   83,   84,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  199,    0,    0,  156,    0,    0,    0,    0,    0,
  146,   53,   52,    0,    0,    0,  100,    0,    0,    0,
  505,  508,    0,    0,  507,  509,  506,  504,   56,   55,
   28,   27,   26,   25,   24,   23,   21,   22,    0,    0,
    0,   67,    0,    0,  108,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   29,  122,    0,    0,    0,
    0,   63,  455,  456,  106,    0,  126,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  160,  193,    0,
    0,    0,    0,    0,  188,    0,    0,    0,    0,  107,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   68,    0,   69,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  337,  338,    0,   45,   47,
   46,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    5,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    6,    0,    2,    3,    4,    0,    0,
    8,  440,    0,    0,    0,  439,    0,  296,  437,  438,
    0,    0,  441,    0,    0,    0,    0,  295,    0,  294,
   10,    7,    0,    0,    9,   11,   12,    0,    0,    0,
    0,  350,  325,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   74,   38,    0,  340,  343,  345,  342,
  341,   41,  112,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  138,    0,  459,    0,  139,    0,  136,
  137,  511,  510,  135,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  173,    0,  175,  171,  172,    0,    0,    0,    0,
  225,  226,  223,  224,  222,    0,    0,  232,    0,    0,
    0,    0,    0,  237,  233,  229,    0,  276,  282,  277,
  283,  273,  274,  275,  280,  278,  279,  272,  281,  234,
  646,  647,  648,  649,  650,  651,  652,  653,    0,    0,
  328,   18,    0,    0,    0,    0,    0,    0,  205,    0,
  219,  216,  203,  201,  204,  217,  218,  200,    0,  202,
    0,    0,    0,    0,    0,  153,  152,  151,  150,  149,
    0,   58,    0,    0,    0,    0,    0,   57,  285,  286,
  284,  287,   44,    0,   14,   20,  109,  110,    0,  115,
  113,    0,    0,   31,    0,   32,   33,  290,  291,  288,
  289,  292,  293,   30,    0,    0,    0,   72,    0,    0,
  625,    0,    0,    0,    0,  165,  170,  167,  168,  164,
  163,  166,    0,  196,  194,  197,  195,    0,  191,  189,
  192,  190,    0,  247,  244,  246,  245,  248,  243,  185,
  184,  187,  186,    0,  131,  144,  159,    0,    0,    0,
    0,    0,  116,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  697,  614,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  323,    0,
    0,    0,    0,    0,  444,  445,    0,  311,    0,  475,
  476,  477,  478,  479,  480,  481,  482,  483,  484,  485,
  486,  487,  488,  489,  490,  491,  492,  493,  494,  495,
  496,  497,  498,  499,  500,  300,    0,  299,  314,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  297,    0,
  310,    0,    0,    0,    0,    0,  427,  349,    0,  416,
    0,    0,    0,    0,    0,    0,  348,    0,    0,    0,
    0,  474,    0,    0,  472,    0,    0,    0,    0,    0,
    0,  473,    0,    0,    0,    0,  353,  364,    0,  351,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  386,    0,  384,    0,  561,  634,  562,  635,  563,
  636,  564,    0,    0,  638,  566,  639,  567,  641,  569,
  642,  570,  643,  571,  644,  572,    0,    0,   95,  666,
  579,  667,  580,    0,    0,    0,  670,  584,  671,  585,
  672,  586,    0,    0,    0,    0,    0,    0,    0,    0,
  677,  591,  678,  592,    0,    0,  683,  600,  684,  601,
  685,  602,  686,  603,  344,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  140,  141,    0,  619,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   79,  174,  176,  177,    0,    0,  227,  242,  230,  231,
  235,    0,    0,  241,    0,  236,    0,    0,    0,    0,
  198,    0,    0,  209,    0,  206,    0,  210,  211,  215,
  220,    0,  154,  155,    0,   36,    0,    0,   81,    0,
   15,  111,  114,    0,    0,    0,    0,    0,   70,    0,
    0,    0,    0,    0,    0,  169,    0,    0,  249,    0,
    0,    0,  119,    0,    0,    0,    0,    0,    0,    0,
    0,  315,  318,  317,    0,    0,  319,  464,  461,  462,
  463,  460,  316,  312,  313,  303,  305,    0,  302,  309,
  308,    0,  306,    0,    0,    0,  428,  429,  430,    0,
  425,  424,  467,  466,  465,  422,  418,  417,  426,  419,
  420,    0,  365,    0,    0,  360,  369,  363,  370,    0,
    0,    0,    0,    0,    0,  354,    0,    0,    0,    0,
    0,    0,  355,    0,    0,  379,  366,  382,  380,  381,
    0,  352,  397,  392,    0,  413,  412,  391,  390,  410,
  398,  394,  396,  395,  414,  401,  389,  393,  502,  503,
  501,  402,  399,  400,    0,    0,    0,    0,  387,  388,
  409,    0,  385,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  633,    0,    0,  669,    0,    0,    0,
  618,    0,  620,    0,    0,    0,  238,    0,    0,    0,
   73,    0,    0,    0,    0,  117,  207,  208,    0,    0,
    0,    0,    0,    0,    0,   77,    0,    0,    0,    0,
  469,  468,  626,  623,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  321,  320,    0,
    0,    0,  423,    0,  371,  377,  375,  373,  367,  372,
  378,  376,  374,  368,    0,  411,  406,  405,  408,  407,
  415,  637,  565,    0,  574,  575,  573,    0,  582,    0,
    0,  674,  588,  675,  589,  676,  590,    0,  597,  598,
  596,    0,    0,    0,    0,    0,    0,    0,    0,   94,
  239,    0,    0,   71,    0,    0,    0,    0,    0,    0,
    0,    0,   89,    0,    0,    0,   50,    0,    0,  121,
    0,    0,    0,    0,    0,   90,   91,  421,    0,    0,
  645,  668,  682,    0,  621,    0,    0,    0,   78,    0,
    0,    0,  624,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   54,    0,  673,  587,    0,    0,   42,
   80,    0,    0,    0,   82,    0,    0,    0,    0,    0,
    0,  622,    0,    0,    0,    0,    0,    0,   93,    0,
   92,    0,    0,    0,    0,    0,    0,    0,
};
short yydgoto[] = {                                     154,
  896,  600,  157,  158,  159,  298,  221,  929,  206,  684,
  956, 1008, 1302, 1246, 1223,  400,  410,  161,  814,  740,
  162,  163,  164,  559,  678,  435,  247,  165,  166, 1374,
  793,  167,  168,  169,  560,  170,  573,  171,  222, 1009,
 1033,  987,  978, 1010, 1034,
};
short yysindex[] = {                                   8872,
   -4,  -11,   26,   48,   95,  106,  185,  237,    0,    0,
    0,  242,  244,  253,  254,  281,    0,  297,  306,  323,
  325,  366,  376,  378,  380,  384,  389,  390,  394,  412,
    0,    0,    0,  427,    0,  431,  432,  433,  437,    0,
    0,    0,    0,    0,    0,    0,    0, -587, -319, -319,
 -422,    0,    0, -158, -451, 1331, -319,  104, 8912, 9889,
  147,  -55, -127, -125, -326,    0, -258, -124,    0,  484,
11867,  188,    0,    0,    0,   91, -319,   78,  195, 3039,
  959,  186,  497,   -5,    0,    0, -277, 9255,10206,  -84,
  -79, -377,  -77, -350, -229,11867,  309, 1463,  122,    0,
    0,  213,10203,    0,  514,   17,    0,    0,    0,    0,
    0,  217,  -13,    0,  -73, -195, -479, 9572,  105,    0,
11867,  446, 8912,  443,11325, -213,11400,  -96,    0,    0,
 1331,    0,    0,    0,    0,    0,    0,    0,    0, 1331,
    0,    0,    0,  525, -350, -350, -350,   76,    0,    0,
11942,11942,11942,    0, 1026, 1984,  577,  580,  581,  349,
  585,12221,  600,  602,  573,  576,  607,  608,  609,  161,
    0,    0,11942,11942,11942,11942,11942,11942,11942,11942,
11942,11942,11942,11942,12259,11942,11942,   -8,11942,11942,
11942,11942,11942,11942,11942,11942,11942,11942,11942,11942,
11942,11942,    0,    0,    0,    0,    0,   -6, -350,    0,
    0,    0,  129,   12,   32, -350,   47,   51,    0,    0,
    0,    0,    0,   52,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  341,  642,  643,  646,
  647,  649,  667,  673,    0,  678,  681,  695,  696,  700,
    0,  701,  714,  716,  718,  741,  743,  744,  752,  754,
  756,  762,  771,  773,    0,    0,    0,  780,    0,  783,
  785,  787,  792,   80,    0,  -68,  677,  175,  214, -378,
  711,  795,  753,11867,11867,11867,  960,  765,    0,    0,
    0,    0,    0,    0,  799,    0,  808,  337,  356,  240,
 -478,  241,  245,  373,    0,  375,  677, 3012,    0,    0,
    0,    0,    0,    0,    0,  540,  257, -350,  259,  262,
  263,    0,    0,  386, -361,  391,  364, -319, -350,    0,
  393,  286,  -82,    0,  396,    0,    0,  161,    0,  269,
  399,  280,    0,    0,    0,    0,  148,  407,  292,  295,
  299,  308,  329,  332,  334, -378,  336,  348,11867,11867,
 3274,    0, -387,  351,    0,  677,  360,  361, -378, 3666,
    0,    0,    0, -350,  398,  365,    0,  892,  438, 4460,
    0,    0,  382,  -61,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1657,  626,
  385,    0,  637, -131,    0,  638,  -74,  507,  387,11867,
  388,  397,  -86,11867, 1001,    0,    0,  402,   43,11867,
  708,    0,    0,    0,    0,11867,    0,  506,  404,  672,
  405,  677,  406,  409, -378,  410, 4582,    0,    0,  411,
  413,  415,  417, 4925,    0,  434,  436,  442,  444,    0,
  487,  449, -350,  451,  453, -378,  454,  455,  456,  457,
  460, 5108,  462,    0,  463,    0,  464,11867,11867,11867,
11867, 5206,  674, -287,11867,    0,    0,  519,    0,    0,
    0,11942,11867,  979,  975,  978,  753,  963,  964,  765,
  963,  964, 2561,  -32,11867,11867,11867,11867,11867,11867,
11867,11867,11942,11942,11942,11942,11867,11942,    0,11867,
11942,11942,11942,11942,11942,11942,11942,11942,11942,11942,
11942,11942,11942,    0,11942,    0,    0,    0,11942,11867,
    0,    0,  702,  331, -186,    0, 3085,    0,    0,    0,
11867,  465,    0,  466,10523, 8912,11867,    0,  468,    0,
    0,    0,  536,  556,    0,    0,    0,  103,  717, 4033,
11945,    0,    0, 5249, 8075, 5268, 8695, 5277, 8703, 5310,
 8786, 5347,  722, 5410, 8873, 5443, 8929, 5473, 8948, 5503,
 8988, 5527, 9024, 5561, 9332, 5549, 7991,   39, 5617, 9342,
 5636, 9587, 5653, 8671, 1019, 5690, 9622, 5713, 9633, 5722,
 9645, 5735,10468, 5752,10785, 5767,10827, 5781,10838, 5825,
 9668, 5891, 9693, 5913,10849, 5924, 9708, 5954, 9716, 5963,
 9725, 5987, 9942,    0,    0,  470,    0,    0,    0,    0,
    0,    0,    0,11867,11867,11867,11867,11867,11867,11867,
11867,11867,11867,11867,11867,11867,11867,11867,  472,11867,
11867,11867,11867,11867,11867,11867,11867,11867,11867,11867,
11867,11867,11867,    0,  473,    0,  474,    0,  653,    0,
    0,    0,    0,    0, 1001,  688,11867,  963,  963, 6019,
11867,11867,11867,11867,11867,11867,11867,  475,  566,  567,
  480,    0,  486,    0,    0,    0,  489, 1071,11867,  490,
    0,    0,    0,    0,    0,  491, -300,    0,  493, 3085,
  494,  495,11867,    0,    0,    0,  496,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   21,  500,
    0,    0, 1088, 1090,  508,  -46,  509,  512,    0,  516,
    0,    0,    0,    0,    0,    0,    0,    0,  805,    0,
 8480, 8480,11867,  526,  527,    0,    0,    0,    0,    0,
11867,    0,  750, 1114,  658,  660,11867,    0,    0,    0,
    0,    0,    0,  821,    0,    0,    0,    0,  822,    0,
    0,  825, 1122,    0, 6048,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 6078, 1107, 1123,    0,  830, 6106,
    0, 1110,  316, 6162,  544,    0,    0,    0,    0,    0,
    0,    0,11867,    0,    0,    0,    0,11867,    0,    0,
    0,    0,  554,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,11867,    0,    0,    0, 8480, 8480, 8480,
 8480,11867,    0,  841,  843, 6171, 1141, 8489,11156, 6198,
11942, 1023,  688,    0,    0, 1062, 1831,  705,  705,  705,
  705,  705,  705,   31,  728,   31,  728,   37,  296,   37,
  296,  321,   37,  296, 1473, 8489,  215, 1885,  772,  772,
  772,  772,  772,  772,   31,  728,   31,  728,  273,  296,
  273,  296,  273,  296,11090, 8489,11156, 6267,    0,  561,
  569,  570,  414,  -58,    0,    0, -328,    0,  571,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 8480,    0,    0, -319,
  574,11867,  575,  579,  584,11867,  586, 8480,    0, 6382,
    0, 1150, 1157,  592,  594,  595,    0,    0,  706,    0,
  596,  597, -324, -194,  601, -294,    0, -350,11867,11867,
 -350,    0,  603,  605,    0,  606,10691,11008,11867,11867,
  -58,    0,  610,  611, -296, 1160,    0,    0, 4033,    0,
  613,  869,  734,  614,  615, 2920,  616, -324, -362,  618,
  -58,  621,  910, -171,  624,  634,11475,11792, -295,  639,
 1225,    0,11945,    0,    0,    0,    0,    0,    0,    0,
    0,    0,11867,11942,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,11942,11942,    0,    0,
    0,    0,    0,  655,  657,    0,    0,    0,    0,    0,
    0,    0,11867,11867,11867,11942,11867,11942,11867,11942,
    0,    0,    0,    0,11942,11942,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 6391, 6405, 6437, 6446, 6469,
 6564, 6594, 6623, 6653, 6681, 6715, 6724, 6774, 6799, 6811,
 1229, 6822, 6845, 6870, 6833, 6881, 6893, 6904, 6916, 6939,
 7047, 7070, 7079, 7093, 7108,    0,    0, 1228,    0,  -27,
 7120,  372,  372,  321,  321,  321, 7173, 7198, 1227,  774,
    0,    0,    0,    0,  670, 8480,    0,    0,    0,    0,
    0, 3085, 1272,    0, 7231,    0,  689,   43,11867, 1001,
    0,11867,  690,    0, -328,    0,  699,    0,    0,    0,
    0, 8480,    0,    0, 7259,    0,11867,  801,    0, 8480,
    0,    0,    0,  703,11867,11867,11867,  704,    0,11867,
11867,11942, -199,11867,11867,    0, 8480, 7325,    0, 7334,
 7517,  949,    0,11867,11867, 1269, 1287,  -27,11867,11942,
 1273,    0,    0,    0,  707,  709,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 8480,    0,    0,
    0, 8480,    0,11867,  710,  712,    0,    0,    0,  719,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1300,    0, 8480, 8480,    0,    0,    0,    0,  720,
 -350,  721,  723,  733, 8480,    0,  736, -350,  746,  755,
  757, 8480,    0, 8480, 8480,    0,    0,    0,    0,    0,
11867,    0,    0,    0,  758,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -246, 8480, -244, 8480,    0,    0,
    0, 1005,    0, 7143, 9950, 7540, 9965, 7549, 9980, 1305,
 1321, 7562, 7573, 7603, 9988, 7627,10005, 7721,10034, 7748,
10042, 7775,10494,    0,11867,  759,    0,11867, 1001,11867,
    0,11867,    0,  761,  996, 1322,    0,  775,11867, 1338,
    0, 1051, 7807,  408, 7834,    0,    0,    0,11867, 7869,
 1016, 1361, 7878, 8480, 8480,    0, 8480, 8480, 8489,11156,
    0,    0,    0,    0, 7936, 7945,  776,11867,11867, 1066,
 7958, 7969,11867, 1001, 8480,11156,11867,    0,    0, 8480,
 1366, 1367,    0,  786,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 8480,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,11867,
11867,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 7981, 1375, 8004,  227, 8013, 8027, 1373, 1372,    0,
    0, 8480,  791,    0,11867,11942, -179,11867,11867, 8036,
11867, 1374,    0,11867, 1362,11867,    0, 8049, 8066,    0,
 1084,11867, 8480,  227, 8480,    0,    0,    0, 8094, 8178,
    0,    0,    0,11867,    0,11867,  797,  928,    0, 8480,
 8489,11156,    0, 8205, 8232,11867, 8480,  929, 8241,11867,
 8265,11867,11867,    0, 8274,    0,    0, 8297, 8480,    0,
    0, 1369,  803, 8480,    0,11867, 8480,11867, 8480, 8480,
  804,    0,11867, 1388, 8480, 8324, 1392, 8480,    0,11867,
    0, 8351,11867, 8383,11867, 8413,11867, 8480,
};
short yyrindex[] = {                                   1434,
    0,    0,    0,    0,    0,    0,    0,    0,   -7,    0,
    0,    0,    0,    0,    0,    0,    2,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   69,  270,  282,    0,  310,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1426,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1428,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,12231,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 3242,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 3250,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1430,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1431,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1432,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1352,
    0,    0,    0,    0,    0, 1435,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1438,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1441,    0, 1443,    0, 1444,    0,    0,    0,
    0,    0,    0, 1446,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1425, 1519, 1132, 2026,
 2038, 2170,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1450,    0, 1454,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1368, 1507,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,12260,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 1455, 1461,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1464,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2490,    0,    0,    0,    0,
    0,    0, 3298,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1466, 1468, 1469,
 1470,    0,    0,    0,    0,    0,    0, 1471, 1472,    0,
    0,    0,    0,    0,    0, 4676, 3609, 3748, 3903, 4042,
 4236, 4383, 4529,  246,  298,  735,  951,   97, 2639,  416,
 2693, 1784, 2595, 2739,    0,  553,  107,   11,   13,   60,
   89,  258,  291,  328, 1332, 2138, 2252, 2960, 2767, 2810,
 2862, 2898, 2941, 2949,    0, 1474, 1475,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1476,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1479,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1480,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 1482,    0,  338,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  350,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2585, 2832, 1939, 2199, 2446,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1485,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1486,    0,    0,    0,    0,    0,    0,    0, 1487,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1488,    0,    0,    0,
    0, 1490,    0,    0,    0, 3000,    0, 2392,    0,    0,
 3120,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1493,    0,    0,
    0, 1494,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 3415, 3757,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 4188,    0,    0,    0,    0,    0,
    0, 4991,    0, 5077, 5185,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 4264,    0, 4915,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 3342,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1495, 1496,    0, 1498, 1501, 1502, 1503,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 4831,  668,    0,    0,    0, 1513,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 5221,    0,    0,    0,    0,    0,
    0,    0,    0,  763,    0,    0,    0, 1106,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1174,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1515,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 3142,    0,    0,    0,    0,    0,
    0,    0, 1517, 2503, 1520,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 1522,
 1525, 1527,    0,    0,    0,    0, 1532,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1533,    0,
    0, 3196,    0, 1535,    0,    0, 1536,    0, 1537, 1543,
    0,    0,    0,    0, 1545,    0,    0, 1547,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 1548,
};
short yygindex[] = {                                      0,
    1, 1113,    0,    0,    0,   53,  683, -738,  -50,   77,
 -716,    0,    0,  426, -718,    0, 1064,    0,    0,    0,
    0,    0,    0,    0,    0, -412,  -81,    0,    0,  112,
    0,    0,    0,    0,    0, 1497, 1231, 1499,   30,    0,
    0,    0,    0,  589,  542,
};
#define YYTABLESIZE 12898
short yytable[] = {                                     207,
  155,  799,  568, 1152,  802,  172,  223,  204,  875,  531,
  529,  577,  530, 1243,  532,  925,  819, 1167, 1193, 1149,
  611,  417,  605, 1279, 1309, 1250,  325,  703,  173,  640,
  535, 1292,  431,  568,  568,  568,  568,  568,  664,  568,
  203,  460,  577,  577,  577,  577,  577,  210,  577,  204,
  568,  611,  160,  605,  611,  568,  605,  436,  307,  577,
  297,  533,  425, 1340,  577,  174, 1160,  517,  611,  606,
  605,  318,  515, 1407,  384, 1409,  208,  516,  593, 1059,
  309, 1371, 1372,  864,  873,  310,  568,  175,  371,  380,
  211, 1244,  865,  520,  219,  577,  390,  220,  607,  520,
  606, 1371, 1372,  606,  385,  679,  539,  353,  354,  593,
  593,  593,  593,  593,  774,  593,  612,  606,  447,  311,
  473,  454,  212, 1373,  518,  472,  593,  482,  926,  607,
  518,  593,  607,  629,  176, 1299,  492,  539,  548,  548,
  539,  548,  775,  548, 1293,  177,  607,  612,  437,  704,
  612,  498,  501,  503,  539,  388,  682,  925,  683,  433,
  486, 1245,  593,  312,  612,  313,  493,  205,  717,  487,
 1294,  474,  308,  574,  576,  578,  580,  582,  584,  586,
  588,  590,  592,  594,  596,  599,  601,  603, 1224,  606,
  608,  610,  612,  614,  616,  618,  620,  622,  624,  626,
  628,  630,  632,  500,  500,  500, 1150,  475,  798,  205,
 1280, 1310, 1251,  741,  742,  743,  744,  745,  746,  747,
  748,  355,  356,  433,  178,  500,  500,  500,  500,  500,
  500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
  776,  500,  500,  500,  500,  500,  500,  500,  500,  500,
  500,  500,  500,  500,  500,  539,  531,  529, 1247,  530,
 1408,  532, 1410,  314, 1248,  801,  434,  608, 1300,  389,
  926, 1301, 1447, 1218, 1219,  675,  179,  535,  301,  594,
  433,  180, 1276,  181,  718,  476,  539,  725,  540,  539,
  540,  595,  182,  183,  688,  689,  690,  925,  608, 1289,
  609,  608, 1296,  539,  483,  477,  680,  542,  533,  517,
  594,  594,  594,  594,  594,  608,  594, 1474,  681,  578,
  184,  209,  595,  595,  595,  595,  595,  594,  595,  808,
  434,  609,  594, 1252,  609,  520,  185,  610,  542,  595,
  542,  542,  542,  428,  595,  186,  665,  560,  609,  927,
  578,  578,  578,  578,  578,  542,  578, 1220,  535,  583,
  419, 1193,  187,  594,  188,  302,  518,  578,  610,  771,
  772,  610,  578,  676,  633,  595, 1192, 1157,  560,  560,
  560,  560,  560,  520,  560,  610,  669,  434,  677,  533,
  583,  583,  583,  583,  583,  560,  583,  433,  219,  809,
  560,  220,  484,  578,  326,  189, 1194,  583,  517,  539,
  926,  429,  583,  693,  695,  190,  749,  191,  694,  192,
  805,  327,  485,  193,  815,  539, 1357, 1221,  194,  195,
  820,  560,  320,  196,  520, 1347,  824,  420,  421,  540,
  422,  928,  768,  583,  449, 1158,  974,  224,  450,  328,
  430,  197,  630, 1447,  303,  780,  539,  552,  552,  539,
  552,  219,  552,  304,  220,  695,  198,  321, 1446, 1222,
  199,  200,  201,  539,  969,  322,  202,  816,  858,  859,
  860,  861,  451,  823, 1159,  866,  300,  219,  568, 1165,
  220,  755,  868,  870,  810,  811,  812,  813, 1448,  329,
  305,  330,  306,  315,  434,  876,  877,  878,  879,  880,
  881,  882,  883,  884,  886,  888,  890,  892,  893,  756,
  895,  831,  219,  316,  975,  220,  976,  319,  452,  905,
  907,  909,  911,  913,  333,  219,  351,  350,  220,  916,
  918,  352,  848,  382,  500,  411,  423,  219,  383,  386,
  220,  957,  412,  418,  432,  968,  427,  970,  789,  790,
  791,  792,  539,  424,  488,  500,  500,  500,  500,  757,
  500,  758,  569,  500,  500,  500,  500,  500,  500,  500,
  500,  500,  500,  500,  500,  500,  536,  500,  323,  537,
  538,  500,  219,  539,  541,  220,  539,  521,  522,  523,
  524,  525,  526,  527,  528,  219,  453,  331,  220,  561,
  539,  562,  563,  728,  391,  564,  565,  566,  567,  605,
  729,  634,  568,  568,  568,  568,  568,  568,  568,  568,
  636,  577,  577,  577,  577,  577,  577,  577,  577,  637,
  611,  611,  605,  605, 1096, 1097, 1098, 1099, 1100, 1101,
 1102, 1103, 1104, 1105, 1106, 1107, 1108, 1109, 1110,  638,
 1112, 1113, 1114, 1115, 1116, 1117, 1118, 1119, 1120, 1121,
 1122, 1123, 1124, 1125,  640,  730,  731,  604,  641,  642,
  643,  644,  645,  570,  571,  646,  647, 1131,  648,  606,
  606, 1132, 1133, 1134, 1135, 1136, 1137, 1138,  593,  593,
  593,  593,  593,  593,  593,  593,  649,  674,  604, 1146,
  392,  604,  650,  393,  732,  733,  734,  651,  607,  607,
  652,  394,  679, 1155,  395,  604,  548,  548,  548,  548,
  548,  548,  548,  548,  653,  654,  612, 1129, 1130,  655,
  656,  517,  299,  720,  539, 1352,  693,  691,  920,  692,
  735,  694,  921,  657,  922,  658,  685,  659,  324,  396,
  332,  461,  344,  531,  529, 1044,  530,  520,  532,  531,
  372,  381,  576, 1172,  532,  539,  387,  544,  539,  544,
  660, 1175,  661,  662,  535,  455,  462, 1180,  426,  456,
  535,  663,  539,  664,  397,  665,  736,  737,  695,  645,
  448,  666,  680,  576,  576,  576,  576,  576,  219,  576,
  667,  220,  668,  531,  529,  533,  530,  923,  532,  669,
  576,  533,  670,  457,  671,  576,  672,  489,  490,  491,
  721,  673,  738, 1197,  535, 1215,  739, 1216, 1198,  398,
  686,  681,  698,  687,  558,  522,  523,  524,  525,  526,
  527,  528,  572,  699, 1200,  697,  576,  701,  219,  463,
  924,  220, 1201,  700,  464,  533,  465,  702,  705,  458,
  466,  599,  706,  708,  707,  540,  540,  540,  540,  540,
  540,  540,  540,  710,  711,  716,  713,  608,  608,  714,
  715,  635,  719,  722,  727,  750,  752,  753,  639,  594,
  594,  594,  594,  594,  594,  594,  594,  754,  760, 1226,
  723,  595,  595,  595,  595,  595,  595,  595,  595,  761,
  609,  609,  762,  500,  783, 1208,  763,  542,  542,  542,
  542,  542,  542,  542,  542,  764,  399,  785,  467,  578,
  578,  578,  578,  578,  578,  578,  578,  459,  741,  742,
  743,  744,  745,  746,  747,  748,  765,  610,  610,  766,
  546,  767, 1228,  769,  786,  795, 1232,  560,  560,  560,
  560,  560,  560,  560,  560,  770,  797,  800,  777,  583,
  583,  583,  583,  583,  583,  583,  583,  778,  779, 1254,
 1255,  546,  784,  546,  546,  546,  517, 1265, 1272, 1274,
 1275,  693,  691,  696,  692,  803,  694,  825,  546,  788,
  712,  827,  796,  863,  804,  806,  843,  867,  871,  724,
  872,  726,  520,  873,  807,  520,  535, 1306, 1308,  817,
  572,  826,  828,  829,  972,  519,  830,  832,  834,  759,
  835,  919,  836, 1314,  837,  552,  552,  552,  552,  552,
  552,  552,  552,  695,  973,  979,  980, 1316, 1318, 1066,
  981,  839,  517,  840, 1140, 1141,  782,  515,  513,  841,
  514,  842,  516, 1322, 1323, 1324,  844, 1326,  846, 1328,
  847,  849,  850,  851,  852, 1330, 1332,  853,  520,  855,
  856,  857,  958,  959,  982,  971,  500, 1095,  517, 1111,
 1126, 1127, 1139,  693,  691,  821,  692, 1142,  694,  500,
  500,  818,  156, 1143, 1145,  581, 1144, 1147, 1148,  518,
 1151, 1153, 1154, 1156,  520,  821,  983, 1161,  500,  984,
  500, 1162,  500, 1163, 1176, 1164, 1168,  500,  500, 1169,
  985,  615,  668, 1170, 1171,  845,  581,  581,  581,  581,
  581, 1128,  581, 1173, 1174,  695, 1178, 1177, 1179, 1353,
 1181, 1182, 1355,  581, 1183, 1184, 1188, 1187,  581, 1189,
 1191, 1196,  615,  615,  615,  615,  615, 1360,  615,  986,
 1202, 1199, 1203,  599, 1205, 1363, 1364, 1365, 1212,  615,
 1367, 1368, 1369, 1235, 1375, 1376, 1213, 1214, 1225,  581,
 1236, 1227, 1229, 1281, 1381, 1382, 1230, 1240, 1284, 1385,
  682, 1231, 1354, 1233,  599,  599,  599,  599,  599, 1237,
  599, 1238, 1239, 1241, 1242,  615,  129,  130, 1249,  822,
 1257,  599, 1258, 1259, 1390, 1285,  599, 1277, 1278,  345,
 1283, 1286, 1287, 1290,  500, 1295,  129,  130, 1297, 1298,
  977, 1303, 1007, 1032,  133,  134,  135,  136,  137,  138,
  139, 1304,  500,  499,  502,  504, 1311,  599, 1312, 1337,
 1344,   52,   53, 1339,  133,  134,  135,  136,  137,  138,
  139, 1405, 1320,   56, 1321,  575,  577,  579,  581,  583,
  585,  587,  589,  591,  593,  595,  597, 1346,  602,  604,
 1345,  607,  609,  611,  613,  615,  617,  619,  621,  623,
  625,  627,  629,  631,  633, 1348, 1350, 1356,  741,  742,
  743,  744,  745,  746,  747,  748, 1358, 1361, 1380, 1383,
 1362, 1366, 1384, 1387, 1388, 1432, 1389, 1391, 1434, 1392,
 1436,  539, 1437, 1394, 1411, 1418, 1393, 1395, 1397, 1442,
 1398,  521,  522,  523,  524,  525,  526,  527,  528, 1450,
 1399, 1419, 1440, 1400,  544,  544,  544,  544,  544,  544,
  544,  544,  539, 1402,  543,  539,  543,  698, 1458, 1459,
 1439, 1443, 1403, 1463, 1404, 1406, 1433, 1465, 1438,  539,
 1444, 1435,  576,  576,  576,  576,  576,  576,  576,  576,
 1452, 1453, 1441, 1457,  698, 1460, 1466, 1467,  698,  698,
  698,  698,  698, 1468,  698, 1472, 1477, 1478, 1479, 1488,
 1469, 1470, 1490, 1494, 1500,  698, 1501, 1505, 1519, 1513,
 1514, 1517, 1521,    1,  535,   96, 1464,   19, 1166,  324,
  133,  327,  516, 1291,  147, 1480, 1481,  161, 1484, 1485,
  130, 1487,  143,  158, 1489,  118, 1491,  346,  347,  458,
  698,  698, 1495,  457,  213,  535,  535,  535,  535,  535,
  214,  535,  794,   16, 1498,  180, 1499,  179,  182,  181,
  531,  527,  535,  532,  528,  298, 1504,  535,  301,  346,
 1507,  347, 1509, 1510,   48,  212,   49,  162,  500,  120,
  131,  132,  307,  304,   35,  526, 1515,   75, 1516,  517,
  524,  533,  529, 1518,  693,  691,  696,  692,  535,  694,
 1522, 1207,  322, 1524,  240, 1526,  521, 1528,  539,  522,
 1209,   76,  140,  141,  534,  520,  530,  142,  143,  129,
  130,   88,  134,  696,  148,  523,  183,  696,  696,  696,
  696,  696,  178,  696,   34,  698,  525,  127, 1483,  539,
  698,  698,  539,  698,  696,  698,  695,  133,  134,  135,
  136,  137,  138,  139, 1313,    0,  539,  348,  751,  349,
  546,  546,  546,  546,  546,  546,  546,  546,    0,  505,
  506,  507,  508,  509,  510,  511,  512, 1282,    0,  696,
  696,    0,    0,    0,  869, 1217,    0,    0,    0,    0,
    0,    0,  698,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  885,  887,  889,  891,    0,
  894,    0,    0,  897,  898,  899,  900,  901,  902,  903,
  904,  906,  908,  910,  912,  914,  698,  915,  698,  698,
    0,  917,    0,    0,    0,  505,  506,  507,  508,  509,
  510,  511,  512,    0,    0,    0,    0,    0,    0,  213,
 1253,    0,    0, 1256,  214,    0,    0,    0,  698, 1266,
 1273,    0,  698,    0,  698,    0,    0,    0,    0,    0,
    0, 1007,  506,  507,  508,  509,  510,  511,  512,  698,
    0,    0,    0,    0,    0,    0,  698,    0,  215,    0,
    0,  698,    0,    0,    0, 1032,    0,  698,  216,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  581,  581,  581,  581,  581,
  581,  581,  581,    0,    0,  698,    0,  698,    0,    0,
    0,    0,  217,    0,  218,    0,    0,    0,    0,  698,
    0,  615,  615,  615,  615,  615,  615,  615,  615,  698,
    0,    0,    0,    0,    0,  219,    0,  698,  220,    0,
  698,    0,    0,    0,    0,  696,    0,  696,  696,    0,
    0,  698,    0,  631,    0,    0,    0,    0,    0,  698,
    0,    0,  698,  599,  599,  599,  599,  599,  599,  599,
  599,    0,  698,  698,  698,  698,  698,  696,  698,    0,
  631,  696,    0,  696,  631,  631,  631,  631,  631,    0,
  631,    0,    0,  401,  698,  698,    0,    0,  696,    0,
 1351,  631,    0,    0,    0,  696,    0,    0,    0,    0,
  696,  402,    0,    0,    0,    0,  696,  403,  404,    0,
    0,    0,    0,    0,    0,    0,    0,  517,  698,  698,
  698,    0,  693,  691,  698,  692,  631,  694,    0,    0,
    0,  698,  698,    0,  696,  698,  696,    0,    0,    0,
  698,    0,    0,  520,    0,  405,  406,  698,  696,    0,
    0,  698,    0,    0,    0,    0,    0,    0,  696,    0,
    0,    0,    0,    0,    0,    0,  696,    0,    0,  696,
    0,    0,    0,    0,  695,    0,  531,  529,    0,  530,
  696,  532,    0,    0,  407,    0,  408,    0,  696,    0,
    0,  696,    0, 1396,    0,    0,    0,  535,  629,    0,
 1401,  696,  696,  696,  696,  696,    0,  696,    0,    0,
    0,  543,  543,  543,  543,  543,  543,  543,  543,    0,
    0,    0,    0,  696,  696,  629,    0,    0,  533,  629,
  629,  629,  629,  629,    0,  629,    0,    0,    0,  409,
    0,    0,    0,  534,    0,  698,  629,  698,  698,  698,
  698,  698,  698,  698,  698,    0,    0,  696,  696,  696,
    0,    0,    0,  696,    0,    0,    0,    0,    0,    0,
  696,  696,    0,    0,  696,  531,  529,  401,  530,  696,
  532,  629,    0,    0,    0,  536,  696,    0,    0,    0,
  696,    0,    0,    0,    0,  402,  535,  539,    0,    0,
    0,  403,  404,    0,  535,  535,  535,  535,  535,  535,
  535,  535,  631,    0,  631,  631,  536,  536,  536,  536,
  536,    0,  536,    0,  696,    0,    0,  533,  539,  696,
  696,  539,  696,  536,  696,    0,    0,    0,  536,  405,
  406,    0,    0,    0,  631,  539,    0,    0,  631,    0,
  631,    0,  505,  506,  507,  508,  509,  510,  511,  512,
    0,    0,    0,    0,    0,  631,    0,    0,    0,  536,
    0,    0,  631,    0,    0,    0,    0,  631,  407,    0,
  408,  696,    0,  631,  696,    0,  696,  696,  696,  696,
  696,  696,  696,  696,    0,    0,    0,  541,  698,  698,
  698,  698,  698,  698,  698,  698, 1315,    0,    0,    0,
    0,  631,    0,  631,    0,    0,    0,    0,    0, 1317,
 1319,    0,    0,    0,    0,  631,    0,    0,  541,  613,
  541,  541,  541,    0,    0,  631,    0,    0, 1325,    0,
 1327,    0, 1329,  631,    0,  541,  631, 1331, 1333,    0,
    0,    0,    0,    0,    0,    0,    0,  631,  630,    0,
  613,  613,  613,  613,  613,  631,  613,  629,  631,  629,
  629,    0,    0,    0,    0,    0,    0,  613,  631,  631,
  631,  631,  631,    0,  631,  630,    0,    0,    0,  630,
  630,  630,  630,  630,    0,  630,    0,    0,    0,  629,
  631,  631,    0,  629,    0,  629,  630,    0,    0,    0,
    0,  539,    0,  613,    0,    0,    0,    0,    0,    0,
  629,    0,    0,    0,    0,    0,    0,  629,    0,    0,
    0,    0,  629,    0,  631,  631,  631,    0,  629,    0,
  631,  630,  539,    0,  547,  539,  547,  631,  631,    0,
    0,  631,    0,    0, 1370,    0,  631,    0,    0,  539,
    0,    0,    0,  631,    0,    0,  629,  631,  629,    0,
    0,    0, 1386,    0,    0,    0,    0,    0,    0,    0,
  629,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  629,    0,    0,    0,    0,    0,    0,    0,  629,    0,
    0,  629,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  629,    0,    0,    0,    0,    0,    0,    0,
  629,    0,    0,  629,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  629,  629,  629,  629,  629,    0,  629,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  537,    0,    0,    0,  629,  629,    0,    0,    0,
    0,  631,    0,  631,  631,  631,  631,  631,  631,  631,
  631,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  537,  537,  537,  537,  537,    0,  537,  629,
  629,  629,    0,    0,    0,  629,    0,    0,    0,  537,
    0,    0,  629,  629,  537,  632,  629,    0,    0,    0,
    0,  629,  507,  508,  509,  510,  511,  512,  629,    0,
    0,    0,  629,    0,    0,    0,    0,  630,    0,  630,
  630,    0,  632,    0,    0,  537,  632,  632,  632,  632,
  632,    0,  632,    0,    0,    0,    0,    0,    0,  619,
    0,    0,    0,  632,    0,    0,    0,    0,    0,  630,
    0,    0,  538,  630,    0,  630,  523,  524,  525,  526,
  527,  528,    0,    0,    0,    0,  619,    0,    0,    0,
  630,  619,  619,    0,  619,    0,  619,  630,  632,    0,
    0,    0,  630,  538,  538,  538,  538,  538,  630,  538,
    0,    0,  619,    0,    0,    0,    0,    0, 1482,    0,
  538,    0,    0,    0,    0,  538,  629,    0,  629,  629,
  629,  629,  629,  629,  629,  629,  630,    0,  630,    0,
    0,    0,    0,  619,    0,    0,    0,    0,    0,    0,
  630,    0,    0,    0,  627,    0,  538,  517,    0,    0,
  630,  874,  515,  513,  539,  514,    0,  516,  630,    0,
    0,  630,    0,  521,  522,  523,  524,  525,  526,  527,
  528,    0,  630,  520,    0,  627,    0,  627,  627,  627,
  630,  632,    0,  630,    0,  539,  556,  556,  539,  556,
    0,  556,  627,  630,  630,  630,  630,  630,  550,  630,
    0,    0,  539,    0,  518,  536,  536,  536,  536,  536,
  536,  536,  536,    0,    0,  630,  630,  696,  696,  696,
  696,  696,  696,  696,  696,    0,    0,  627,    0,  550,
  550,  550,  550,  550,    0,  550,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  550,    0,    0,  630,
  630,  630,  554,    0,    0,  630,    0,    0,    0,    0,
    0,    0,  630,  630,    0,    0,  630,    0,    0,    0,
    0,  630,    0,    0,  632,    0,  632,  632,  630,    0,
    0,    0,  630,  554,  554,  554,  554,  554,    0,  554,
    0,    0,    0,    0,    0,    0,    0,    0,  557,    0,
  554,    0,    0,    0,    0,    0,  632,    0,    0,    0,
  632,    0,  632,    0,    0,    0,    0,  541,  541,  541,
  541,  541,  541,  541,  541,    0,  539,  632,    0,  557,
  557,  557,  557,  557,  632,  557,    0,    0,    0,  632,
    0,    0,    0,    0,    0,  632,  557,    0,    0,  613,
  613,  613,  613,  613,  613,  613,  613,  539,  551,  551,
  539,  551,    0,  551,    0,    0,    0,    0,    0,  549,
    0,    0,    0,  632,  539,  632,  630,    0,  630,  630,
  630,  630,  630,  630,  630,  630,    0,  632,    0,    0,
    0,  628,    0,    0,    0,    0,    0,  632,    0,    0,
  549,  549,  549,  549,  549,  632,  549,    0,  632,    0,
    0,    0,    0,  627,    0,  627,  627,  549,    0,  632,
    0,  539,  628,    0,  628,  628,  628,  632,    0,    0,
  632,  547,  547,  547,  547,  547,  547,  547,  547,  628,
  632,  632,  632,  632,  632,  627,  632,    0,    0,  627,
    0,  627,  539,  555,  555,  539,  555,  553,  555,    0,
    0,    0,  632,  632,    0,    0,  627,    0,    0,  539,
    0,    0,    0,  627,  628,    0,    0,    0,  627,    0,
    0,    0,    0,    0,  627,    0,    0,    0,  553,  553,
  553,  553,  553,    0,  553,    0,  632,  632,  632,    0,
  539,    0,  632,    0,    0,  553,    0,    0,  559,  632,
  632,    0,  627,  632,  627,    0,    0,    0,  632,  545,
    0,    0,    0,    0,    0,  632,  627,    0,    0,  632,
    0,  539,  558,  558,  539,  558,  627,  558,    0,  559,
  559,  559,  559,  559,  627,  559,    0,  627,  539,    0,
  545,    0,  545,  545,  545,    0,  559,    0,  627,  618,
    0,    0,    0,    0,    0,    0,  627,  545,    0,  627,
    0,  537,  537,  537,  537,  537,  537,  537,  537,  627,
  627,  627,  627,  627,    0,  627,  618,    0,    0,    0,
    0,  618,  618,    0,  618,    0,  618,    0,  517,    0,
    0,  627,  627,  693,  691,  709,  692,    0,  694,    0,
    0,    0,  618,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  632,  520,  632,  632,  632,  632,  632,
  632,  632,  632,    0,  343,  627,  627,  627,    0,    0,
    0,  627,    0,  618,    0,    0,    0,    0,  627,  627,
    0,    0,  627,    0,    0,  695,    0,  627,    0,    0,
  628,    0,  628,  628,  627,    0,    0,    0,  627,  619,
  619,  619,  619,  619,  619,  619,  619,    0,    0,  620,
    0,    0,  538,  538,  538,  538,  538,  538,  538,  538,
    0,    0,  628,    0,    0,    0,  628,    0,  628,    0,
    0,  621,    0,    0,    0,    0,  620,    0,    0,    0,
    0,  620,  620,  628,  620,    0,  620,    0,    0,    0,
  628,    0,    0,    0,    0,  628,    0,    0,  621,    0,
    0,  628,  620,  621,  621,    0,  621,    0,  621,    0,
  505,  506,  507,  508,  509,  510,  511,  512,    0,    0,
    0,    0,    0,    0,  621,  622,    0,    0,    0,  628,
    0,  628,  627,  620,  627,  627,  627,  627,  627,  627,
  627,  627,    0,  628,  556,  556,  556,  556,  556,  556,
  556,  556,  622,  628,    0,  621,    0,  622,  622,    0,
  622,  628,  622,    0,  628,    0,    0,    0,    0,    0,
    0,  535,    0,    0,    0,  628,    0,    0,  622,  536,
    0,    0,    0,  628,    0,    0,  628,  930,  550,  550,
  550,  550,  550,  550,  550,  550,  628,  628,  628,  628,
  628,    0,  628,  535,  535,    0,  535,  931,  535,  622,
    0,  536,  536,    0,  536,    0,  536,    0,  628,  628,
    0,    0,    0,    0,  535,    0,    0,  537,    0,    0,
  517,    0,  536,    0,    0,  693,  691,  773,  692,  334,
  694,    0,  554,  554,  554,  554,  554,  554,  554,  554,
    0,    0,  628,  628,  628,  535,  520,    0,  628,  537,
  537,    0,  537,  536,  537,  628,  628,    0,    0,  628,
    0,  538,    0,    0,  628,    0,    0,    0,    0,  335,
  537,  628,    0,    0,    0,  628,  336,  695,  557,  557,
  557,  557,  557,  557,  557,  557,    0,    0,    0,    0,
    0,    0,    0,  538,  538,  932,  538,    0,  538,    0,
    0,  537,    0,    0,    0,    0,  551,  551,  551,  551,
  551,  551,  551,  551,  538,    0,    0,    0,    0,    0,
    0,    0,  337,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  362,    0,    0,    0,    0,    0,
    0,  338,  930,    0,    0,  538,    0,    0,    0,  549,
  549,  549,  549,  549,  549,  549,  549,    0,    0,    0,
  339,    0,  931,    0,    0,    0,    0,    0,    0,  628,
    0,  628,  628,  628,  628,  628,  628,  628,  628,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  219,    0,    0,  220,    0,    0,    0,
    0,  555,  555,  555,  555,  555,  555,  555,  555,    0,
    0,    0,    0,    0,  933,  934,  935,  936,  937,  938,
  939,  940,  941,  942,  943,  944,  945,  946,  947,  948,
  949,  950,  951,  952,  953,  954,  955,  553,  553,  553,
  553,  553,  553,  553,  553,    0,    0,    0,  340,    0,
    0,    0,    0,    0,    0,    0,    0, 1288,    0,  341,
  932,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  342,    0,
  558,  558,  558,  558,  558,  558,  558,  558,  559,  559,
  559,  559,  559,  559,  559,  559,    0,    0,    0,  545,
  545,  545,  545,  545,  545,  545,  545,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  694,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  618,
  618,  618,  618,  618,  618,  618,  618,    0,    0,    0,
    0,  505,  506,  507,  508,  509,  510,  511,  512,  694,
    0,    0,  694,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  694,    0,    0,  933,
  934,  935,  936,  937,  938,  939,  940,  941,  942,  943,
  944,  945,  946,  947,  948,  949,  950,  951,  952,  953,
  954,  955,    0,  362,    0,  362,  362,    0,    0,    0,
    0,  694,  517,    0,    0,    0,    0,  693,  691,  781,
  692,    0,  694,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  362,    0,    0,  520,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  362,    0,    0,  620,
  620,  620,  620,  620,  620,  620,  620,  688,  362,  695,
    0,    0,    0,    0,  362,    0,  361,    0,    0,    0,
    0,  621,  621,  621,  621,  621,  621,  621,  621,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  688,    0,
    0,  688,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  688,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  362,    0,    0,    0,
    0,    0,    0,    0,    0,  622,  622,  622,  622,  622,
  622,  622,  622,    0,    0,    0,    0,    0,  362,    0,
  688,    0,    0,    0,    0,    0,  362,    0,    0,  362,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  362,
  362,  362,  362,  362,    0,  362,    0,    0,    0,    0,
    0,  535,  535,  535,  535,  535,  535,  535,  535,  536,
  536,  536,  536,  536,  536,  536,  536,  694,    0,  694,
  694,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  505,  506,  507,  508,  509,  510,  511,
  512,    0,  689,    0,    0,    0,  362,    0,    0,  694,
    0,  362,    0,  694,    0,  694,    0,  537,  537,  537,
  537,  537,  537,  537,  537,    0,    0,    0,    0,    0,
  694,    0,    0,  689,  362,    0,  689,  694,    0,    0,
    0,    0,  694,    0,    0,    0,    0,    0,  694,    0,
  689,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  538,  538,  538,  538,  538,  538,  538,  538,    0,
    0,    0,    0,    0,    0,    0,  694,    0,  694,    0,
    0,    0,    0,    0,    0,  689,    0,    0,    0,    0,
  694,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  694,    0,    0,    0,    0,    0,    0,    0,  694,    0,
    0,  694,    0,    0,    0,    0,  688,    0,  688,  688,
    0,    0,  694,    0,    0,  361,    0,  361,  361,    0,
  694,    0,  362,  694,    0,    0,    0,    0,    0,    0,
    0,  690,    0,  694,  694,  694,  694,  694,  688,  694,
    0,    0,  688,    0,  688,    0,    0,  361,    0,    0,
    0,    0,    0,    0,    0,  694,  694,    0,    0,  688,
    0,    0,  690,    0,    0,  690,  688,    0,  361,    0,
    0,  688,    0,    0,    0,    0,    0,  688,    0,  690,
  361,    0,    0,    0,    0,    0,  361,    0,    0,  694,
  694,  694,    0,    0,    0,  694,    0,    0,    0,    0,
    0,    0,  694,  694,    0,  688,  694,  688,    0,    0,
    0,  694,    0,    0,  690,    0,    0,    0,  694,  688,
    0,    0,  694,    0,    0,    0,    0,    0,    0,  688,
    0,    0,    0,    0,    0,    0,    0,  688,  361,    0,
  688,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  688,    0,    0,    0,    0,    0,    0,    0,  688,
  361,  689,  688,  689,  689,    0,    0,    0,  361,    0,
    0,  361,  688,  688,  688,  688,  688,  356,  688,    0,
    0,  361,  361,  361,  361,  361,    0,  361,    0,    0,
    0,    0,    0,  689,  688,  688,    0,  689,    0,  689,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  689,    0,  694,    0,  694,  694,
    0,  689,    0,    0,    0,  691,  689,    0,  688,  688,
  688,    0,  689,    0,  688,    0,    0,    0,  361,    0,
    0,  688,  688,  361,    0,  688,    0,    0,    0,    0,
  688,    0,    0,  403,    0,    0,  691,  688,    0,  691,
  689,  688,  689,    0,    0,    0,  361,    0,    0,    0,
    0,    0,    0,  691,  689,  505,  506,  507,  508,  509,
  510,  511,  512,    0,  689,    0,    0,    0,    0,    0,
    0,  988,  689,  989,  990,  689,    0,    0,    0,    0,
  690,    0,  690,  690,    0,    0,  689,    0,  691,    0,
    0,    0,    0,    0,  689,    0,    0,  689,    0,    0,
    0,    0,    0,  991,    0,    0,    0,  689,  689,  689,
  689,  689,  690,  689,    0,    0,  690,    0,  690,    0,
    0,    0,    0,    0,  992,    0,    0,    0,    0,  689,
  689,    0,    0,  690,    0,  688,  993,  688,  688,    0,
  690,    0,  994,    0,  361,  690,    0,    0,    0,    0,
    0,  690,  692,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  689,  689,  689,    0,    0,    0,  689,
    0,    0,    0,    0,    0,    0,  689,  689,    0,  690,
  689,  690,    0,  692,    0,  689,  692,    0,    0,    0,
    0,    0,  689,  690,  995,    0,  689,    0,    0,    0,
  692,    0,    0,  690,    0,    0,    0,    0,    0,    0,
    0,  690,    0,    0,  690,    0,  996,    0,    0,    0,
    0,    0,    0,    0,  997,  690,  356,  998,  356,  356,
    0,    0,    0,  690,    0,  692,  690,  219,  999, 1000,
  220, 1001,    0, 1002,    0,    0,  690,  690,  690,  690,
  690,    0,  690,    0,    0,    0,  517,    0,  356,    0,
    0,  693,  691,  787,  692,    0,  694,    0,  690,  690,
    0,    0,    0,    0,  691,    0,  691,  691,    0,  356,
    0,    0,  520,    0,    0,    0,    0,    0,    0,    0,
  689,  356,  689,  689, 1003,    0,    0,  356,  693, 1004,
    0,    0,  690,  690,  690,    0,  691,    0,  690,    0,
  691,    0,  691,  695,    0,  690,  690,    0,    0,  690,
    0,    0, 1005,    0,  690,    0,    0,  691,    0,  693,
    0,  690,  693,    0,  691,  690,    0,    0,  403,  691,
  403,    0,    0,    0,    0,  691,  693,    0,    0,  356,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  403,    0,    0,    0,    0,  403,    0,    0,
    0,  356,    0,  691,    0,  691,    0,    0,  517,  356,
    0,  693,  356,  693,  691,  833,  692,  691,  694,    0,
    0,    0,  356,  356,  356,  356,  356,  691,  356,    0,
    0,  403,    0,  403,  520,  691,    0,    0,  691,    0,
    0,    0,    0,    0,    0,  403,    0,    0,    0,  691,
 1006,  692,    0,  692,  692,    0,    0,  691,    0,  690,
  691,  690,  690,  403,    0,  695,  403,    0,    0,    0,
  691,  691,  691,  691,  691,  695,  691,  403,    0,  356,
    0,    0,    0,  692,  356,    0,    0,  692,    0,  692,
    0,    0,  691,  691,    0,    0,    0,    0,  403,    0,
    0,  403,  403,    0,  692,    0,  695,  356,    0,  695,
    0,  692,    0,    0,    0,    0,  692,    0,    0,    0,
  403,  403,  692,  695,    0,    0,  691,  691,  691,    0,
    0,    0,  691,    0,    0,    0,    0,    0,    0,  691,
  691,    0,    0,  691,    0,    0,    0,    0,  691,    0,
  692,    0,  692,    0,  403,  691,  403,    0,  695,  691,
    0,    0,    0,    0,  692,    0,    0,  403,  403,    0,
    0,  403,    0,    0,  692,    0,    0,    0,    0,    0,
    0,    0,  692,  403,    0,  692,    0,  403,    0,    0,
    0,    0,    0,    0,    0,    0,  692,  693,    0,  693,
  693,    0,    0,    0,  692,  356,    0,  692,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  692,  692,  692,
  692,  692,    0,  692,    0,    0,    0,    0,    0,  693,
  687,    0,    0,  693,    0,  693,    0,    0,    0,  692,
  692,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  693,    0,    0,  691,    0,  691,  691,  693,    0,    0,
    0,  687,  693,    0,  687,    0,    0,    0,  693,    0,
    0,    0,    0,  692,  692,  692,    0,    0,  687,  692,
    0,  403,    0,    0,    0,    0,  692,  692,    0,    0,
  692,    0,    0,    0,    0,  692,  693,    0,  693,    0,
    0,    0,  692,    0,    0,    0,  692,    0,    0,    0,
  693,    0,    0,  687,  404,    0,    0,    0,    0,    0,
  693,    0,    0,    0,    0,    0,    0,    0,  693,    0,
    0,  693,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  693,    0,  695,    0,  695,  695,    0,    0,
  693,  517,    0,  693,    0,    0,  693,  691,  838,  692,
    0,  694,    0,  693,  693,  693,  693,  693,    0,  693,
    0,    0,    0,    0,    0,    0,  695,  520,    0,    0,
  695,    0,  695,    0,    0,  693,  693,    0,    0,    0,
  357,    0,    0,    0,    0,    0,    0,  695,    0,    0,
  692,    0,  692,  692,  695,    0,    0,    0,  695,  695,
    0,    0,    0,    0,    0,  695,    0,    0,    0,  693,
  693,  693,    0,    0,    0,  693,    0,    0,    0,    0,
    0,    0,  693,  693,    0,    0,  693,    0,    0,    0,
    0,  693,    0,  695,    0,  695,    0,    0,  693,    0,
    0,    0,  693,    0,    0,    0,    0,  695,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  695,    0,    0,
    0,    0,    0,    0,    0,  695,  358,    0,  695,  505,
  506,  507,  508,  509,  510,  511,  512,    0,    0,  695,
    0,    0,    0,    0,    0,    0,    0,  695,    0,  687,
  695,  687,  687,    0,    0,    0,    0,    0,    0,    0,
  695,  695,  695,  695,  695,    0,  695,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  687,  695,  695,  517,  687,    0,  687,    0,  693,
  691,  854,  692,    0,  694,    0,  693,    0,  693,  693,
    0,    0,  687,    0,    0,    0,    0,    0,    0,  687,
  520,    0,    0,    0,  687,    0,  695,  695,  695,    0,
  687,    0,  695,    0,    0,    0,    0,    0,    0,  695,
  695,    0,    0,  695,  359,    0,    0,    0,  695,    0,
    0,  695,    0,    0,    0,  695,    0,    0,  687,  695,
  687,  505,  506,  507,  508,  509,  510,  511,  512,    0,
    0,    0,  687,    0,    0,    0,    0,    0,    0,  404,
  383,  404,  687,    0,    0,    0,    0,    0,    0,    0,
  687,    0,  517,  687,    0,    0,    0,  693,  691,  862,
  692,    0,  694,  404,  687,    0,    0,    0,  404,    0,
    0,    0,  687,    0,    0,  687,    0,    0,  520,  357,
    0,  357,  357,    0,    0,  687,  687,  687,  687,  687,
    0,  687,    0,    0,    0,  517,    0,    0,    0, 1035,
  515,  513,  404,  514,  404,  516,    0,  687,  687,  695,
    0,  357,    0,  695,  517,  695,  404,    0, 1037,  515,
  513,  520,  514,  517,  516,    0,    0, 1039,  515,  513,
    0,  514,  357,  516,  404,    0,    0,  404,    0,    0,
  520,  687,  687,  687,  357,    0,    0,  687,  404,  520,
  357,    0,  518,    0,  687,  687,  517,    0,  687,    0,
 1041,  515,  513,  687,  514,  358,  516,  358,  358,  404,
  687,  518,  404,  404,  687,    0,    0,    0,    0,    0,
  518,    0,  520,    0,    0,    0,    0,    0,    0,    0,
    0,  404,  404,  517,    0,    0,    0,  358,  515,  513,
 1043,  514,  357,  516,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  518,    0,    0,    0,    0,  358,  520,
    0,    0,    0,    0,  357,  404,    0,  404,    0,    0,
  358,    0,  357,    0,    0,  357,  358,    0,  404,  404,
    0,    0,  404,    0,    0,  357,  357,  357,  357,  357,
  518,  357,    0,    0,  404,    0,  517,    0,  404,    0,
 1045,  515,  513,    0,  514,    0,  516,    0,  687,    0,
    0,    0,    0,  359,    0,  359,  359,    0,    0,    0,
    0,    0,  520,    0,    0,    0,    0,    0,  358,  517,
    0,    0,    0, 1047,  515,  513,    0,  514,    0,  516,
    0,    0,  357,    0,    0,  359,    0,  357,    0,  383,
  358,  383,  383,  518,    0,  520,    0,    0,  358,  517,
    0,  358,    0, 1049,  515,  513,  359,  514,    0,  516,
  357,  358,  358,  358,  358,  358,    0,  358,  359,    0,
    0,  383,    0,    0,  359,  520,  518,    0,    0,  517,
    0,    0,  404, 1051,  515,  513,    0,  514,    0,  516,
    0,    0,  383,    0,  505,  506,  507,  508,  509,  510,
  511,  512,    0,  517,  383,  520,  518, 1053,  515,  513,
  383,  514,    0,  516,    0,    0,    0,    0,  358,    0,
    0,    0,    0,  358,    0,  517,  359,    0,    0,  520,
  515,  513, 1057,  514,    0,  516,  518,  517,    0,    0,
    0, 1055,  515,  513,    0,  514,  358,  516,  359,    0,
    0,  520,    0,    0,    0,    0,  359,    0,  357,  359,
  518,    0,  383,  520,    0,    0,    0,    0,    0,  359,
  359,  359,  359,  359,    0,  359,    0,    0,    0,    0,
    0,    0,  518,    0,  383,    0,    0,    0,    0,    0,
    0,    0,  383,  517,  518,  383,    0, 1060,  515,  513,
    0,  514,    0,  516,    0,  383,  383,  383,  383,  383,
    0,  383,  517,    0,    0,    0, 1062,  515,  513,  520,
  514,    0,  516,    0,    0,    0,  359,    0,    0,  517,
    0,  359,    0,    0,  515,  513, 1064,  514,  520,  516,
    0,    0,    0,    0,  358,    0,    0,    0,    0,    0,
  518,    0,    0,    0,  359,  520,    0,    0,    0,    0,
    0,    0,  383,    0,    0,    0,  517,  383,    0,  518,
 1067,  515,  513,    0,  514,    0,  516,  505,  506,  507,
  508,  509,  510,  511,  512,    0,  518,    0,    0,  517,
  383,    0,  520, 1069,  515,  513,    0,  514,  517,  516,
    0,    0, 1071,  515,  513,    0,  514,    0,  516,    0,
    0,  517,    0,    0,    0,  520,  515,  513, 1073,  514,
    0,  516,    0,  518,  520,    0,    0,    0,  517,    0,
    0,    0,    0,  515,  513, 1075,  514,  520,  516,    0,
    0,    0,    0,  517,    0,    0,  518,    0,  515,  513,
 1077,  514,  359,  516,  520,  518,    0,  517,    0,    0,
    0,    0,  515,  513, 1079,  514,    0,  516,  518,  520,
    0,    0,    0,    0,    0,  505,  506,  507,  508,  509,
  510,  511,  512,  520,    0,  518,    0,    0,  383,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  518,  517,    0,    0,    0, 1081,  515,  513,    0,  514,
    0,  516,    0,    0,  518,    0,    0,    0,  505,  506,
  507,  508,  509,  510,  511,  512,    0,  520,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  505,  506,  507,
  508,  509,  510,  511,  512,    0,  505,  506,  507,  508,
  509,  510,  511,  512,    0,    0,    0,    0,  518,    0,
    0,    0,    0,    0,    0,    0,    0,  517,    0,    0,
    0, 1083,  515,  513,    0,  514,    0,  516,    0,  505,
  506,  507,  508,  509,  510,  511,  512,    0,    0,  517,
    0,    0,    0,  520,  515,  513, 1085,  514,    0,  516,
  517,    0,    0,    0, 1087,  515,  513,    0,  514,    0,
  516,    0,    0,    0,    0,  520,  505,  506,  507,  508,
  509,  510,  511,  512,  518,    0,  520,    0,    0,    0,
  517,    0,    0,    0, 1089,  515,  513,    0,  514,  517,
  516,    0,    0, 1091,  515,  513,  518,  514,    0,  516,
    0,    0,    0,    0,    0,    0,  520,  518,    0,    0,
    0,    0,    0,  517,    0,  520,    0, 1093,  515,  513,
    0,  514,    0,  516,    0,    0,    0,    0,    0,  505,
  506,  507,  508,  509,  510,  511,  512,  518,    0,  520,
    0,    0,    0,    0,    0,  517,  518,    0,    0,  874,
  693,  691,    0,  692,    0,  694,    0,    0,    0,    0,
    0,    0,  505,  506,  507,  508,  509,  510,  511,  512,
  518,  520,    0,    0,  517,    0,    0,    0,    0,  693,
  691, 1185,  692,    0,  694,    0,    0,    0,    0,    0,
    0,    0,  505,  506,  507,  508,  509,  510,  511,  512,
  520,    0,  695,    0,  517,    0,    0,    0,    0,  693,
  691, 1186,  692,    0,  694,    0,    0,    0,    0,    0,
    0,    0,  505,  506,  507,  508,  509,  510,  511,  512,
  520,  695,  517,    0,    0,    0,    0,  693,  691, 1190,
  692,    0,  694,    0,    0,    0,  505,  506,  507,  508,
  509,  510,  511,  512,    0,    0,    0,    0,  520,    0,
    0,  695,    0,    0,    0,    0,    0,    0,  505,  506,
  507,  508,  509,  510,  511,  512,    0,    0,    0,    0,
  505,  506,  507,  508,  509,  510,  511,  512,  517,  695,
    0,    0,    0,  693,  691, 1195,  692,  517,  694,    0,
    0,    0,  693,  691, 1204,  692,    0,  694,    0,    0,
    0,    0,    0,    0,  520,    0,    0,    0,    0,    0,
    0,    0,    0,  520,  517,    0,    0,    0,    0,  693,
  691,    0,  692,    0,  694,    0,  505,  506,  507,  508,
  509,  510,  511,  512,    0,  695,    0,    0,    0,    0,
  520,    0,    0,    0,  695,  505,  506,  507,  508,  509,
  510,  511,  512,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  505,  506,  507,  508,  509,  510,  511,  512,
 1206,  695,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  517,    0,    0,    0,    0,  693,  691,
    0,  692,    0,  694,    0,    0,    0,    0,    0,  505,
  506,  507,  508,  509,  510,  511,  512,    0,    0,  520,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  505,  506,  507,  508,  509,  510,  511,  512,
    0,  505,  506,  507,  508,  509,  510,  511,  512, 1211,
  695,    0,    0,    0,  505,  506,  507,  508,  509,  510,
  511,  512,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  505,  506,  507,  508,  509,  510,  511,  512,    0,
    0,    0,    0,    0,    0,    0,  505,  506,  507,  508,
  509,  510,  511,  512,    0,    0,    0,    0,    0,    0,
  505,  506,  507,  508,  509,  510,  511,  512,  517,    0,
    0,    0,    0,  693,  691, 1234,  692,  517,  694,    0,
    0, 1334,  693,  691,    0,  692,    0,  694,    0,    0,
    0,  517,    0,    0,  520, 1037,  693,  691,    0,  692,
    0,  694,    0,  520,  505,  506,  507,  508,  509,  510,
  511,  512,    0,    0,    0,    0,    0,  520,    0,    0,
    0,    0,    0,  517,    0,  695,    0, 1039,  693,  691,
    0,  692,  517,  694,  695,    0, 1041,  693,  691,    0,
  692,    0,  694,    0,    0,    0,    0,    0,  695,  520,
    0,    0,    0,    0,    0,  517,    0,    0,  520,    0,
  693,  691, 1043,  692,    0,  694,    0,    0,    0,    0,
  505,  506,  507,  508,  509,  510,  511,  512,    0,    0,
  695,  520,    0,    0,    0,    0,    0,    0,    0,  695,
    0,    0,  505,  506,  507,  508,  509,  510,  511,  512,
    0,    0,    0,  505,  506,  507,  508,  509,  510,  511,
  512,    0,  695,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  505,  506,  507,  508,  509,  510,  511,
  512,    0,  505,  506,  507,  508,  509,  510,  511,  512,
  517,    0,    0,    0, 1045,  693,  691,    0,  692,    0,
  694,    0,    0,    0,    0,    0,  505,  506,  507,  508,
  509,  510,  511,  512,    0,    0,  520,    0,    0,    0,
  517,    0,    0,    0, 1047,  693,  691,    0,  692,    0,
  694,    0,    0,    0,    0,    0,    0,    0,  505,  506,
  507,  508,  509,  510,  511,  512,  520,  695,    0,  517,
    0,    0,    0, 1049,  693,  691,    0,  692,    0,  694,
    0,    0,    0,    0,    0,    0,    0,  505,  506,  507,
  508,  509,  510,  511,  512,  520,    0,  695,    0,  517,
    0,    0,    0, 1051,  693,  691,    0,  692,    0,  694,
    0,    0,    0,    0,    0,    0,    0,  505,  506,  507,
  508,  509,  510,  511,  512,  520,  695,  517,    0,    0,
    0, 1053,  693,  691,    0,  692,    0,  694,    0,    0,
    0,    0,    0,    0,    0,  505,  506,  507,  508,  509,
  510,  511,  512,  520,    0,    0,  695,    0,    0,    0,
    0,  517,    0,    0,    0, 1055,  693,  691,    0,  692,
  517,  694,    0,    0,    0,  693,  691, 1335,  692,    0,
  694,    0,    0,    0,  695,    0,    0,  520,    0,    0,
    0,    0,    0,    0,    0,    0,  520,    0,    0,    0,
    0,  505,  506,  507,  508,  509,  510,  511,  512,    0,
  505,  506,  507,  508,  509,  510,  511,  512,  695,    0,
  517,    0,    0,    0, 1060,  693,  691,  695,  692,    0,
  694,    0,    0,    0,    0,    0,    0,  505,  506,  507,
  508,  509,  510,  511,  512,  517,  520,    0,    0, 1062,
  693,  691,    0,  692,    0,  694,    0,  517,    0,    0,
    0,    0,  693,  691, 1336,  692,    0,  694,  517,    0,
    0,  520, 1067,  693,  691,    0,  692,  695,  694,  517,
    0,    0,    0,  520,  693,  691, 1073,  692,    0,  694,
    0,  517,    0,    0,  520, 1069,  693,  691,    0,  692,
    0,  694,  695,    0,    0,  520,  505,  506,  507,  508,
  509,  510,  511,  512,  695,    0,  517,  520,    0,    0,
 1071,  693,  691,    0,  692,  695,  694,  517,    0,    0,
    0,    0,  693,  691, 1075,  692,  695,  694,    0,  517,
    0,    0,  520,    0,  693,  691, 1077,  692,  695,  694,
  517,    0,    0,  520,    0,  693,  691, 1079,  692,    0,
  694,    0,  517,    0,    0,  520, 1081,  693,  691,    0,
  692,    0,  694,  695,    0,    0,  520,    0,    0,    0,
    0,    0,    0,    0,  695,  517,    0,    0,  520, 1083,
  693,  691,    0,  692,    0,  694,  695,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  695,    0,    0,
    0,  520,    0,    0,    0,    0,    0,    0,    0,  695,
    0,  505,  506,  507,  508,  509,  510,  511,  512,    0,
  505,  506,  507,  508,  509,  510,  511,  512,    0,    0,
    0,    0,  695,    0,  505,  506,  507,  508,  509,  510,
  511,  512,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  505,  506,  507,  508,
  509,  510,  511,  512,    0,  505,  506,  507,  508,  509,
  510,  511,  512,  517,    0,    0,    0,    0,  693,  691,
 1338,  692,    0,  694,    0,    0,    0,    0,  505,  506,
  507,  508,  509,  510,  511,  512,  517,    0,    0,  520,
 1087,  693,  691,    0,  692,  517,  694,    0,    0, 1089,
  693,  691,    0,  692,    0,  694,    0,    0,    0,  517,
    0,    0,  520, 1091,  693,  691,    0,  692,    0,  694,
  695,  520,    0,    0,  517,    0,    0,    0, 1093,  693,
  691,    0,  692,    0,  694,  520,  517,    0,    0,    0,
    0,  693,  691,  695,  692,    0,  694,    0,    0,    0,
  520,    0,  695,    0,    0,    0,    0,    0,    0,  517,
    0,    0,  520, 1412,  693,  691,  695,  692,    0,  694,
    0,    0,    0,  505,  506,  507,  508,  509,  510,  511,
  512,  695,    0,    0,    0,  520,    0,    0,    0,  517,
    0,    0, 1341,  695,  693,  691, 1342,  692,    0,  694,
    0,    0,    0,  505,  506,  507,  508,  509,  510,  511,
  512,    0,    0,    0,  517,  520,  695,    0,    0,  693,
  691,    0,  692,    0,  694,    0,    0,    0,    0,    0,
    0,    0,  505,  506,  507,  508,  509,  510,  511,  512,
  520,    0,    0,    0,    0,    0,  695,  517,    0,    0,
    0,    0,  693,  691, 1349,  692,    0,  694,    0,    0,
    0,    0,  505,  506,  507,  508,  509,  510,  511,  512,
 1343,  695,    0,  520,    0,  517,    0,    0,    0,    0,
  693,  691, 1359,  692,    0,  694,    0,    0,    0,    0,
  505,  506,  507,  508,  509,  510,  511,  512,    0,    0,
    0,  520,    0,    0,  695,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  505,  506,  507,  508,  509,  510,
  511,  512,  695,  505,  506,  507,  508,  509,  510,  511,
  512,  517,    0,    0,    0,    0,  693,  691, 1377,  692,
  517,  694,    0,    0,    0,  693,  691, 1378,  692,    0,
  694,    0,    0,    0,    0,    0,    0,  520,    0,    0,
    0,    0,    0,    0,    0,    0,  520,    0,    0,    0,
    0,    0,    0,  505,  506,  507,  508,  509,  510,  511,
  512,    0,    0,    0,    0,    0,    0,    0,  695,    0,
    0,    0,    0,    0,    0,    0,    0,  695,  505,  506,
  507,  508,  509,  510,  511,  512,    0,    0,    0,    0,
  505,  506,  507,  508,  509,  510,  511,  512,    0,    0,
    0,  505,  506,  507,  508,  509,  510,  511,  512,    0,
    0,    0,  505,  506,  507,  508,  509,  510,  511,  512,
    0,    0,    0,    0,  505,  506,  507,  508,  509,  510,
  511,  512,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  505,
  506,  507,  508,  509,  510,  511,  512,    0,    0,    0,
  505,  506,  507,  508,  509,  510,  511,  512,    0,    0,
    0,    0,  505,  506,  507,  508,  509,  510,  511,  512,
    0,    0,    0,  505,  506,  507,  508,  509,  510,  511,
  512,    0,    0,    0,    0,  505,  506,  507,  508,  509,
  510,  511,  512,  517,    0,    0,    0,    0,  693,  691,
 1379,  692,    0,  694,    0,    0,    0,    0,  505,  506,
  507,  508,  509,  510,  511,  512,  517,    0,    0,  520,
 1414,  515,  513,    0,  514,  517,  516,    0,    0, 1416,
  515,  513,    0,  514,    0,  516,    0,    0,  517,    0,
    0,    0,  520,  693,  691, 1420,  692,    0,  694,  517,
  695,  520,    0,    0,  693,  691, 1421,  692,    0,  694,
    0,    0,    0,    0,  520,    0,    0,    0,    0,    0,
    0,    0,    0,  518,    0,  520,    0,    0,    0,  517,
    0,    0,  518, 1422,  693,  691,    0,  692,    0,  694,
    0,    0,    0,    0,    0,  695,    0,    0,    0,    0,
    0,    0,    0,  517,    0,  520,  695, 1424,  693,  691,
    0,  692,    0,  694,    0,    0,  505,  506,  507,  508,
  509,  510,  511,  512,    0,    0,    0,    0,    0,  520,
    0,    0,    0,    0,    0,    0,  695,    0,    0,  505,
  506,  507,  508,  509,  510,  511,  512,    0,  505,  506,
  507,  508,  509,  510,  511,  512,    0,    0,    0,    0,
  695,    0,  505,  506,  507,  508,  509,  510,  511,  512,
    0,    0,    0,    0,    0,    0,    0,  505,  506,  507,
  508,  509,  510,  511,  512,    0,    0,    0,    0,  505,
  506,  507,  508,  509,  510,  511,  512,  517,    0,    0,
    0, 1426,  693,  691,    0,  692,    0,  694,    0,    0,
    0,    0,  505,  506,  507,  508,  509,  510,  511,  512,
    0,    0,    0,  520,  517,    0,    0,    0, 1428,  515,
  513,    0,  514,    0,  516,    0,    0,    0,    0,    0,
    0,    0,  505,  506,  507,  508,  509,  510,  511,  512,
  520,  517,    0,    0,  695, 1430,  515,  513,    0,  514,
    0,  516,    0,    0,    0,    0,    0,  505,  506,  507,
  508,  509,  510,  511,  512,    0,    0,  520,    0,    0,
    0,  518,    0,  517,    0,    0,    0,    0,  693,  691,
 1445,  692,    0,  694,    0,    0,    0,    0,    0,    0,
  505,  506,  507,  508,  509,  510,  511,  512,  518,  520,
  517,    0,    0,    0,    0,  693,  691, 1449,  692,    0,
  694,    0,    0,    0,    0,    0,    0,    0,  505,  506,
  507,  508,  509,  510,  511,  512,  520,    0,    0,    0,
  695,    0,    0,    0,    0,  517,    0,    0,    0,    0,
  693,  691, 1451,  692,  517,  694,    0,    0,    0,  693,
  691, 1454,  692,    0,  694,    0,    0,  695,    0,    0,
    0,  520,    0,    0,    0,    0,    0,    0,    0,    0,
  520,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  505,  506,  507,  508,  509,  510,
  511,  512,  695,  505,  506,  507,  508,  509,  510,  511,
  512,  695,  517,    0,    0,    0,    0,  693,  691,    0,
  692,  517,  694,    0,    0,    0,  693,  691, 1456,  692,
    0,  694,    0,    0,  517,    0,    0,    0,  520,  693,
  691, 1461,  692,    0,  694,  517,    0,  520,    0,    0,
  693,  691, 1462,  692,    0,  694,    0,  517,    0,    0,
  520, 1471,  693,  691,    0,  692,    0,  694, 1455,  695,
    0,  520,  531,  529, 1058,  530,    0,  532,  695,    0,
  517,    0,    0,  520, 1473,  693,  691,    0,  692,  517,
  694,  695,    0,  535,  693,  691,    0,  692,    0,  694,
    0,    0,  695,  517,    0,    0,  520,    0,  693,  691,
 1476,  692,  517,  694,  695,  520,    0,  693,  691, 1486,
  692,    0,  694,    0,  533,  517,    0,    0,    0,  520,
  693,  691, 1492,  692,    0,  694,    0,  695,  520,    0,
    0,    0,  517,    0,    0, 1475,  695,  693,  691, 1493,
  692,  520,  694,    0,    0, 1036,  531,  529,    0,  530,
  695,  532,    0,    0,    0,    0,    0,    0,  520,  695,
  517,    0,    0,    0, 1496,  693,  691,  535,  692,    0,
  694,    0,  695,    0,    0,    0,  505,  506,  507,  508,
  509,  510,  511,  512,    0,    0,  520,    0,    0,  695,
    0,    0,    0,    0,    0,    0,    0,    0,  533,  505,
  506,  507,  508,  509,  510,  511,  512,    0,  505,  506,
  507,  508,  509,  510,  511,  512,    0,  695,    0,    0,
    0,  505,  506,  507,  508,  509,  510,  511,  512,    0,
    0,    0,  505,  506,  507,  508,  509,  510,  511,  512,
    0,    0,    0,    0,  517,    0,    0,    0, 1497,  693,
  691,    0,  692,    0,  694,    0,    0,    0,    0,    0,
    0,    0,  505,  506,  507,  508,  509,  510,  511,  512,
  520,  517,    0,    0,    0,    0,  693,  691,    0,  692,
    0,  694,    0,    0,    0,    0,  505,  506,  507,  508,
  509,  510,  511,  512,    0,    0,    0,  520,  517,    0,
    0,  695,    0,  693,  691, 1503,  692,  517,  694,    0,
    0,    0,  693,  691, 1506,  692,    0,  694,    0,    0,
    0,    0,    0,    0,  520,    0,    0, 1502,  695,    0,
    0,  517,    0,  520,    0,    0,  693,  691, 1508,  692,
  517,  694,    0,    0,    0,  693,  691, 1511,  692,    0,
  694,    0,    0,    0,    0,  695,    0,  520,    0,    0,
    0,    0,    0,  517,  695,    0,  520,    0,  693,  691,
    0,  692,    0,  694,    0,    0,    0,    0,    0,    0,
  505,  506,  507,  508,  509,  510,  511,  512,  695,  520,
  517,    0,    0,    0,    0,  693,  691,  695,  692,    0,
  694,    0,    0,    0,    0,    0,    0,  505,  506,  507,
  508,  509,  510,  511,  512,    0,  520,  517,    0, 1512,
  695,    0,  693,  691, 1523,  692,    0,  694,    0,    0,
    0,    0,    0,    0,  505,  506,  507,  508,  509,  510,
  511,  512,    0,  520,    0,    0,    0,  695,    0,  517,
    0,    0,    0,    0,  693,  691, 1525,  692,    0,  694,
    0,    0,    0,    0,    0,    0,  505,  506,  507,  508,
  509,  510,  511,  512,  695,  520,    0,    0,    0,  517,
    0,    0,    0,    0,  693,  691, 1527,  692,    0,  694,
    0,    0,    0,  505,  506,  507,  508,  509,  510,  511,
  512,    0,    0,    0,    0,  520,  695,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  505,  506,
  507,  508,  509,  510,  511,  512,  695,  505,  506,  507,
  508,  509,  510,  511,  512,    0,  517,    0,    0,    0,
    0,  693,  691,    0,  692,  517,  694,    0,    0,    0,
  515,  513,    0,  514,    0,  516,    0,    0,    0,    0,
    0,    0,  520,    0,    0,    0,    0,    0,    0,    0,
    0,  520,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  505,  506,  507,  508,  509,
  510,  511,  512,  695,  505,  506,  507,  508,  509,  510,
  511,  512,  518,    0,    0,    0,    0,  505,  506,  507,
  508,  509,  510,  511,  512,    0,    0,    0,  505,  506,
  507,  508,  509,  510,  511,  512,    0,    0,    0,    0,
  505,  506,  507,  508,  509,  510,  511,  512,    0,    0,
  521,  522,  523,  524,  525,  526,  527,  528,    0,    0,
    0,    0,    0,  505,  506,  507,  508,  509,  510,  511,
  512,    0,  505,  506,  507,  508,  509,  510,  511,  512,
    0,    0,    0,    0,    0,    0,  505,  506,  507,  508,
  509,  510,  511,  512,    0,  505,  506,  507,  508,  509,
  510,  511,  512,    0,    0,    0,    0,    0,  505,  506,
  507,  508,  509,  510,  511,  512,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  505,  506,  507,  508,  509,
  510,  511,  512,    0,  521,  522,  523,  524,  525,  526,
  527,  528,  531,  529, 1065,  530,    0,  532,    0,    0,
    0,    0,    0,  505,  506,  507,  508,  509,  510,  511,
  512,    0,    0,  535,    0, 1038,  531,  529,    0,  530,
    0,  532,    0, 1040,  531,  529,    0,  530,    0,  532,
    0,    0,    0,    0,    0,    0,    0,  535,    0,    0,
    0,    0,    0,    0,  533,  535,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  533,    0,
    0,    0,    0,    0,    0,    0,  533,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  505,  506,  507,
  508,  509,  510,  511,  512,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1042,  531,  529,    0,
  530,    0,  532,    0,  505,  506,  507,  508,  509,  510,
  511,  512,    0,    0,    0,    0, 1520,    0,  535,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  505,  506,  507,  508,  509,  510,  511,  512,    0,
  505,  506,  507,  508,  509,  510,  511,  512,    0,  533,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  505,  506,  507,  508,  509,  510,
  511,  512,    0,  505,  506,  507,  508,  509,  510,  511,
  512,  153,    0, 1046,  531,  529,  151,  530,    0,  532,
    0,    0,    0,    0,    0,    0,  505,  506,  507,  508,
  509,  510,  511,  512,    0,  535,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  505,  506,  507,  508,  509,  510,  511,
  512,    0,    0,    0,    0,    0,  533,    0,    0, 1048,
  531,  529,    0,  530,    0,  532,    0,    0,    0,    0,
  505,  506,  507,  508,  509,  510,  511,  512, 1050,  531,
  529,  535,  530,    0,  532,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  535,    0,  505,  506,  507,  508,  509,  510,  511,  512,
    0,    0,  533,    0,    0,    0,    0,    0, 1052,  531,
  529,    0,  530,    0,  532,    0,    0,    0,    0,    0,
    0,  533,  505,  506,  507,  508,  509,  510,  511,  512,
  535,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1054,  531,  529,    0,  530,    0,
  532,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  533,    0,    0,    0,    0,  535,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  505,
  506,  507,  508,  509,  510,  511,  512,  533,  505,  506,
  507,  508,  509,  510,  511,  512,    0,    1,    2,    3,
    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
   14,   15,   16,   17,   18,   19,   20,   21,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
   34,   35,   36,   37,   38,   39,    0,   40,   41,   42,
   43,   44,   45,   46,   47,   48,   49,    0,    0,   50,
   51,    0,    0,    0,   52,   53,    0,    0,    0,    0,
    0,   54,   55,    0,    0,    0,   56,   57,   58,    0,
    0,   59,    0,    0,    0,   60,    0,   61,    0,    0,
    0,    0,   62,    0,   63,   64,    0,   65,   66,    0,
    0,   67,    0,   68,   69,   70,    0,   71,    0,    0,
    0,    0,    0,   72,    0,    0,    0,    0,   73,    0,
    0,   74,  225,    0,    0,    0,   75,   76,    0,    0,
    0,    0,   77,   78,   79,    0,   80,   81,    0,    0,
   82,    0,    0,    0,    0,    0,    0,    0,   83,    0,
    0,    0,   84,    0,    0,    0,    0,    0,    0,   85,
   86,    0,   87,    0,    0,    0,    0,    0,   88,    0,
    0,    0,   89,   90,  296,   91,   92,   93,   94,  294,
  521,  522,  523,  524,  525,  526,  527,  528,   95,   96,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   97,  521,  522,  523,  524,  525,  526,
  527,  528,  521,  522,  523,  524,  525,  526,  527,  528,
   98,   99,    0,    0,    0,    0,  100,  101,  102,    0,
  103,  104,  105,  106,    0,  226,    0,    0,    0,    0,
  107,  108,  109,  110,  111,    0,  112,    0,    0,    0,
  113,  114, 1056,  531,  529,  115,  530,  116,  532,    0,
    0,  117, 1061,  531,  529,    0,  530,    0,  532,  227,
  118,  119,  120,  121,  535,    0,    0,  122,    0,    0,
    0,  123,    0,  124,  535,    0,  125,  126,  127,  128,
  129,  130,    0,  131,  132,  521,  522,  523,  524,  525,
  526,  527,  528,    0,    0,  533,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  533,    0,    0,  133,  134,
  135,  136,  137,  138,  139,  140,  141,    0,    0,    0,
  142,  143,    0,    0,    0,    0,    0,    0,  228,  229,
  230,  231,    0,  232,  233,  234,  235,  236,  237,  238,
  239,  240,  241,  242,  243,  244,  245,  246,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  144,    0,    0,    0,    0,  145,  146,  147,  148,  149,
  150,    0,  521,  522,  523,  524,  525,  526,  527,  528,
  152,  248,  249,  250,  251,  252,  253,  254,  255,   10,
   11,  256,  257,  258,  259,  260,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,    0,
   40,   41,   42,   43,   44,   45,   46,   47,  521,  522,
  523,  524,  525,  526,  527,  528,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  521,  522,  523,
  524,  525,  526,  527,  528,    0,    0,    0,  357,    0,
    0,    0,    0,  358,    0,    0,    0,    0,  359,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  296,    0,    0,    0,    0,  294,  521,  522,  523,
  524,  525,  526,  527,  528,    0,    0, 1063,  531,  529,
    0,  530,  360,  532,    0,    0,    0,    0,    0,  317,
    0,    0,    0,    0,    0,    0,  361,    0,    0,  535,
    0,    0,    0,  521,  522,  523,  524,  525,  526,  527,
  528,    0, 1068,  531,  529,    0,  530,  362,  532,    0,
    0,    0,  363, 1070,  531,  529,  364,  530,  365,  532,
  533,    0,  366,    0,  535, 1072,  531,  529,    0,  530,
    0,  532,    0,    0,    0,  535,    0,    0,    0,  219,
    0,    0,  220,    0,    0,    0,    0,  535, 1082,  531,
  529,    0,  530,    0,  532,  533,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  533,    0,    0,    0,
  535,    0,    0, 1084,  531,  529,  291,  530,  533,  532,
    0,    0,    0,    0,    0,    0,    0,    0, 1088,  531,
  529,    0,  530,  292,  532,  535, 1090,  531,  529,    0,
  530,  533,  532,    0,    0, 1092,  531,  529,    0,  530,
  535,  532,    0,  367,    0,    0,    0,    0,  535,    0,
    0,    0,    0,    0,    0,    0,  533,  535,  368,    0,
    0,    0,    0,  129,  130,  369,    0,    0,    0,    0,
    0,  533,    0,    0,    0,    0,    0,    0,    0,  533,
    0,    0,    0,    0,    0,    0,    0,    0,  533,    0,
    0,  133,  134,  370,  136,  137,  138,  139,  248,  249,
  250,  251,  252,  253,  254,  255,   10,   11,  256,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,    0,   40,   41,   42,
   43,   44,   45,   46,   47,    0,    0,    0,    0,    0,
    0,  293,  149,  150,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  295,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  438,    0,    0,    0,    0,  439,    0,    0,    0,    0,
  440,    0,    0,    0,    0,    0,    0,    0,  296,    0,
    0,    0,    0,  294,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  441,
    0,    0,    0,    0,    0,    0,  442,    0,    0,    0,
    0,  521,  522,  523,  524,  525,  526,  527,  528,    0,
    0,  521,  522,  523,  524,  525,  526,  527,  528,    0,
    0,  443, 1094,  531,  529,    0,  530,    0,  532,    0,
 1413,  531,  529,    0,  530,  444,  532,    0,    0,  445,
    0,    0,    0,    0,  535, 1415,  531,  529,    0,  530,
    0,  532,  535,    0,    0,    0,  219,    0,    0,  220,
 1417,  531,  529,    0,  530,    0,  532,  535, 1423,  531,
  529,    0,  530,    0,  532,  533,    0,    0,    0,    0,
    0,    0,  535,  533,    0, 1425,  531,  529,    0,  530,
  535,  532,    0,  291,    0,    0,    0,    0,  533,  446,
    0,    0,    0,    0,    0,    0,    0,  535,    0,    0,
  292,    0,    0,  533, 1427,  531,  529,    0,  530,    0,
  532,  533, 1429,  531,  529,    0,  530,    0,  532,    0,
    0,    0,    0,    0,    0,    0,  535,    0,  533,    0,
    0,    0,    0,    0,  535,    0,    0,    0,    0,    0,
  129,  130,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  533,    0,    0,
    0,    0,    0,    0,    0,  533,    0,    0,  133,  134,
  135,  136,  137,  138,  139,  248,  249,  250,  251,  252,
  253,  254,  255,   10,   11,  256,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,    0,   40,   41,   42,   43,   44,   45,
   46,   47,    0,    0,    0,    0,    0,    0,  293,  149,
  150,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  295,    0,    0,    0,    0,    0,  521,  522,  523,  524,
  525,  526,  527,  528,    0,    0,    0,    0,    0,    0,
    0,    0,  284,    0,    0,    0,    0,  285,    0,    0,
    0,    0,    0,    0,    0,  296,    0,    0,    0,    0,
  294,  521,  522,  523,  524,  525,  526,  527,  528,    0,
  286,    0,  521,  522,  523,  524,  525,  526,  527,  528,
    0,    0,    0,  287,  521,  522,  523,  524,  525,  526,
  527,  528,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  521,  522,  523,
  524,  525,  526,  527,  528,    0,    0,    0,    0,    0,
  288,    0,  289,    0,    0,    0,  290,    0,    0,    0,
    0,    0,  521,  522,  523,  524,  525,  526,  527,  528,
    0,    0,    0,  219,    0,    0,  220,  521,  522,  523,
  524,  525,  526,  527,  528,  521,  522,  523,  524,  525,
  526,  527,  528,    0,  521,  522,  523,  524,  525,  526,
  527,  528,    0,    0,    0,    0,    0,    0,    0,    0,
  291,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  292,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  129,  130,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  133,  134,  135,  136,  137,
  138,  139,  248,  249,  250,  251,  252,  253,  254,  255,
   10,   11,  256,  257,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
    0,   40,   41,   42,   43,   44,   45,   46,   47,  531,
  529, 1074,  530,    0,  532,  293,  149,  150,    0,    0,
    0,    0,    0,    0,  373,    0,    0,  295,    0,    0,
  535,  413,  414,  225, 1431,  531,  529,    0,  530,    0,
  532,    0,  415,    0,    0,    0,    0,    0,    0,  374,
    0,    0,    0,    0,  375,    0,  535,    0,    0,    0,
    0,  533,  296,    0,    0,    0,    0,  294,    0,    0,
    0,  521,  522,  523,  524,  525,  526,  527,  528,  521,
  522,  523,  524,  525,  526,  527,  528,  533,    0,    0,
  376,    0,    0,    0,  521,  522,  523,  524,  525,  526,
  527,  528,    0,  416,    0,    0,    0,    0,    0,  521,
  522,  523,  524,  525,  526,  527,  528,  521,  522,  523,
  524,  525,  526,  527,  528,    0,    0,  377,    0,  378,
    0,    0,    0,  379,  521,  522,  523,  524,  525,  526,
  527,  528,    0,    0,    0,    0,  226,    0,    0,    0,
  219,    0,    0,  220,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  521,  522,  523,  524,  525,  526,  527,
  528,  521,  522,  523,  524,  525,  526,  527,  528,    0,
  227,    0,    0,    0,    0,    0,    0,  291,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  292,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  296,    0,    0,    0,    0,  294,    0,    0,    0,    0,
    0,    0,    0,    0,  129,  130,    0,    0,    0,  228,
  229,  230,  231,    0,  232,  233,  234,  235,  236,  237,
  238,  239,  240,  241,  242,  243,  244,  245,  246,    0,
    0,    0,  133,  134,  135,  136,  137,  138,  139,  248,
  249,  250,  251,  252,  253,  254,  255,   10,   11,  256,
  257,  258,  259,  260,  261,  262,  263,  264,  265,  266,
  267,  268,  269,  270,  271,  272,  273,  274,  275,  276,
  277,  278,  279,  280,  281,  282,  283,    0,   40,   41,
   42,   43,   44,   45,   46,   47,  531,  529, 1076,  530,
    0,  532,  293,  149,  150,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  295,    0,    0,  535,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  960,  961,    0,    0,    0,    0,  962,    0,  531,  529,
 1078,  530,    0,  532,    0,    0,    0,    0,  533,  531,
  529, 1080,  530,    0,  532,    0,    0,    0,    0,  535,
  531,  529, 1086,  530,  963,  532,    0,    0,    0,    0,
  535,    0,    0,    0,    0,    0,    0,  317,    0,    0,
    0,  535,    0,    0,    0,    0,    0,    0,    0,    0,
  533,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  533,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  533,    0,  964,    0,  965,  248,  249,  250,
  251,  252,  253,  254,  255,   10,   11,  256,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,    0,   40,   41,   42,   43,
   44,   45,   46,   47,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  291,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  292,    0,    0,  966,  967,    0,    0,    0,    0,
    0,    0,    0,    0, 1260,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  296,    0,    0,
    0,    0,  294,    0,    0,    0,    0,    0,    0,    0,
    0,  129,  130,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  317,    0,    0, 1261,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  133,
  134,  135,  136,  137,  138,  139,    0,  521,  522,  523,
  524,  525,  526,  527,  528,    0,    0,    0,    0,    0,
    0,    0, 1262,    0, 1263,    0,    0,    0,    0,    0,
    0,    0,    0,  521,  522,  523,  524,  525,  526,  527,
  528,  531,  529,    0,  530,  219,  532,    0,  220,    0,
    0,    0,    0,    0,    0,    0,    0, 1210,    0,  293,
  149,  150,  535,    0,    0,    0,    0,    0,    0,    0,
    0,  295,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  291,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  533,    0,    0,    0,    0,    0,  292,
    0,    0, 1264,    0,    0,    0,    0,  531,  529,    0,
  530,    0,  532,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  535,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  129,
  130,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  533,
    0,    0,    0,    0,    0,    0,    0,  133,  134,  135,
  136,  137,  138,  139,  248,  249,  250,  251,  252,  253,
  254,  255,   10,   11,  256,  257,  258,  259,  260,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,    0,   40,   41,   42,   43,   44,   45,   46,
   47,    0,    0,    0,    0,    0,    0,  293,  149,  150,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  295,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1267,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  296,    0,    0,    0,    0,  294,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  317,    0,    0, 1268,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  521,  522,  523,  524,  525,  526,
  527,  528,    0,    0,    0,    0,    0,    0,    0, 1269,
    0, 1270,    0,    0,    0,    0,    0,    0,    0,  296,
    0,    0,    0,    0,  294,    0,    0,    0,    0,    0,
    0,    0,  219,    0,    0,  220,  521,  522,  523,  524,
  525,  526,  527,  528,    0,    0,    0,  521,  522,  523,
  524,  525,  526,  527,  528,    0,    0,    0,  521,  522,
  523,  524,  525,  526,  527,  528,    0,    0,    0,  291,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  292,    0,    0, 1271,
    0,    0,    0,    0,  296,    0,    0,    0,    0,  294,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  129,  130,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  133,  134,  135,  136,  137,  138,
  139,  248,  249,  250,  251,  252,  253,  254,  255,   10,
   11,  256,  257,  258,  259,  260,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,    0,
   40,   41,   42,   43,   44,   45,   46,   47,    0,    0,
    0,    0,    0,    0,  293,  149,  150,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  295,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  248,  249,  250,  251,
  252,  253,  254,  255,   10,   11,  256,  257,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,    0,   40,   41,   42,   43,   44,
   45,   46,   47,    0,    0,    0,    0,    0,    0,  317,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  521,
  522,  523,  524,  525,  526,  527,  528,    0,    0,    0,
    0,  248,  249,  250,  251,  252,  253,  254,  255,   10,
   11,  256,  257,  258,  259,  260,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,    0,
   40,   41,   42,   43,   44,   45,   46,   47,    0,    0,
    0,    0,    0,    0,  317,  521,  522,  523,  524,  525,
  526,  527,  528,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  291,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  292,    0,    0,    0,    0,    0,    0,
    0,  296,    0,    0,    0,    0,  294,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  317,
    0,    0,    0,  129,  130,    0,    0,    0,    0,  468,
  469,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  291,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  133,  134,  135,  136,  137,  138,  139,  292,    0,
    0,  470,  471,    0,    0,    0,  296,    0,    0,    0,
    0,  294,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  129,  130,
    0,    0,    0,    0,  478,  479,    0,    0,    0,    0,
    0,  293,  149,  150,    0,    0,  291,    0,    0,    0,
    0,    0,    0,  295,    0,    0,  133,  134,  135,  136,
  137,  138,  139,  292,    0,    0,  480,  481,    0,    0,
    0,  153,    0,    0,    0,    0,  151,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1305,    0,    0,    0,    0,    0,
    0,    0,    0,  129,  130,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  293,  149,  150,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  295,    0,
    0,  133,  134,  135,  136,  137,  138,  139,  248,  249,
  250,  251,  252,  253,  254,  255,   10,   11,  256,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,    0,   40,   41,   42,
   43,   44,   45,   46,   47,    0,    0,    0,    0,    0,
    0,  293,  149,  150,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  295,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  248,  249,  250,  251,  252,  253,  254,
  255,   10,   11,  256,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,    0,   40,   41,   42,   43,   44,   45,   46,   47,
    0,    0,    0,    0,    0,    0,  317,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    2,    3,
    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
   14,   15,   16,   17,  494,   19,   20,   21,   22,   23,
   24,   25,   26,   27,   28,   29,   30,   31,   32,   33,
   34,   35,   36,   37,   38,   39,    0,   40,   41,   42,
   43,   44,   45,   46,   47,    0,    0,    0,    0,    0,
    0,  317,    0,    0,    0,    0,    0,    0,    0, 1011,
    0, 1012,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  291,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1013,    0,    0,    0,    0, 1014,    0,
  292,    0,    0,    0,    0,    0,    0,    0,  153,    0,
    0,    0,    0,  151,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 1307, 1015,    0, 1016,    0,  495,    0,    0,    0,
  129,  130,    0,    0,    0,    0, 1017,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  291,    0,
    0,    0,    0,    0, 1018,    0,    0, 1019,  133,  134,
  135,  136,  137,  138,  139,  292,    0,    0, 1020,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  219,
    0,    0,  220, 1021,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  129,  130,    0,    0,    0,
    0, 1022, 1023,    0,    0,    0,    0,    0,  293,  149,
  150,    0,    0,  291,    0,    0,    0,    0,    0,    0,
  295,    0,    0,  133,  134,  135,  136,  137,  138,  139,
  496,    0,    0,    0,    0, 1024,    0, 1025,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1026, 1027,
    0,    0, 1028,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1029,    0,    0,    0, 1030,    0,
  129,  130,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  293,  149,  150,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  295,    0,    0,  133,  134,
  135,  136,  137,  138,  139,    2,    3,    4,    5,    6,
    7,    8,    9,   10,   11,   12,   13,   14,   15,   16,
   17,  494,   19,   20,   21,   22,   23,   24,   25,   26,
   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,
   37,   38,   39,    0,   40,   41,   42,   43,   44,   45,
   46,   47,    0,    0,  542,  543,    0,    0,  497,  149,
  150,    0, 1031,    0,  432,  432,    0,    0,    0,    0,
  152,    0,    0,    0,    0,    0,  544,    0,    0,    0,
    0,    0,  545,    0,    0,    0,  432,    0,  546,    0,
  547,    0,  432,  431,  431,    0,    0,    0,  432,    0,
  432,    0,    0,    0,    0,    0,    0,    0,    0,  548,
    0,    0,    0,    0,    0,  431,    0,    0,    0,  432,
    0,  431,    0,    0,    0,    0,    0,  431,    0,  431,
    0,    0,  549,  495,  550,    0,    0,    0,    0,    0,
    0,    0,  432,    0,  432,    0,  551,    0,  431,    0,
    0,    0,    0,    0,    0,  219,  432,    0,  220,    0,
    0,    0,    0,    0,    0,  432,    0,    0,  432,    0,
    0,  431,    0,  431,    0,    0,    0,  552,    0,    0,
    0,    0,    0,    0,    0,  431,    0,  432,    0,    0,
    0,    0,    0,    0,  431,    0,    0,  431,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  553,  554,    0,    0,  431,    0,    0,    0,
    0,    0,  432,  432,    0,    0,    0,    0,    0,    0,
  291,    0,  555,    0,    0,    0,    0,    0,    0,    0,
  556,    0,  432,    0,    0,    0,    0,  598,    0,    0,
  432,  431,  431,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  431,    0,    0,  557,    0,    0,    0,    0,  431,
    0,    0,    0,    0,  432,    0,    0,  129,  130,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  431,    0,  133,  134,  135,  136,  137,
  138,  139,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  497,  149,  150,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  152,
};
short yycheck[] = {                                      50,
    0,  414,   10,  720,  417,   10,   57,  369,   41,   42,
   43,   10,   45,  338,   47,  344,  429,  756,   46,  320,
   10,  103,   10,  320,  320,  320,   77,  506,   40,   37,
   63,  394,   46,   41,   42,   43,   44,   45,   37,   47,
  628,  123,   41,   42,   43,   44,   45,  499,   47,  369,
   58,   41,    0,   41,   44,   63,   44,  537,  385,   58,
   60,   94,   46,   91,   63,   40,   46,   37,   58,   10,
   58,   71,   42,  320,  452,  320,  499,   47,   10,   41,
  339,  281,  282,  371,   46,  344,   94,   40,   88,   89,
  542,  416,  380,   63,  445,   94,   96,  448,   10,   63,
   41,  281,  282,   44,  482,   37,   10,  385,  386,   41,
   42,   43,   44,   45,  502,   47,   10,   58,  118,  378,
  334,  121,  574,  323,   94,  125,   58,  127,  457,   41,
   94,   63,   44,   37,   40,  307,   61,   41,   42,   43,
   44,   45,  530,   47,  507,   40,   58,   41,  628,  628,
   44,  151,  152,  153,   58,  385,  535,  344,  537,  355,
  131,  486,   94,  422,   58,  424,   91,  529,  530,  140,
  533,  385,  499,  173,  174,  175,  176,  177,  178,  179,
  180,  181,  182,  183,  184,  185,  186,  187,  927,  189,
  190,  191,  192,  193,  194,  195,  196,  197,  198,  199,
  200,  201,  202,  151,  152,  153,  507,  421,  340,  529,
  507,  507,  507,  296,  297,  298,  299,  300,  301,  302,
  303,  499,  500,  355,   40,  173,  174,  175,  176,  177,
  178,  179,  180,  181,  182,  183,  184,  185,  186,  187,
  628,  189,  190,  191,  192,  193,  194,  195,  196,  197,
  198,  199,  200,  201,  202,   10,   42,   43,  453,   45,
  507,   47,  507,  522,  459,  340,  462,   10,  440,  499,
  457,  443,   46,  332,  333,  344,   40,   63,  334,   10,
  355,   40, 1001,   40,  335,  499,   41,  338,   43,   44,
   45,   10,   40,   40,  294,  295,  296,  344,   41, 1016,
   10,   44, 1021,   58,  401,  519,   37,   10,   94,   37,
   41,   42,   43,   44,   45,   58,   47,   91,   37,   10,
   40,  480,   41,   42,   43,   44,   45,   58,   47,  416,
  462,   41,   63,  628,   44,   63,   40,   10,   41,   58,
   43,   44,   45,  357,   63,   40,   37,   10,   58,  536,
   41,   42,   43,   44,   45,   58,   47,  416,   63,   10,
  344,   46,   40,   94,   40,  421,   94,   58,   41,  369,
  370,   44,   63,  442,   37,   94,   61,  357,   41,   42,
   43,   44,   45,   63,   47,   58,   37,  462,  457,   94,
   41,   42,   43,   44,   45,   58,   47,  355,  445,  486,
   63,  448,  499,   94,  327,   40,   91,   58,   37,   61,
  457,  425,   63,   42,   94,   40,  499,   40,   47,   40,
  420,  344,  519,   40,  424,   10, 1165,  486,   40,   40,
  430,   94,  342,   40,   63, 1152,  436,  421,  422,   91,
  424,  628,  366,   94,  340,  425,  344,  344,  344,  372,
  464,   40,   37,   46,  510,  379,   41,   42,   43,   44,
   45,  445,   47,  519,  448,   94,   40,  377,   61,  528,
   40,   40,   40,   58,  556,  385,   40,  425,  478,  479,
  480,  481,  378,  431,  464,  485,  340,  445,  328,  536,
  448,  344,  492,  493,  581,  582,  583,  584,   91,  422,
  628,  424,  628,  628,  462,  505,  506,  507,  508,  509,
  510,  511,  512,  513,  514,  515,  516,  517,  518,  372,
  520,  445,  445,   40,  422,  448,  424,  340,  424,  529,
  530,  531,  532,  533,  340,  445,   40,  352,  448,  539,
  540,  547,  466,  628,  492,  424,  530,  445,  628,  627,
  448,  551,  340,   40,  628,  555,  340,  557,  620,  621,
  622,  623,   10,  547,   40,  513,  514,  515,  516,  422,
  518,  424,  412,  521,  522,  523,  524,  525,  526,  527,
  528,  529,  530,  531,  532,  533,   10,  535,  498,   10,
   10,  539,  445,   41,   10,  448,   44,  630,  631,  632,
  633,  634,  635,  636,  637,  445,  502,  530,  448,   10,
   58,   10,   40,  328,  306,   40,   10,   10,   10,  628,
  335,  628,  630,  631,  632,  633,  634,  635,  636,  637,
  502,  630,  631,  632,  633,  634,  635,  636,  637,  628,
  630,  631,  630,  631,  644,  645,  646,  647,  648,  649,
  650,  651,  652,  653,  654,  655,  656,  657,  658,  628,
  660,  661,  662,  663,  664,  665,  666,  667,  668,  669,
  670,  671,  672,  673,  628,  390,  391,   10,  628,  628,
  340,   40,   40,  523,  524,   40,   40,  687,   40,  630,
  631,  691,  692,  693,  694,  695,  696,  697,  630,  631,
  632,  633,  634,  635,  636,  637,   40,  628,   41,  709,
  402,   44,   40,  405,  429,  430,  431,   40,  630,  631,
   40,  413,   46,  723,  416,   58,  630,  631,  632,  633,
  634,  635,  636,  637,   40,   40,  630,  685,  686,   40,
   40,   37,   60,  380,   10, 1158,   42,   43,  418,   45,
  465,   47,  422,   40,  424,   40,   46,   40,   76,  451,
   78,  319,   80,   42,   43,   44,   45,   63,   47,   42,
   88,   89,   10,  773,   47,   41,   94,   43,   44,   45,
   40,  781,   40,   40,   63,  340,  344,  787,  106,  344,
   63,   40,   58,   40,  486,   40,  511,  512,   94,   37,
  118,   40,  628,   41,   42,   43,   44,   45,  445,   47,
   40,  448,   40,   42,   43,   94,   45,  487,   47,   40,
   58,   94,   40,  378,   40,   63,   40,  145,  146,  147,
  467,   40,  547,  833,   63,  422,  551,  424,  838,  531,
   46,  628,   44,   91,  162,  631,  632,  633,  634,  635,
  636,  637,  170,   46,  854,   91,   94,  502,  445,  417,
  530,  448,  862,  527,  422,   94,  424,  628,  628,  424,
  428,  871,  628,  499,  502,  630,  631,  632,  633,  634,
  635,  636,  637,  344,  628,  500,  628,  630,  631,  628,
  628,  209,  502,  530,  502,  500,  628,  499,  216,  630,
  631,  632,  633,  634,  635,  636,  637,  628,  502,  960,
  547,  630,  631,  632,  633,  634,  635,  636,  637,  628,
  630,  631,  628,  871,  527,  873,  628,  630,  631,  632,
  633,  634,  635,  636,  637,  628,  628,   46,  496,  630,
  631,  632,  633,  634,  635,  636,  637,  502,  296,  297,
  298,  299,  300,  301,  302,  303,  628,  630,  631,  628,
   10,  628,  962,  628,  527,  340,  966,  630,  631,  632,
  633,  634,  635,  636,  637,  628,  340,  340,  628,  630,
  631,  632,  633,  634,  635,  636,  637,  628,  628,  989,
  990,   41,  628,   43,   44,   45,   37,  997,  998,  999,
 1000,   42,   43,   44,   45,  499,   47,  502,   58,  628,
  328,  340,  628,  340,  628,  628,  530,  499,   40,  337,
   46,  339,   63,   46,  628,   63,   63, 1027, 1028,  628,
  348,  628,  628,  628,  499,   10,  628,  628,  628,  357,
  628,  340,  628, 1043,  628,  630,  631,  632,  633,  634,
  635,  636,  637,   94,  499,  339,  340, 1057, 1058,   41,
  344,  628,   37,  628,  499,  499,  384,   42,   43,  628,
   45,  628,   47, 1073, 1074, 1075,  628, 1077,  628, 1079,
  628,  628,  628,  628,  628, 1085, 1086,  628,   63,  628,
  628,  628,  628,  628,  378,  628, 1044,  628,   37,  628,
  628,  628,  628,   42,   43,  418,   45,  628,   47, 1057,
 1058,  429,    0,  628,   44,   10,  628,  628,  628,   94,
  628,  628,  628,  628,   63,  418,  410,  628, 1076,  413,
 1078,   44, 1080,   44,  385,  628,  628, 1085, 1086,  628,
  424,   10,   37,  628,  340,  463,   41,   42,   43,   44,
   45,  499,   47,  628,  628,   94,  499,   44,  499, 1159,
  340,  340, 1162,   58,  340,   44,   44,   61,   63,  340,
   61,  628,   41,   42,   43,   44,   45, 1177,   47,  463,
  340,  628,  340,   10,   44, 1185, 1186, 1187,  628,   58,
 1190, 1191, 1192,   44, 1194, 1195,  628,  628,  628,   94,
   44,  628,  628,   44, 1204, 1205,  628,  502,  340, 1209,
   37,  628, 1160,  628,   41,   42,   43,   44,   45,  628,
   47,  628,  628,  628,  628,   94,  539,  540,  628,  522,
  628,   58,  628,  628, 1234,  502,   63,  628,  628,  281,
  628,  628,  628,  628, 1192,  628,  539,  540,  628,  340,
  568,  628,  570,  571,  567,  568,  569,  570,  571,  572,
  573,  628, 1210,  151,  152,  153,  628,   94,   44,   41,
   44,  313,  314,   46,  567,  568,  569,  570,  571,  572,
  573, 1281,  628,  325,  628,  173,  174,  175,  176,  177,
  178,  179,  180,  181,  182,  183,  184,  628,  186,  187,
  527,  189,  190,  191,  192,  193,  194,  195,  196,  197,
  198,  199,  200,  201,  202,   44,  628,  628,  296,  297,
  298,  299,  300,  301,  302,  303,  628,  527,  380,   61,
  628,  628,   46,   61,  628, 1335,  628,  628, 1338,  628,
 1340,   10, 1342,   44,  340,   41,  628,  628,  628, 1349,
  628,  630,  631,  632,  633,  634,  635,  636,  637, 1359,
  628,   41,   41,  628,  630,  631,  632,  633,  634,  635,
  636,  637,   41,  628,   43,   44,   45,   10, 1378, 1379,
  385,   44,  628, 1383,  628,  628,  628, 1387,  628,   58,
  340, 1339,  630,  631,  632,  633,  634,  635,  636,  637,
  385,   41,  628,  628,   37,  340,   41,   41,   41,   42,
   43,   44,   45,  628,   47,   41,   44,   46,  628,   46,
 1420, 1421,   61,  340,  628,   58,  499,  499,   41,   61,
  628,  628,   41,    0,   10,   10, 1384,   10,  756,   10,
   10,   10,   91, 1018,   10, 1445, 1446,   10, 1448, 1449,
   10, 1451,   10,   10, 1454,   10, 1456,  499,  500,   10,
   93,   94, 1462,   10,   10,   41,   42,   43,   44,   45,
   10,   47,  409,   10, 1474,   10, 1476,   10,   10,   10,
   10,   10,   58,   10,   10,   10, 1486,   63,   10,   10,
 1490,   10, 1492, 1493,   10,   10,   10,   10, 1446,   10,
  542,  543,   10,   10,   10,   10, 1506,   10, 1508,   37,
   10,   10,   10, 1513,   42,   43,   10,   45,   94,   47,
 1520,  499,   10, 1523,   10, 1525,   10, 1527,   10,   10,
   58,   10,  574,  575,   10,   63,   10,  579,  580,  539,
  540,   10,   10,   37,   10,   10,   10,   41,   42,   43,
   44,   45,   10,   47,   10,   37,   10,   10, 1447,   41,
   42,   43,   44,   45,   58,   47,   94,  567,  568,  569,
  570,  571,  572,  573, 1033,   -1,   58,   81,  348,   81,
  630,  631,  632,  633,  634,  635,  636,  637,   -1,  630,
  631,  632,  633,  634,  635,  636,  637, 1009,   -1,   93,
   94,   -1,   -1,   -1,  492,  923,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  513,  514,  515,  516,   -1,
  518,   -1,   -1,  521,  522,  523,  524,  525,  526,  527,
  528,  529,  530,  531,  532,  533,  279,  535,  281,  282,
   -1,  539,   -1,   -1,   -1,  630,  631,  632,  633,  634,
  635,  636,  637,   -1,   -1,   -1,   -1,   -1,   -1,  339,
  988,   -1,   -1,  991,  344,   -1,   -1,   -1,  311,  997,
  998,   -1,  315,   -1,  317,   -1,   -1,   -1,   -1,   -1,
   -1, 1009,  631,  632,  633,  634,  635,  636,  637,  332,
   -1,   -1,   -1,   -1,   -1,   -1,  339,   -1,  378,   -1,
   -1,  344,   -1,   -1,   -1, 1033,   -1,  350,  388,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  630,  631,  632,  633,  634,
  635,  636,  637,   -1,   -1,  378,   -1,  380,   -1,   -1,
   -1,   -1,  422,   -1,  424,   -1,   -1,   -1,   -1,  392,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,  402,
   -1,   -1,   -1,   -1,   -1,  445,   -1,  410,  448,   -1,
  413,   -1,   -1,   -1,   -1,  279,   -1,  281,  282,   -1,
   -1,  424,   -1,   10,   -1,   -1,   -1,   -1,   -1,  432,
   -1,   -1,  435,  630,  631,  632,  633,  634,  635,  636,
  637,   -1,  445,  446,  447,  448,  449,  311,  451,   -1,
   37,  315,   -1,  317,   41,   42,   43,   44,   45,   -1,
   47,   -1,   -1,  371,  467,  468,   -1,   -1,  332,   -1,
 1158,   58,   -1,   -1,   -1,  339,   -1,   -1,   -1,   -1,
  344,  389,   -1,   -1,   -1,   -1,  350,  395,  396,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,  501,  502,
  503,   -1,   42,   43,  507,   45,   93,   47,   -1,   -1,
   -1,  514,  515,   -1,  378,  518,  380,   -1,   -1,   -1,
  523,   -1,   -1,   63,   -1,  433,  434,  530,  392,   -1,
   -1,  534,   -1,   -1,   -1,   -1,   -1,   -1,  402,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  410,   -1,   -1,  413,
   -1,   -1,   -1,   -1,   94,   -1,   42,   43,   -1,   45,
  424,   47,   -1,   -1,  472,   -1,  474,   -1,  432,   -1,
   -1,  435,   -1, 1261,   -1,   -1,   -1,   63,   10,   -1,
 1268,  445,  446,  447,  448,  449,   -1,  451,   -1,   -1,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
   -1,   -1,   -1,  467,  468,   37,   -1,   -1,   94,   41,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,  527,
   -1,   -1,   -1,   10,   -1,  628,   58,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   -1,  501,  502,  503,
   -1,   -1,   -1,  507,   -1,   -1,   -1,   -1,   -1,   -1,
  514,  515,   -1,   -1,  518,   42,   43,  371,   45,  523,
   47,   93,   -1,   -1,   -1,   10,  530,   -1,   -1,   -1,
  534,   -1,   -1,   -1,   -1,  389,   63,   10,   -1,   -1,
   -1,  395,  396,   -1,  630,  631,  632,  633,  634,  635,
  636,  637,  279,   -1,  281,  282,   41,   42,   43,   44,
   45,   -1,   47,   -1,   37,   -1,   -1,   94,   41,   42,
   43,   44,   45,   58,   47,   -1,   -1,   -1,   63,  433,
  434,   -1,   -1,   -1,  311,   58,   -1,   -1,  315,   -1,
  317,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   -1,   -1,   -1,   -1,   -1,  332,   -1,   -1,   -1,   94,
   -1,   -1,  339,   -1,   -1,   -1,   -1,  344,  472,   -1,
  474,   94,   -1,  350,  628,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   -1,   -1,   -1,   10,  630,  631,
  632,  633,  634,  635,  636,  637, 1044,   -1,   -1,   -1,
   -1,  378,   -1,  380,   -1,   -1,   -1,   -1,   -1, 1057,
 1058,   -1,   -1,   -1,   -1,  392,   -1,   -1,   41,   10,
   43,   44,   45,   -1,   -1,  402,   -1,   -1, 1076,   -1,
 1078,   -1, 1080,  410,   -1,   58,  413, 1085, 1086,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  424,   10,   -1,
   41,   42,   43,   44,   45,  432,   47,  279,  435,  281,
  282,   -1,   -1,   -1,   -1,   -1,   -1,   58,  445,  446,
  447,  448,  449,   -1,  451,   37,   -1,   -1,   -1,   41,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,  311,
  467,  468,   -1,  315,   -1,  317,   58,   -1,   -1,   -1,
   -1,   10,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,
  332,   -1,   -1,   -1,   -1,   -1,   -1,  339,   -1,   -1,
   -1,   -1,  344,   -1,  501,  502,  503,   -1,  350,   -1,
  507,   93,   41,   -1,   43,   44,   45,  514,  515,   -1,
   -1,  518,   -1,   -1, 1192,   -1,  523,   -1,   -1,   58,
   -1,   -1,   -1,  530,   -1,   -1,  378,  534,  380,   -1,
   -1,   -1, 1210,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  402,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  410,   -1,
   -1,  413,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  432,   -1,   -1,  435,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  445,  446,  447,  448,  449,   -1,  451,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   10,   -1,   -1,   -1,  467,  468,   -1,   -1,   -1,
   -1,  628,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   41,   42,   43,   44,   45,   -1,   47,  501,
  502,  503,   -1,   -1,   -1,  507,   -1,   -1,   -1,   58,
   -1,   -1,  514,  515,   63,   10,  518,   -1,   -1,   -1,
   -1,  523,  632,  633,  634,  635,  636,  637,  530,   -1,
   -1,   -1,  534,   -1,   -1,   -1,   -1,  279,   -1,  281,
  282,   -1,   37,   -1,   -1,   94,   41,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   10,
   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,   -1,  311,
   -1,   -1,   10,  315,   -1,  317,  632,  633,  634,  635,
  636,  637,   -1,   -1,   -1,   -1,   37,   -1,   -1,   -1,
  332,   42,   43,   -1,   45,   -1,   47,  339,   93,   -1,
   -1,   -1,  344,   41,   42,   43,   44,   45,  350,   47,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1, 1446,   -1,
   58,   -1,   -1,   -1,   -1,   63,  628,   -1,  630,  631,
  632,  633,  634,  635,  636,  637,  378,   -1,  380,   -1,
   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,
  392,   -1,   -1,   -1,   10,   -1,   94,   37,   -1,   -1,
  402,   41,   42,   43,   10,   45,   -1,   47,  410,   -1,
   -1,  413,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   -1,  424,   63,   -1,   41,   -1,   43,   44,   45,
  432,   37,   -1,  435,   -1,   41,   42,   43,   44,   45,
   -1,   47,   58,  445,  446,  447,  448,  449,   10,  451,
   -1,   -1,   58,   -1,   94,  630,  631,  632,  633,  634,
  635,  636,  637,   -1,   -1,  467,  468,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   -1,   93,   -1,   41,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,  501,
  502,  503,   10,   -1,   -1,  507,   -1,   -1,   -1,   -1,
   -1,   -1,  514,  515,   -1,   -1,  518,   -1,   -1,   -1,
   -1,  523,   -1,   -1,  279,   -1,  281,  282,  530,   -1,
   -1,   -1,  534,   41,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,
   58,   -1,   -1,   -1,   -1,   -1,  311,   -1,   -1,   -1,
  315,   -1,  317,   -1,   -1,   -1,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   10,  332,   -1,   41,
   42,   43,   44,   45,  339,   47,   -1,   -1,   -1,  344,
   -1,   -1,   -1,   -1,   -1,  350,   58,   -1,   -1,  630,
  631,  632,  633,  634,  635,  636,  637,   41,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   10,
   -1,   -1,   -1,  378,   58,  380,  628,   -1,  630,  631,
  632,  633,  634,  635,  636,  637,   -1,  392,   -1,   -1,
   -1,   10,   -1,   -1,   -1,   -1,   -1,  402,   -1,   -1,
   41,   42,   43,   44,   45,  410,   47,   -1,  413,   -1,
   -1,   -1,   -1,  279,   -1,  281,  282,   58,   -1,  424,
   -1,   10,   41,   -1,   43,   44,   45,  432,   -1,   -1,
  435,  630,  631,  632,  633,  634,  635,  636,  637,   58,
  445,  446,  447,  448,  449,  311,  451,   -1,   -1,  315,
   -1,  317,   41,   42,   43,   44,   45,   10,   47,   -1,
   -1,   -1,  467,  468,   -1,   -1,  332,   -1,   -1,   58,
   -1,   -1,   -1,  339,   93,   -1,   -1,   -1,  344,   -1,
   -1,   -1,   -1,   -1,  350,   -1,   -1,   -1,   41,   42,
   43,   44,   45,   -1,   47,   -1,  501,  502,  503,   -1,
   10,   -1,  507,   -1,   -1,   58,   -1,   -1,   10,  514,
  515,   -1,  378,  518,  380,   -1,   -1,   -1,  523,   10,
   -1,   -1,   -1,   -1,   -1,  530,  392,   -1,   -1,  534,
   -1,   41,   42,   43,   44,   45,  402,   47,   -1,   41,
   42,   43,   44,   45,  410,   47,   -1,  413,   58,   -1,
   41,   -1,   43,   44,   45,   -1,   58,   -1,  424,   10,
   -1,   -1,   -1,   -1,   -1,   -1,  432,   58,   -1,  435,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,  445,
  446,  447,  448,  449,   -1,  451,   37,   -1,   -1,   -1,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,   37,   -1,
   -1,  467,  468,   42,   43,   44,   45,   -1,   47,   -1,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  628,   63,  630,  631,  632,  633,  634,
  635,  636,  637,   -1,   46,  501,  502,  503,   -1,   -1,
   -1,  507,   -1,   94,   -1,   -1,   -1,   -1,  514,  515,
   -1,   -1,  518,   -1,   -1,   94,   -1,  523,   -1,   -1,
  279,   -1,  281,  282,  530,   -1,   -1,   -1,  534,  630,
  631,  632,  633,  634,  635,  636,  637,   -1,   -1,   10,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   -1,   -1,  311,   -1,   -1,   -1,  315,   -1,  317,   -1,
   -1,   10,   -1,   -1,   -1,   -1,   37,   -1,   -1,   -1,
   -1,   42,   43,  332,   45,   -1,   47,   -1,   -1,   -1,
  339,   -1,   -1,   -1,   -1,  344,   -1,   -1,   37,   -1,
   -1,  350,   63,   42,   43,   -1,   45,   -1,   47,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   -1,   -1,
   -1,   -1,   -1,   -1,   63,   10,   -1,   -1,   -1,  378,
   -1,  380,  628,   94,  630,  631,  632,  633,  634,  635,
  636,  637,   -1,  392,  630,  631,  632,  633,  634,  635,
  636,  637,   37,  402,   -1,   94,   -1,   42,   43,   -1,
   45,  410,   47,   -1,  413,   -1,   -1,   -1,   -1,   -1,
   -1,   10,   -1,   -1,   -1,  424,   -1,   -1,   63,   10,
   -1,   -1,   -1,  432,   -1,   -1,  435,  348,  630,  631,
  632,  633,  634,  635,  636,  637,  445,  446,  447,  448,
  449,   -1,  451,   42,   43,   -1,   45,  368,   47,   94,
   -1,   42,   43,   -1,   45,   -1,   47,   -1,  467,  468,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   10,   -1,   -1,
   37,   -1,   63,   -1,   -1,   42,   43,   44,   45,  281,
   47,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   -1,   -1,  501,  502,  503,   94,   63,   -1,  507,   42,
   43,   -1,   45,   94,   47,  514,  515,   -1,   -1,  518,
   -1,   10,   -1,   -1,  523,   -1,   -1,   -1,   -1,  321,
   63,  530,   -1,   -1,   -1,  534,  328,   94,  630,  631,
  632,  633,  634,  635,  636,  637,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   42,   43,  466,   45,   -1,   47,   -1,
   -1,   94,   -1,   -1,   -1,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  374,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   10,   -1,   -1,   -1,   -1,   -1,
   -1,  393,  348,   -1,   -1,   94,   -1,   -1,   -1,  630,
  631,  632,  633,  634,  635,  636,  637,   -1,   -1,   -1,
  412,   -1,  368,   -1,   -1,   -1,   -1,   -1,   -1,  628,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  445,   -1,   -1,  448,   -1,   -1,   -1,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
   -1,   -1,   -1,   -1,  585,  586,  587,  588,  589,  590,
  591,  592,  593,  594,  595,  596,  597,  598,  599,  600,
  601,  602,  603,  604,  605,  606,  607,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   -1,   -1,  500,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  628,   -1,  511,
  466,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  530,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,  630,  631,
  632,  633,  634,  635,  636,  637,   -1,   -1,   -1,  630,
  631,  632,  633,  634,  635,  636,  637,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   10,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,
  631,  632,  633,  634,  635,  636,  637,   -1,   -1,   -1,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   41,
   -1,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,  585,
  586,  587,  588,  589,  590,  591,  592,  593,  594,  595,
  596,  597,  598,  599,  600,  601,  602,  603,  604,  605,
  606,  607,   -1,  279,   -1,  281,  282,   -1,   -1,   -1,
   -1,   93,   37,   -1,   -1,   -1,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  311,   -1,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  332,   -1,   -1,  630,
  631,  632,  633,  634,  635,  636,  637,   10,  344,   94,
   -1,   -1,   -1,   -1,  350,   -1,   10,   -1,   -1,   -1,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   -1,
   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  402,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  630,  631,  632,  633,  634,
  635,  636,  637,   -1,   -1,   -1,   -1,   -1,  424,   -1,
   93,   -1,   -1,   -1,   -1,   -1,  432,   -1,   -1,  435,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  445,
  446,  447,  448,  449,   -1,  451,   -1,   -1,   -1,   -1,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,  630,
  631,  632,  633,  634,  635,  636,  637,  279,   -1,  281,
  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   -1,   10,   -1,   -1,   -1,  502,   -1,   -1,  311,
   -1,  507,   -1,  315,   -1,  317,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   -1,   -1,   -1,   -1,
  332,   -1,   -1,   41,  530,   -1,   44,  339,   -1,   -1,
   -1,   -1,  344,   -1,   -1,   -1,   -1,   -1,  350,   -1,
   58,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  378,   -1,  380,   -1,
   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,
  392,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  402,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  410,   -1,
   -1,  413,   -1,   -1,   -1,   -1,  279,   -1,  281,  282,
   -1,   -1,  424,   -1,   -1,  279,   -1,  281,  282,   -1,
  432,   -1,  628,  435,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   10,   -1,  445,  446,  447,  448,  449,  311,  451,
   -1,   -1,  315,   -1,  317,   -1,   -1,  311,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  467,  468,   -1,   -1,  332,
   -1,   -1,   41,   -1,   -1,   44,  339,   -1,  332,   -1,
   -1,  344,   -1,   -1,   -1,   -1,   -1,  350,   -1,   58,
  344,   -1,   -1,   -1,   -1,   -1,  350,   -1,   -1,  501,
  502,  503,   -1,   -1,   -1,  507,   -1,   -1,   -1,   -1,
   -1,   -1,  514,  515,   -1,  378,  518,  380,   -1,   -1,
   -1,  523,   -1,   -1,   93,   -1,   -1,   -1,  530,  392,
   -1,   -1,  534,   -1,   -1,   -1,   -1,   -1,   -1,  402,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  410,  402,   -1,
  413,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  432,
  424,  279,  435,  281,  282,   -1,   -1,   -1,  432,   -1,
   -1,  435,  445,  446,  447,  448,  449,   10,  451,   -1,
   -1,  445,  446,  447,  448,  449,   -1,  451,   -1,   -1,
   -1,   -1,   -1,  311,  467,  468,   -1,  315,   -1,  317,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  332,   -1,  628,   -1,  630,  631,
   -1,  339,   -1,   -1,   -1,   10,  344,   -1,  501,  502,
  503,   -1,  350,   -1,  507,   -1,   -1,   -1,  502,   -1,
   -1,  514,  515,  507,   -1,  518,   -1,   -1,   -1,   -1,
  523,   -1,   -1,   10,   -1,   -1,   41,  530,   -1,   44,
  378,  534,  380,   -1,   -1,   -1,  530,   -1,   -1,   -1,
   -1,   -1,   -1,   58,  392,  630,  631,  632,  633,  634,
  635,  636,  637,   -1,  402,   -1,   -1,   -1,   -1,   -1,
   -1,  279,  410,  281,  282,  413,   -1,   -1,   -1,   -1,
  279,   -1,  281,  282,   -1,   -1,  424,   -1,   93,   -1,
   -1,   -1,   -1,   -1,  432,   -1,   -1,  435,   -1,   -1,
   -1,   -1,   -1,  311,   -1,   -1,   -1,  445,  446,  447,
  448,  449,  311,  451,   -1,   -1,  315,   -1,  317,   -1,
   -1,   -1,   -1,   -1,  332,   -1,   -1,   -1,   -1,  467,
  468,   -1,   -1,  332,   -1,  628,  344,  630,  631,   -1,
  339,   -1,  350,   -1,  628,  344,   -1,   -1,   -1,   -1,
   -1,  350,   10,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  501,  502,  503,   -1,   -1,   -1,  507,
   -1,   -1,   -1,   -1,   -1,   -1,  514,  515,   -1,  378,
  518,  380,   -1,   41,   -1,  523,   44,   -1,   -1,   -1,
   -1,   -1,  530,  392,  402,   -1,  534,   -1,   -1,   -1,
   58,   -1,   -1,  402,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  410,   -1,   -1,  413,   -1,  424,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  432,  424,  279,  435,  281,  282,
   -1,   -1,   -1,  432,   -1,   93,  435,  445,  446,  447,
  448,  449,   -1,  451,   -1,   -1,  445,  446,  447,  448,
  449,   -1,  451,   -1,   -1,   -1,   37,   -1,  311,   -1,
   -1,   42,   43,   44,   45,   -1,   47,   -1,  467,  468,
   -1,   -1,   -1,   -1,  279,   -1,  281,  282,   -1,  332,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  628,  344,  630,  631,  502,   -1,   -1,  350,   10,  507,
   -1,   -1,  501,  502,  503,   -1,  311,   -1,  507,   -1,
  315,   -1,  317,   94,   -1,  514,  515,   -1,   -1,  518,
   -1,   -1,  530,   -1,  523,   -1,   -1,  332,   -1,   41,
   -1,  530,   44,   -1,  339,  534,   -1,   -1,  315,  344,
  317,   -1,   -1,   -1,   -1,  350,   58,   -1,   -1,  402,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  339,   -1,   -1,   -1,   -1,  344,   -1,   -1,
   -1,  424,   -1,  378,   -1,  380,   -1,   -1,   37,  432,
   -1,   93,  435,   42,   43,   44,   45,  392,   47,   -1,
   -1,   -1,  445,  446,  447,  448,  449,  402,  451,   -1,
   -1,  378,   -1,  380,   63,  410,   -1,   -1,  413,   -1,
   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,  424,
  628,  279,   -1,  281,  282,   -1,   -1,  432,   -1,  628,
  435,  630,  631,  410,   -1,   94,  413,   -1,   -1,   -1,
  445,  446,  447,  448,  449,   10,  451,  424,   -1,  502,
   -1,   -1,   -1,  311,  507,   -1,   -1,  315,   -1,  317,
   -1,   -1,  467,  468,   -1,   -1,   -1,   -1,  445,   -1,
   -1,  448,  449,   -1,  332,   -1,   41,  530,   -1,   44,
   -1,  339,   -1,   -1,   -1,   -1,  344,   -1,   -1,   -1,
  467,  468,  350,   58,   -1,   -1,  501,  502,  503,   -1,
   -1,   -1,  507,   -1,   -1,   -1,   -1,   -1,   -1,  514,
  515,   -1,   -1,  518,   -1,   -1,   -1,   -1,  523,   -1,
  378,   -1,  380,   -1,  501,  530,  503,   -1,   93,  534,
   -1,   -1,   -1,   -1,  392,   -1,   -1,  514,  515,   -1,
   -1,  518,   -1,   -1,  402,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  410,  530,   -1,  413,   -1,  534,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  424,  279,   -1,  281,
  282,   -1,   -1,   -1,  432,  628,   -1,  435,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  445,  446,  447,
  448,  449,   -1,  451,   -1,   -1,   -1,   -1,   -1,  311,
   10,   -1,   -1,  315,   -1,  317,   -1,   -1,   -1,  467,
  468,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  332,   -1,   -1,  628,   -1,  630,  631,  339,   -1,   -1,
   -1,   41,  344,   -1,   44,   -1,   -1,   -1,  350,   -1,
   -1,   -1,   -1,  501,  502,  503,   -1,   -1,   58,  507,
   -1,  628,   -1,   -1,   -1,   -1,  514,  515,   -1,   -1,
  518,   -1,   -1,   -1,   -1,  523,  378,   -1,  380,   -1,
   -1,   -1,  530,   -1,   -1,   -1,  534,   -1,   -1,   -1,
  392,   -1,   -1,   93,   10,   -1,   -1,   -1,   -1,   -1,
  402,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  410,   -1,
   -1,  413,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  424,   -1,  279,   -1,  281,  282,   -1,   -1,
  432,   37,   -1,  435,   -1,   -1,   42,   43,   44,   45,
   -1,   47,   -1,  445,  446,  447,  448,  449,   -1,  451,
   -1,   -1,   -1,   -1,   -1,   -1,  311,   63,   -1,   -1,
  315,   -1,  317,   -1,   -1,  467,  468,   -1,   -1,   -1,
   10,   -1,   -1,   -1,   -1,   -1,   -1,  332,   -1,   -1,
  628,   -1,  630,  631,  339,   -1,   -1,   -1,   94,  344,
   -1,   -1,   -1,   -1,   -1,  350,   -1,   -1,   -1,  501,
  502,  503,   -1,   -1,   -1,  507,   -1,   -1,   -1,   -1,
   -1,   -1,  514,  515,   -1,   -1,  518,   -1,   -1,   -1,
   -1,  523,   -1,  378,   -1,  380,   -1,   -1,  530,   -1,
   -1,   -1,  534,   -1,   -1,   -1,   -1,  392,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  402,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  410,   10,   -1,  413,  630,
  631,  632,  633,  634,  635,  636,  637,   -1,   -1,  424,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  432,   -1,  279,
  435,  281,  282,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  445,  446,  447,  448,  449,   -1,  451,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  311,  467,  468,   37,  315,   -1,  317,   -1,   42,
   43,   44,   45,   -1,   47,   -1,  628,   -1,  630,  631,
   -1,   -1,  332,   -1,   -1,   -1,   -1,   -1,   -1,  339,
   63,   -1,   -1,   -1,  344,   -1,  501,  502,  503,   -1,
  350,   -1,  507,   -1,   -1,   -1,   -1,   -1,   -1,  514,
  515,   -1,   -1,  518,   10,   -1,   -1,   -1,  523,   -1,
   -1,   94,   -1,   -1,   -1,  530,   -1,   -1,  378,  534,
  380,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
   -1,   -1,  392,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   10,  317,  402,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  410,   -1,   37,  413,   -1,   -1,   -1,   42,   43,   44,
   45,   -1,   47,  339,  424,   -1,   -1,   -1,  344,   -1,
   -1,   -1,  432,   -1,   -1,  435,   -1,   -1,   63,  279,
   -1,  281,  282,   -1,   -1,  445,  446,  447,  448,  449,
   -1,  451,   -1,   -1,   -1,   37,   -1,   -1,   -1,   41,
   42,   43,  378,   45,  380,   47,   -1,  467,  468,   94,
   -1,  311,   -1,  628,   37,  630,  392,   -1,   41,   42,
   43,   63,   45,   37,   47,   -1,   -1,   41,   42,   43,
   -1,   45,  332,   47,  410,   -1,   -1,  413,   -1,   -1,
   63,  501,  502,  503,  344,   -1,   -1,  507,  424,   63,
  350,   -1,   94,   -1,  514,  515,   37,   -1,  518,   -1,
   41,   42,   43,  523,   45,  279,   47,  281,  282,  445,
  530,   94,  448,  449,  534,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  467,  468,   37,   -1,   -1,   -1,  311,   42,   43,
   44,   45,  402,   47,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,  332,   63,
   -1,   -1,   -1,   -1,  424,  501,   -1,  503,   -1,   -1,
  344,   -1,  432,   -1,   -1,  435,  350,   -1,  514,  515,
   -1,   -1,  518,   -1,   -1,  445,  446,  447,  448,  449,
   94,  451,   -1,   -1,  530,   -1,   37,   -1,  534,   -1,
   41,   42,   43,   -1,   45,   -1,   47,   -1,  628,   -1,
   -1,   -1,   -1,  279,   -1,  281,  282,   -1,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,  402,   37,
   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,  502,   -1,   -1,  311,   -1,  507,   -1,  279,
  424,  281,  282,   94,   -1,   63,   -1,   -1,  432,   37,
   -1,  435,   -1,   41,   42,   43,  332,   45,   -1,   47,
  530,  445,  446,  447,  448,  449,   -1,  451,  344,   -1,
   -1,  311,   -1,   -1,  350,   63,   94,   -1,   -1,   37,
   -1,   -1,  628,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,  332,   -1,  630,  631,  632,  633,  634,  635,
  636,  637,   -1,   37,  344,   63,   94,   41,   42,   43,
  350,   45,   -1,   47,   -1,   -1,   -1,   -1,  502,   -1,
   -1,   -1,   -1,  507,   -1,   37,  402,   -1,   -1,   63,
   42,   43,   44,   45,   -1,   47,   94,   37,   -1,   -1,
   -1,   41,   42,   43,   -1,   45,  530,   47,  424,   -1,
   -1,   63,   -1,   -1,   -1,   -1,  432,   -1,  628,  435,
   94,   -1,  402,   63,   -1,   -1,   -1,   -1,   -1,  445,
  446,  447,  448,  449,   -1,  451,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,  424,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  432,   37,   94,  435,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,  445,  446,  447,  448,  449,
   -1,  451,   37,   -1,   -1,   -1,   41,   42,   43,   63,
   45,   -1,   47,   -1,   -1,   -1,  502,   -1,   -1,   37,
   -1,  507,   -1,   -1,   42,   43,   44,   45,   63,   47,
   -1,   -1,   -1,   -1,  628,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,  530,   63,   -1,   -1,   -1,   -1,
   -1,   -1,  502,   -1,   -1,   -1,   37,  507,   -1,   94,
   41,   42,   43,   -1,   45,   -1,   47,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   94,   -1,   -1,   37,
  530,   -1,   63,   41,   42,   43,   -1,   45,   37,   47,
   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   37,   -1,   -1,   -1,   63,   42,   43,   44,   45,
   -1,   47,   -1,   94,   63,   -1,   -1,   -1,   37,   -1,
   -1,   -1,   -1,   42,   43,   44,   45,   63,   47,   -1,
   -1,   -1,   -1,   37,   -1,   -1,   94,   -1,   42,   43,
   44,   45,  628,   47,   63,   94,   -1,   37,   -1,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   94,   63,
   -1,   -1,   -1,   -1,   -1,  630,  631,  632,  633,  634,
  635,  636,  637,   63,   -1,   94,   -1,   -1,  628,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   94,   -1,   -1,   -1,  630,  631,
  632,  633,  634,  635,  636,  637,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   -1,   -1,   -1,   -1,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,  630,
  631,  632,  633,  634,  635,  636,  637,   -1,   -1,   37,
   -1,   -1,   -1,   63,   42,   43,   44,   45,   -1,   47,
   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   63,  630,  631,  632,  633,
  634,  635,  636,  637,   94,   -1,   63,   -1,   -1,   -1,
   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   37,
   47,   -1,   -1,   41,   42,   43,   94,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   63,   94,   -1,   -1,
   -1,   -1,   -1,   37,   -1,   63,   -1,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,  630,
  631,  632,  633,  634,  635,  636,  637,   94,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   37,   94,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   94,   63,   -1,   -1,   37,   -1,   -1,   -1,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   63,   -1,   94,   -1,   37,   -1,   -1,   -1,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   63,   94,   37,   -1,   -1,   -1,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   -1,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   -1,   -1,   -1,   -1,   63,   -1,
   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,
  632,  633,  634,  635,  636,  637,   -1,   -1,   -1,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   37,   94,
   -1,   -1,   -1,   42,   43,   44,   45,   37,   47,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   63,   37,   -1,   -1,   -1,   -1,   42,
   43,   -1,   45,   -1,   47,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   -1,   94,   -1,   -1,   -1,   -1,
   63,   -1,   -1,   -1,   94,  630,  631,  632,  633,  634,
  635,  636,  637,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   37,   -1,   -1,   -1,   -1,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,  630,
  631,  632,  633,  634,  635,  636,  637,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   93,
   94,   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,
  636,  637,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   -1,   -1,   -1,   -1,   -1,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   37,   -1,
   -1,   -1,   -1,   42,   43,   44,   45,   37,   47,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   37,   -1,   -1,   63,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   63,  630,  631,  632,  633,  634,  635,
  636,  637,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   37,   -1,   94,   -1,   41,   42,   43,
   -1,   45,   37,   47,   94,   -1,   41,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   94,   63,
   -1,   -1,   -1,   -1,   -1,   37,   -1,   -1,   63,   -1,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   -1,   -1,
   94,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   -1,   -1,   63,   -1,   -1,   -1,
   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,
  632,  633,  634,  635,  636,  637,   63,   94,   -1,   37,
   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   63,   -1,   94,   -1,   37,
   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   63,   94,   37,   -1,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  630,  631,  632,  633,  634,
  635,  636,  637,   63,   -1,   -1,   94,   -1,   -1,   -1,
   -1,   37,   -1,   -1,   -1,   41,   42,   43,   -1,   45,
   37,   47,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   94,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   94,   -1,
   37,   -1,   -1,   -1,   41,   42,   43,   94,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   37,   63,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   37,   -1,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   37,   -1,
   -1,   63,   41,   42,   43,   -1,   45,   94,   47,   37,
   -1,   -1,   -1,   63,   42,   43,   44,   45,   -1,   47,
   -1,   37,   -1,   -1,   63,   41,   42,   43,   -1,   45,
   -1,   47,   94,   -1,   -1,   63,  630,  631,  632,  633,
  634,  635,  636,  637,   94,   -1,   37,   63,   -1,   -1,
   41,   42,   43,   -1,   45,   94,   47,   37,   -1,   -1,
   -1,   -1,   42,   43,   44,   45,   94,   47,   -1,   37,
   -1,   -1,   63,   -1,   42,   43,   44,   45,   94,   47,
   37,   -1,   -1,   63,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   37,   -1,   -1,   63,   41,   42,   43,   -1,
   45,   -1,   47,   94,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   94,   37,   -1,   -1,   63,   41,
   42,   43,   -1,   45,   -1,   47,   94,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   -1,   -1,
   -1,   -1,   94,   -1,  630,  631,  632,  633,  634,  635,
  636,  637,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   -1,  630,  631,  632,  633,  634,
  635,  636,  637,   37,   -1,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,  630,  631,
  632,  633,  634,  635,  636,  637,   37,   -1,   -1,   63,
   41,   42,   43,   -1,   45,   37,   47,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   37,
   -1,   -1,   63,   41,   42,   43,   -1,   45,   -1,   47,
   94,   63,   -1,   -1,   37,   -1,   -1,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   63,   37,   -1,   -1,   -1,
   -1,   42,   43,   94,   45,   -1,   47,   -1,   -1,   -1,
   63,   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   37,
   -1,   -1,   63,   41,   42,   43,   94,   45,   -1,   47,
   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   94,   -1,   -1,   -1,   63,   -1,   -1,   -1,   37,
   -1,   -1,   93,   94,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   -1,   -1,   -1,   37,   63,   94,   -1,   -1,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   63,   -1,   -1,   -1,   -1,   -1,   94,   37,   -1,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   93,   94,   -1,   63,   -1,   37,   -1,   -1,   -1,   -1,
   42,   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   -1,   -1,
   -1,   63,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,
  636,  637,   94,  630,  631,  632,  633,  634,  635,  636,
  637,   37,   -1,   -1,   -1,   -1,   42,   43,   44,   45,
   37,   47,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,  630,  631,
  632,  633,  634,  635,  636,  637,   -1,   -1,   -1,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   -1,   -1,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   -1,   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,
  636,  637,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,
  631,  632,  633,  634,  635,  636,  637,   -1,   -1,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   -1,   -1,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   -1,   -1,   -1,   -1,  630,  631,  632,  633,  634,
  635,  636,  637,   37,   -1,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,  630,  631,
  632,  633,  634,  635,  636,  637,   37,   -1,   -1,   63,
   41,   42,   43,   -1,   45,   37,   47,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   37,   -1,
   -1,   -1,   63,   42,   43,   44,   45,   -1,   47,   37,
   94,   63,   -1,   -1,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   94,   -1,   63,   -1,   -1,   -1,   37,
   -1,   -1,   94,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   37,   -1,   63,   94,   41,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   -1,   -1,   -1,   -1,   -1,   63,
   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,  630,
  631,  632,  633,  634,  635,  636,  637,   -1,  630,  631,
  632,  633,  634,  635,  636,  637,   -1,   -1,   -1,   -1,
   94,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   -1,   -1,   -1,  630,
  631,  632,  633,  634,  635,  636,  637,   37,   -1,   -1,
   -1,   41,   42,   43,   -1,   45,   -1,   47,   -1,   -1,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   -1,   -1,   -1,   63,   37,   -1,   -1,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   63,   37,   -1,   -1,   94,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   -1,   63,   -1,   -1,
   -1,   94,   -1,   37,   -1,   -1,   -1,   -1,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   94,   63,
   37,   -1,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,
  632,  633,  634,  635,  636,  637,   63,   -1,   -1,   -1,
   94,   -1,   -1,   -1,   -1,   37,   -1,   -1,   -1,   -1,
   42,   43,   44,   45,   37,   47,   -1,   -1,   -1,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   94,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,
  636,  637,   94,  630,  631,  632,  633,  634,  635,  636,
  637,   94,   37,   -1,   -1,   -1,   -1,   42,   43,   -1,
   45,   37,   47,   -1,   -1,   -1,   42,   43,   44,   45,
   -1,   47,   -1,   -1,   37,   -1,   -1,   -1,   63,   42,
   43,   44,   45,   -1,   47,   37,   -1,   63,   -1,   -1,
   42,   43,   44,   45,   -1,   47,   -1,   37,   -1,   -1,
   63,   41,   42,   43,   -1,   45,   -1,   47,   93,   94,
   -1,   63,   42,   43,   44,   45,   -1,   47,   94,   -1,
   37,   -1,   -1,   63,   41,   42,   43,   -1,   45,   37,
   47,   94,   -1,   63,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   94,   37,   -1,   -1,   63,   -1,   42,   43,
   44,   45,   37,   47,   94,   63,   -1,   42,   43,   44,
   45,   -1,   47,   -1,   94,   37,   -1,   -1,   -1,   63,
   42,   43,   44,   45,   -1,   47,   -1,   94,   63,   -1,
   -1,   -1,   37,   -1,   -1,   93,   94,   42,   43,   44,
   45,   63,   47,   -1,   -1,   41,   42,   43,   -1,   45,
   94,   47,   -1,   -1,   -1,   -1,   -1,   -1,   63,   94,
   37,   -1,   -1,   -1,   41,   42,   43,   63,   45,   -1,
   47,   -1,   94,   -1,   -1,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   -1,   -1,   63,   -1,   -1,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,  630,
  631,  632,  633,  634,  635,  636,  637,   -1,  630,  631,
  632,  633,  634,  635,  636,  637,   -1,   94,   -1,   -1,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   -1,   -1,   -1,   -1,   37,   -1,   -1,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   63,   37,   -1,   -1,   -1,   -1,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   -1,   -1,   -1,   63,   37,   -1,
   -1,   94,   -1,   42,   43,   44,   45,   37,   47,   -1,
   -1,   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   93,   94,   -1,
   -1,   37,   -1,   63,   -1,   -1,   42,   43,   44,   45,
   37,   47,   -1,   -1,   -1,   42,   43,   44,   45,   -1,
   47,   -1,   -1,   -1,   -1,   94,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   37,   94,   -1,   63,   -1,   42,   43,
   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   94,   63,
   37,   -1,   -1,   -1,   -1,   42,   43,   94,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   63,   37,   -1,   93,
   94,   -1,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,
  636,  637,   -1,   63,   -1,   -1,   -1,   94,   -1,   37,
   -1,   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   94,   63,   -1,   -1,   -1,   37,
   -1,   -1,   -1,   -1,   42,   43,   44,   45,   -1,   47,
   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   -1,   -1,   -1,   -1,   63,   94,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,
  632,  633,  634,  635,  636,  637,   94,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   37,   -1,   -1,   -1,
   -1,   42,   43,   -1,   45,   37,   47,   -1,   -1,   -1,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  630,  631,  632,  633,  634,
  635,  636,  637,   94,  630,  631,  632,  633,  634,  635,
  636,  637,   94,   -1,   -1,   -1,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   -1,   -1,  630,  631,
  632,  633,  634,  635,  636,  637,   -1,   -1,   -1,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   -1,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   -1,   -1,
   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   -1,  630,  631,  632,  633,  634,
  635,  636,  637,   -1,   -1,   -1,   -1,   -1,  630,  631,
  632,  633,  634,  635,  636,  637,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  630,  631,  632,  633,  634,
  635,  636,  637,   -1,  630,  631,  632,  633,  634,  635,
  636,  637,   42,   43,   44,   45,   -1,   47,   -1,   -1,
   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   -1,   -1,   63,   -1,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   41,   42,   43,   -1,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   94,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,   43,   -1,
   45,   -1,   47,   -1,  630,  631,  632,  633,  634,  635,
  636,  637,   -1,   -1,   -1,   -1,  523,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   -1,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,
  636,  637,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   40,   -1,   41,   42,   43,   45,   45,   -1,   47,
   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   -1,   63,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   41,
   42,   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,
  630,  631,  632,  633,  634,  635,  636,  637,   41,   42,
   43,   63,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   63,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,   41,   42,
   43,   -1,   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,
   -1,   94,  630,  631,  632,  633,  634,  635,  636,  637,
   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   41,   42,   43,   -1,   45,   -1,
   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   94,   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,
  631,  632,  633,  634,  635,  636,  637,   94,  630,  631,
  632,  633,  634,  635,  636,  637,   -1,  256,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,   -1,  296,  297,  298,
  299,  300,  301,  302,  303,  304,  305,   -1,   -1,  308,
  309,   -1,   -1,   -1,  313,  314,   -1,   -1,   -1,   -1,
   -1,  320,  321,   -1,   -1,   -1,  325,  326,  327,   -1,
   -1,  330,   -1,   -1,   -1,  334,   -1,  336,   -1,   -1,
   -1,   -1,  341,   -1,  343,  344,   -1,  346,  347,   -1,
   -1,  350,   -1,  352,  353,  354,   -1,  356,   -1,   -1,
   -1,   -1,   -1,  362,   -1,   -1,   -1,   -1,  367,   -1,
   -1,  370,  331,   -1,   -1,   -1,  375,  376,   -1,   -1,
   -1,   -1,  381,  382,  383,   -1,  385,  386,   -1,   -1,
  389,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  397,   -1,
   -1,   -1,  401,   -1,   -1,   -1,   -1,   -1,   -1,  408,
  409,   -1,  411,   -1,   -1,   -1,   -1,   -1,  417,   -1,
   -1,   -1,  421,  422,   40,  424,  425,  426,  427,   45,
  630,  631,  632,  633,  634,  635,  636,  637,  437,  438,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  452,  630,  631,  632,  633,  634,  635,
  636,  637,  630,  631,  632,  633,  634,  635,  636,  637,
  469,  470,   -1,   -1,   -1,   -1,  475,  476,  477,   -1,
  479,  480,  481,  482,   -1,  444,   -1,   -1,   -1,   -1,
  489,  490,  491,  492,  493,   -1,  495,   -1,   -1,   -1,
  499,  500,   41,   42,   43,  504,   45,  506,   47,   -1,
   -1,  510,   41,   42,   43,   -1,   45,   -1,   47,  478,
  519,  520,  521,  522,   63,   -1,   -1,  526,   -1,   -1,
   -1,  530,   -1,  532,   63,   -1,  535,  536,  537,  538,
  539,  540,   -1,  542,  543,  630,  631,  632,  633,  634,
  635,  636,  637,   -1,   -1,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,  567,  568,
  569,  570,  571,  572,  573,  574,  575,   -1,   -1,   -1,
  579,  580,   -1,   -1,   -1,   -1,   -1,   -1,  547,  548,
  549,  550,   -1,  552,  553,  554,  555,  556,  557,  558,
  559,  560,  561,  562,  563,  564,  565,  566,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  619,   -1,   -1,   -1,   -1,  624,  625,  626,  627,  628,
  629,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
  639,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,   -1,
  296,  297,  298,  299,  300,  301,  302,  303,  630,  631,
  632,  633,  634,  635,  636,  637,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   -1,   -1,  334,   -1,
   -1,   -1,   -1,  339,   -1,   -1,   -1,   -1,  344,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   -1,   -1,   45,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   -1,   41,   42,   43,
   -1,   45,  378,   47,   -1,   -1,   -1,   -1,   -1,  385,
   -1,   -1,   -1,   -1,   -1,   -1,  392,   -1,   -1,   63,
   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   -1,   41,   42,   43,   -1,   45,  413,   47,   -1,
   -1,   -1,  418,   41,   42,   43,  422,   45,  424,   47,
   94,   -1,  428,   -1,   63,   41,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   63,   -1,   -1,   -1,  445,
   -1,   -1,  448,   -1,   -1,   -1,   -1,   63,   41,   42,
   43,   -1,   45,   -1,   47,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,   -1,
   63,   -1,   -1,   41,   42,   43,  482,   45,   94,   47,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   41,   42,
   43,   -1,   45,  499,   47,   63,   41,   42,   43,   -1,
   45,   94,   47,   -1,   -1,   41,   42,   43,   -1,   45,
   63,   47,   -1,  519,   -1,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   94,   63,  534,   -1,
   -1,   -1,   -1,  539,  540,  541,   -1,   -1,   -1,   -1,
   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,
   -1,  567,  568,  569,  570,  571,  572,  573,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,   -1,  296,  297,  298,
  299,  300,  301,  302,  303,   -1,   -1,   -1,   -1,   -1,
   -1,  627,  628,  629,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  639,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  339,   -1,   -1,   -1,   -1,  344,   -1,   -1,   -1,   -1,
  349,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,
   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  378,
   -1,   -1,   -1,   -1,   -1,   -1,  385,   -1,   -1,   -1,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
   -1,  410,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   41,   42,   43,   -1,   45,  424,   47,   -1,   -1,  428,
   -1,   -1,   -1,   -1,   63,   41,   42,   43,   -1,   45,
   -1,   47,   63,   -1,   -1,   -1,  445,   -1,   -1,  448,
   41,   42,   43,   -1,   45,   -1,   47,   63,   41,   42,
   43,   -1,   45,   -1,   47,   94,   -1,   -1,   -1,   -1,
   -1,   -1,   63,   94,   -1,   41,   42,   43,   -1,   45,
   63,   47,   -1,  482,   -1,   -1,   -1,   -1,   94,  488,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   -1,
  499,   -1,   -1,   94,   41,   42,   43,   -1,   45,   -1,
   47,   94,   41,   42,   43,   -1,   45,   -1,   47,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,   94,   -1,
   -1,   -1,   -1,   -1,   63,   -1,   -1,   -1,   -1,   -1,
  539,  540,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   94,   -1,   -1,  567,  568,
  569,  570,  571,  572,  573,  257,  258,  259,  260,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,   -1,  296,  297,  298,  299,  300,  301,
  302,  303,   -1,   -1,   -1,   -1,   -1,   -1,  627,  628,
  629,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  639,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,  633,
  634,  635,  636,  637,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  344,   -1,   -1,   -1,   -1,  349,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,
   45,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
  372,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   -1,   -1,   -1,  385,  630,  631,  632,  633,  634,  635,
  636,  637,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   -1,   -1,   -1,   -1,
  422,   -1,  424,   -1,   -1,   -1,  428,   -1,   -1,   -1,
   -1,   -1,  630,  631,  632,  633,  634,  635,  636,  637,
   -1,   -1,   -1,  445,   -1,   -1,  448,  630,  631,  632,
  633,  634,  635,  636,  637,  630,  631,  632,  633,  634,
  635,  636,  637,   -1,  630,  631,  632,  633,  634,  635,
  636,  637,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  482,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  499,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  539,  540,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  567,  568,  569,  570,  571,
  572,  573,  257,  258,  259,  260,  261,  262,  263,  264,
  265,  266,  267,  268,  269,  270,  271,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
   -1,  296,  297,  298,  299,  300,  301,  302,  303,   42,
   43,   44,   45,   -1,   47,  627,  628,  629,   -1,   -1,
   -1,   -1,   -1,   -1,  319,   -1,   -1,  639,   -1,   -1,
   63,  329,  330,  331,   41,   42,   43,   -1,   45,   -1,
   47,   -1,  340,   -1,   -1,   -1,   -1,   -1,   -1,  344,
   -1,   -1,   -1,   -1,  349,   -1,   63,   -1,   -1,   -1,
   -1,   94,   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,
   -1,  630,  631,  632,  633,  634,  635,  636,  637,  630,
  631,  632,  633,  634,  635,  636,  637,   94,   -1,   -1,
  385,   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,
  636,  637,   -1,  401,   -1,   -1,   -1,   -1,   -1,  630,
  631,  632,  633,  634,  635,  636,  637,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   -1,  422,   -1,  424,
   -1,   -1,   -1,  428,  630,  631,  632,  633,  634,  635,
  636,  637,   -1,   -1,   -1,   -1,  444,   -1,   -1,   -1,
  445,   -1,   -1,  448,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,  630,  631,  632,  633,  634,  635,  636,  637,   -1,
  478,   -1,   -1,   -1,   -1,   -1,   -1,  482,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  499,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  539,  540,   -1,   -1,   -1,  547,
  548,  549,  550,   -1,  552,  553,  554,  555,  556,  557,
  558,  559,  560,  561,  562,  563,  564,  565,  566,   -1,
   -1,   -1,  567,  568,  569,  570,  571,  572,  573,  257,
  258,  259,  260,  261,  262,  263,  264,  265,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  294,   -1,  296,  297,
  298,  299,  300,  301,  302,  303,   42,   43,   44,   45,
   -1,   47,  627,  628,  629,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  639,   -1,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  338,  339,   -1,   -1,   -1,   -1,  344,   -1,   42,   43,
   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   94,   42,
   43,   44,   45,   -1,   47,   -1,   -1,   -1,   -1,   63,
   42,   43,   44,   45,  372,   47,   -1,   -1,   -1,   -1,
   63,   -1,   -1,   -1,   -1,   -1,   -1,  385,   -1,   -1,
   -1,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   94,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   94,   -1,  422,   -1,  424,  257,  258,  259,
  260,  261,  262,  263,  264,  265,  266,  267,  268,  269,
  270,  271,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,   -1,  296,  297,  298,  299,
  300,  301,  302,  303,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  482,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  499,   -1,   -1,  502,  503,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  344,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,   -1,
   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  539,  540,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  385,   -1,   -1,  388,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  567,
  568,  569,  570,  571,  572,  573,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  422,   -1,  424,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,  636,
  637,   42,   43,   -1,   45,  445,   47,   -1,  448,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   58,   -1,  627,
  628,  629,   63,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  639,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  482,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   94,   -1,   -1,   -1,   -1,   -1,  499,
   -1,   -1,  502,   -1,   -1,   -1,   -1,   42,   43,   -1,
   45,   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  539,
  540,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   94,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  567,  568,  569,
  570,  571,  572,  573,  257,  258,  259,  260,  261,  262,
  263,  264,  265,  266,  267,  268,  269,  270,  271,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,   -1,  296,  297,  298,  299,  300,  301,  302,
  303,   -1,   -1,   -1,   -1,   -1,   -1,  627,  628,  629,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  639,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  344,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  385,   -1,   -1,  388,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  630,  631,  632,  633,  634,  635,
  636,  637,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  422,
   -1,  424,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,
   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  445,   -1,   -1,  448,  630,  631,  632,  633,
  634,  635,  636,  637,   -1,   -1,   -1,  630,  631,  632,
  633,  634,  635,  636,  637,   -1,   -1,   -1,  630,  631,
  632,  633,  634,  635,  636,  637,   -1,   -1,   -1,  482,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  499,   -1,   -1,  502,
   -1,   -1,   -1,   -1,   40,   -1,   -1,   -1,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  539,  540,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  567,  568,  569,  570,  571,  572,
  573,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,   -1,
  296,  297,  298,  299,  300,  301,  302,  303,   -1,   -1,
   -1,   -1,   -1,   -1,  627,  628,  629,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  639,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,
  261,  262,  263,  264,  265,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,   -1,  296,  297,  298,  299,  300,
  301,  302,  303,   -1,   -1,   -1,   -1,   -1,   -1,  385,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  630,
  631,  632,  633,  634,  635,  636,  637,   -1,   -1,   -1,
   -1,  257,  258,  259,  260,  261,  262,  263,  264,  265,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  283,  284,  285,
  286,  287,  288,  289,  290,  291,  292,  293,  294,   -1,
  296,  297,  298,  299,  300,  301,  302,  303,   -1,   -1,
   -1,   -1,   -1,   -1,  385,  630,  631,  632,  633,  634,
  635,  636,  637,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  482,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  499,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  385,
   -1,   -1,   -1,  539,  540,   -1,   -1,   -1,   -1,  545,
  546,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  482,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  567,  568,  569,  570,  571,  572,  573,  499,   -1,
   -1,  577,  578,   -1,   -1,   -1,   40,   -1,   -1,   -1,
   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  539,  540,
   -1,   -1,   -1,   -1,  545,  546,   -1,   -1,   -1,   -1,
   -1,  627,  628,  629,   -1,   -1,  482,   -1,   -1,   -1,
   -1,   -1,   -1,  639,   -1,   -1,  567,  568,  569,  570,
  571,  572,  573,  499,   -1,   -1,  577,  578,   -1,   -1,
   -1,   40,   -1,   -1,   -1,   -1,   45,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  530,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  539,  540,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  627,  628,  629,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  639,   -1,
   -1,  567,  568,  569,  570,  571,  572,  573,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,   -1,  296,  297,  298,
  299,  300,  301,  302,  303,   -1,   -1,   -1,   -1,   -1,
   -1,  627,  628,  629,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  639,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  257,  258,  259,  260,  261,  262,  263,
  264,  265,  266,  267,  268,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,   -1,  296,  297,  298,  299,  300,  301,  302,  303,
   -1,   -1,   -1,   -1,   -1,   -1,  385,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,
  259,  260,  261,  262,  263,  264,  265,  266,  267,  268,
  269,  270,  271,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  287,  288,
  289,  290,  291,  292,  293,  294,   -1,  296,  297,  298,
  299,  300,  301,  302,  303,   -1,   -1,   -1,   -1,   -1,
   -1,  385,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  315,
   -1,  317,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  482,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  339,   -1,   -1,   -1,   -1,  344,   -1,
  499,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   40,   -1,
   -1,   -1,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  530,  378,   -1,  380,   -1,  385,   -1,   -1,   -1,
  539,  540,   -1,   -1,   -1,   -1,  392,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  482,   -1,
   -1,   -1,   -1,   -1,  410,   -1,   -1,  413,  567,  568,
  569,  570,  571,  572,  573,  499,   -1,   -1,  424,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  445,
   -1,   -1,  448,  449,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  539,  540,   -1,   -1,   -1,
   -1,  467,  468,   -1,   -1,   -1,   -1,   -1,  627,  628,
  629,   -1,   -1,  482,   -1,   -1,   -1,   -1,   -1,   -1,
  639,   -1,   -1,  567,  568,  569,  570,  571,  572,  573,
  499,   -1,   -1,   -1,   -1,  501,   -1,  503,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  514,  515,
   -1,   -1,  518,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  530,   -1,   -1,   -1,  534,   -1,
  539,  540,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  627,  628,  629,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  639,   -1,   -1,  567,  568,
  569,  570,  571,  572,  573,  257,  258,  259,  260,  261,
  262,  263,  264,  265,  266,  267,  268,  269,  270,  271,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,  293,  294,   -1,  296,  297,  298,  299,  300,  301,
  302,  303,   -1,   -1,  344,  345,   -1,   -1,  627,  628,
  629,   -1,  628,   -1,  344,  345,   -1,   -1,   -1,   -1,
  639,   -1,   -1,   -1,   -1,   -1,  366,   -1,   -1,   -1,
   -1,   -1,  372,   -1,   -1,   -1,  366,   -1,  378,   -1,
  380,   -1,  372,  344,  345,   -1,   -1,   -1,  378,   -1,
  380,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  399,
   -1,   -1,   -1,   -1,   -1,  366,   -1,   -1,   -1,  399,
   -1,  372,   -1,   -1,   -1,   -1,   -1,  378,   -1,  380,
   -1,   -1,  422,  385,  424,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  422,   -1,  424,   -1,  436,   -1,  399,   -1,
   -1,   -1,   -1,   -1,   -1,  445,  436,   -1,  448,   -1,
   -1,   -1,   -1,   -1,   -1,  445,   -1,   -1,  448,   -1,
   -1,  422,   -1,  424,   -1,   -1,   -1,  467,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  436,   -1,  467,   -1,   -1,
   -1,   -1,   -1,   -1,  445,   -1,   -1,  448,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  502,  503,   -1,   -1,  467,   -1,   -1,   -1,
   -1,   -1,  502,  503,   -1,   -1,   -1,   -1,   -1,   -1,
  482,   -1,  522,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  530,   -1,  522,   -1,   -1,   -1,   -1,  499,   -1,   -1,
  530,  502,  503,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  522,   -1,   -1,  564,   -1,   -1,   -1,   -1,  530,
   -1,   -1,   -1,   -1,  564,   -1,   -1,  539,  540,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  564,   -1,  567,  568,  569,  570,  571,
  572,  573,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  627,  628,  629,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  639,
};
#define YYFINAL 154
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 639
#if YYDEBUG
char *yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,"'\\n'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'%'",0,0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,0,0,
0,0,0,0,0,"':'",0,0,"'='",0,"'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"ABS","ACOS","ASIN","ATAN","ATAN2","CEIL","COS",
"DEG","DX","DY","ERF","ERFC","EXP","FLOOR","HYPOT","INDEX","INT","INVN","INVT",
"IRAND","LGAMMA","LN","LOG","LOGISTIC","MAXP","MINP","MOD","NORM","NORMP","PI",
"RAD","RAND","RNORM","SETNO","SIN","SQR","SQRT","TAN","INUM","VX1","VX2","VY1",
"VY2","WX1","WX2","WY1","WY2","DELAYP","DOUBLEBUFFER","DOWN","ABSOLUTE","ABORT",
"ACTIVATE","ACTIVE","ALT","ALTERNATE","ALTXAXIS","ALTYAXIS","ANGLE","ANNOTATE",
"APPEND","AREA","ARROW","AUTO","AUTOSCALE","AUTOTICKS","AVG","AXIS","AXES",
"BACKBUFFER","BACKGROUND","BAR","BATCH","BLOCK","BIN","BOTH","BOTTOM","BOX",
"BOXPLOT","CD","CELLS","CENTER","CHAR","CHRSTR","CLEAR","CLICK","CMAP","COLOR",
"COMMENT","COPY","CYCLE","DECIMAL","DEF","DEFAULT","DELETE","DEVICE","DFT",
"DIFFERENCE","DISK","DRAW2","DROP","DXDX","DXP","DYDY","DYP","ECHO","EDIT",
"ELSE","END","ERRORBAR","EXIT","EXPONENTIAL","FALSEP","FFT","FILEP","FILL",
"FIND","FIXEDPOINT","FLUSH","FOCUS","FOLLOWS","FONTP","FOREGROUND","FORMAT",
"FRONTBUFFER","FRAMEP","GETP","GRAPH","GRAPHNO","GRAPHS","GRAPHTYPE","GRID",
"HARDCOPY","HBAR","HBOXPLOT","HGAP","HIDDEN","HORIZONTAL","HPGLL","HPGLP",
"HISTO","IF","IGNORE","IHL","IMAGE","IN","INIT","INITGRAPHICS","INOUT",
"INTEGRATE","INTERP","INVDFT","INVFFT","JUST","KILL","LABEL","LAYOUT","LEAVE",
"LEAVEGRAPHICS","LEFT","LEGEND","LENGTH","LEVEL","LEVELS","LINE","LINESTYLE",
"LINETO","LINEWIDTH","LINK","LOAD","LOCATOR","LOCTYPE","LOGX","LOGY","LOGXY",
"MAJOR","MIFL","MIFP","MINOR","MISSINGP","MOVE","MOVE2","MOVETO","NEGATE","NO",
"NONE","NORMAL","NXY","OFF","OFFSETX","OFFSETY","ON","OP","ORIENT","OUT","PAGE",
"PARA","PARALLEL","PARAMETERS","PARAMS","PATTERN","PERIMETER","PERP",
"PERPENDICULAR","PIE","PIPE","PLACE","POINT","POLAR","POWER","PREC","PREPEND",
"PRINT","PS","PSCOLORP","PSMONOP","PSCOLORL","PSMONOL","PUSH","POP","PUTP",
"RAWSPICE","READ","REDRAW","REGRESS","REGNUM","REGIONS","RENDER","REVERSE",
"RIGHT","RISER","ROT","RUNAVG","RUNMED","RUNSTD","RUNMIN","RUNMAX","SAMPLE",
"SAVEALL","SCALE","SCIENTIFIC","SET","SETNUM","SETS","SIGN","SIZE","SKIP",
"SLEEP","SLICE","SOURCE","SPEC","SPECIFIED","SPECTRUM","STACK","STACKEDBAR",
"STACKEDHBAR","STACKEDLINE","STAGGER","START","STARTTYPE","STATUS","STOP",
"STRING","SUBTITLE","SWAPBUFFER","SYMBOL","TICKP","TICKLABEL","TICKMARKS",
"TITLE","TO","TOP","TRUEP","TYPE","UP","VELOCITY","VERTICAL","VGAP","VIEW",
"WITH","WORLD","WRITE","X","X0","X1","XAXES","XAXIS","XCOR","XMAX","XMIN","XY",
"XYARC","XYBOX","XYBOXPLOT","XYFIXED","XYHILO","XYRT","XYSEG","XYSTRING","XYDX",
"XYDY","XYDXDX","XYDYDY","XYDXDY","XYX2Y2","XYXX","XYYY","XYZ","XYZW","XYUV",
"Y","Y0","Y1","Y2","Y3","Y4","Y5","YAXES","YAXIS","YES","YMAX","YMIN",
"ZEROXAXIS","ZEROYAXIS","ABOVE","BELOW","POLYI","POLYO","GENERAL","DDMMYY",
"MMDDYY","MMYY","MMDD","MONTHDAY","DAYMONTH","MONTHS","MONTHL","DAYOFWEEKS",
"DAYOFWEEKL","DAYOFYEAR","HMS","MMDDHMS","MMDDYYHMS","DEGREESLON",
"DEGREESMMLON","DEGREESMMSSLON","MMSSLON","DEGREESLAT","DEGREESMMLAT",
"DEGREESMMSSLAT","MMSSLAT","DOT","STAR","PLUS","CROSS","CIRCLE","SQUARE",
"DIAMOND","TRIANGLE1","TRIANGLE2","TRIANGLE3","TRIANGLE4","SPLINE","LANDSCAPE",
"PORTRAIT","FREE","FIXED","STATUSBAR","LOCATORBAR","TOOLBAR","VAR","NUMBER",
"FITPARM","OR","AND","GT","LT","LE","GE","EQ","NE","UMINUS","NOT",
};
char *yyrule[] = {
"$accept : list",
"list :",
"list : asgn '\\n'",
"list : vasgn '\\n'",
"list : rasgn '\\n'",
"list : expr '\\n'",
"list : vexpr '\\n'",
"list : parmset '\\n'",
"list : regionset '\\n'",
"list : setaxis '\\n'",
"list : setvelocity '\\n'",
"list : set_setprop '\\n'",
"list : setprint '\\n'",
"list : error '\\n'",
"setprint : PRINT printer CHRSTR",
"setprint : PRINT TO printer CHRSTR",
"setprint : PRINT TO printer",
"setprint : DEVICE NUMBER",
"setprint : HARDCOPY DEVICE NUMBER",
"setprint : HARDCOPY",
"setprint : PS LINEWIDTH NUMBER",
"printer : PSMONOP",
"printer : PSMONOL",
"printer : MIFP",
"printer : MIFL",
"printer : HPGLP",
"printer : HPGLL",
"printer : HARDCOPY",
"printer : FILEP",
"regionset : REGNUM onoff",
"regionset : REGNUM TYPE regiontype",
"regionset : REGNUM COLOR NUMBER",
"regionset : REGNUM LINESTYLE NUMBER",
"regionset : REGNUM LINEWIDTH NUMBER",
"regionset : REGNUM LINE expr ',' expr ',' expr ',' expr",
"regionset : REGNUM XY expr ',' expr",
"regionset : LINK REGNUM TO GRAPHNO",
"parmset : REDRAW",
"parmset : AUTO REDRAW onoff",
"parmset : CD CHRSTR",
"parmset : ECHO CHRSTR",
"parmset : BACKGROUND COLOR NUMBER",
"parmset : CMAP NUMBER ',' NUMBER ',' NUMBER ',' NUMBER",
"parmset : EXIT",
"parmset : PAGE LAYOUT pagelayout",
"parmset : STATUSBAR onoff",
"parmset : TOOLBAR onoff",
"parmset : LOCATORBAR onoff",
"parmset : DRAW2 expr ',' expr",
"parmset : MOVE2 expr ',' expr",
"parmset : SYMBOL expr ',' expr ',' NUMBER",
"parmset : COLOR NUMBER",
"parmset : LINEWIDTH NUMBER",
"parmset : LINESTYLE NUMBER",
"parmset : WRITE STRING expr ',' expr ',' CHRSTR",
"parmset : PAGE direction",
"parmset : PAGE NUMBER",
"parmset : PAGE INOUT NUMBER",
"parmset : LINK PAGE onoff",
"parmset : DOUBLEBUFFER torf",
"parmset : FRONTBUFFER torf",
"parmset : BACKBUFFER torf",
"parmset : SWAPBUFFER",
"parmset : SLEEP NUMBER",
"parmset : DELAYP NUMBER",
"parmset : ABORT torf",
"parmset : GETP CHRSTR",
"parmset : PUTP CHRSTR",
"parmset : WITH GRAPHNO",
"parmset : WITH SETNUM",
"parmset : SETNUM LINK sourcetype CHRSTR",
"parmset : GRAPHNO '.' SETNUM LINK sourcetype CHRSTR",
"parmset : SETNUM LINK onoff",
"parmset : GRAPHNO '.' SETNUM LINK onoff",
"parmset : ACTIVATE SETNUM NUMBER",
"parmset : SETNUM POINT expr ',' expr",
"parmset : GRAPHNO '.' SETNUM POINT expr ',' expr",
"parmset : SETNUM DROP NUMBER ',' NUMBER",
"parmset : GRAPHNO '.' SETNUM DROP NUMBER ',' NUMBER",
"parmset : COPY SETNUM TO SETNUM",
"parmset : COPY GRAPHNO '.' SETNUM TO GRAPHNO '.' SETNUM",
"parmset : MOVE SETNUM TO SETNUM",
"parmset : MOVE GRAPHNO '.' SETNUM TO GRAPHNO '.' SETNUM",
"parmset : KILL SETNUM",
"parmset : KILL SETS",
"parmset : KILL GRAPHNO",
"parmset : KILL GRAPHS",
"parmset : FLUSH",
"parmset : LOAD VAR NUMBER ',' expr ',' expr",
"parmset : REGRESS '(' SETNUM ',' NUMBER ')'",
"parmset : runtype '(' SETNUM ',' NUMBER ')'",
"parmset : ffttype '(' SETNUM ',' NUMBER ')'",
"parmset : SPLINE '(' SETNUM ',' expr ',' expr ',' NUMBER ')'",
"parmset : HISTO '(' SETNUM ',' expr ',' expr ',' NUMBER ')'",
"parmset : DIFFERENCE '(' SETNUM ',' NUMBER ')'",
"parmset : INT '(' SETNUM ')'",
"parmset : AUTOSCALE",
"parmset : AUTOSCALE XAXES",
"parmset : AUTOSCALE YAXES",
"parmset : AUTOSCALE SETNUM",
"parmset : LOCATOR onoff",
"parmset : FOCUS GRAPHNO",
"parmset : FOCUS onoff",
"parmset : FOCUS SET",
"parmset : FOCUS FOLLOWS",
"parmset : FOCUS CLICK",
"parmset : SOURCE sourcetype",
"parmset : TYPE xytype",
"parmset : READ CHRSTR",
"parmset : READ BATCH CHRSTR",
"parmset : READ BLOCK CHRSTR",
"parmset : READ BLOCK sourcetype CHRSTR",
"parmset : BLOCK xytype CHRSTR",
"parmset : READ xytype CHRSTR",
"parmset : READ xytype sourcetype CHRSTR",
"parmset : READ IMAGE CHRSTR",
"parmset : WRITE IMAGE CHRSTR",
"parmset : IMAGE XY NUMBER ',' NUMBER",
"parmset : WRITE SETNUM",
"parmset : WRITE SETNUM FORMAT CHRSTR",
"parmset : WRITE SETNUM FILEP CHRSTR",
"parmset : WRITE SETNUM FILEP CHRSTR FORMAT CHRSTR",
"parmset : SAVEALL CHRSTR",
"parmset : PUSH",
"parmset : POP",
"parmset : CYCLE",
"parmset : STACK NUMBER",
"parmset : STACK WORLD expr ',' expr ',' expr ',' expr TICKP expr ',' expr ',' expr ',' expr",
"parmset : CLEAR STACK",
"parmset : CLEAR BOX",
"parmset : WITH BOX",
"parmset : WITH BOX NUMBER",
"parmset : BOX onoff",
"parmset : BOX GRAPHNO",
"parmset : BOX expr ',' expr ',' expr ',' expr",
"parmset : BOX LOCTYPE worldview",
"parmset : BOX LINESTYLE NUMBER",
"parmset : BOX LINEWIDTH NUMBER",
"parmset : BOX COLOR NUMBER",
"parmset : BOX FILL filltype",
"parmset : BOX FILL COLOR NUMBER",
"parmset : BOX FILL PATTERN NUMBER",
"parmset : BOX DEF",
"parmset : WITH LINE",
"parmset : WITH LINE NUMBER",
"parmset : CLEAR LINE",
"parmset : LINE onoff",
"parmset : LINE GRAPHNO",
"parmset : LINE expr ',' expr ',' expr ',' expr",
"parmset : LINE LOCTYPE worldview",
"parmset : LINE LINEWIDTH NUMBER",
"parmset : LINE LINESTYLE NUMBER",
"parmset : LINE COLOR NUMBER",
"parmset : LINE ARROW NUMBER",
"parmset : LINE ARROW SIZE NUMBER",
"parmset : LINE ARROW TYPE NUMBER",
"parmset : LINE DEF",
"parmset : CLEAR STRING",
"parmset : WITH STRING",
"parmset : WITH STRING NUMBER",
"parmset : STRING onoff",
"parmset : STRING GRAPHNO",
"parmset : STRING expr ',' expr",
"parmset : STRING LOCTYPE worldview",
"parmset : STRING LINEWIDTH NUMBER",
"parmset : STRING COLOR NUMBER",
"parmset : STRING ROT NUMBER",
"parmset : STRING FONTP NUMBER",
"parmset : STRING JUST NUMBER",
"parmset : STRING CHAR SIZE NUMBER",
"parmset : STRING DEF CHRSTR",
"parmset : DEFAULT LINESTYLE NUMBER",
"parmset : DEFAULT LINEWIDTH NUMBER",
"parmset : DEFAULT COLOR NUMBER",
"parmset : DEFAULT CHAR SIZE NUMBER",
"parmset : DEFAULT FONTP NUMBER",
"parmset : DEFAULT FONTP SOURCE NUMBER",
"parmset : DEFAULT SYMBOL SIZE NUMBER",
"parmset : WORLD expr ',' expr ',' expr ',' expr",
"parmset : WORLD XMIN expr",
"parmset : WORLD XMAX expr",
"parmset : WORLD YMIN expr",
"parmset : WORLD YMAX expr",
"parmset : VIEW expr ',' expr ',' expr ',' expr",
"parmset : VIEW XMIN NUMBER",
"parmset : VIEW XMAX NUMBER",
"parmset : VIEW YMIN NUMBER",
"parmset : VIEW YMAX NUMBER",
"parmset : TITLE CHRSTR",
"parmset : TITLE FONTP NUMBER",
"parmset : TITLE SIZE NUMBER",
"parmset : TITLE COLOR NUMBER",
"parmset : TITLE LINEWIDTH NUMBER",
"parmset : SUBTITLE CHRSTR",
"parmset : SUBTITLE FONTP NUMBER",
"parmset : SUBTITLE SIZE NUMBER",
"parmset : SUBTITLE COLOR NUMBER",
"parmset : SUBTITLE LINEWIDTH NUMBER",
"parmset : GRAPHS MAXP SETS NUMBER",
"parmset : LEGEND onoff",
"parmset : LEGEND LOCTYPE worldview",
"parmset : LEGEND LAYOUT NUMBER",
"parmset : LEGEND VGAP NUMBER",
"parmset : LEGEND HGAP NUMBER",
"parmset : LEGEND LENGTH NUMBER",
"parmset : LEGEND BOX onoff",
"parmset : LEGEND BOX FILL onoff",
"parmset : LEGEND BOX FILL WITH colpat",
"parmset : LEGEND BOX FILL colpat NUMBER",
"parmset : LEGEND BOX COLOR NUMBER",
"parmset : LEGEND BOX LINESTYLE NUMBER",
"parmset : LEGEND BOX LINEWIDTH NUMBER",
"parmset : LEGEND expr ',' expr",
"parmset : LEGEND X1 expr",
"parmset : LEGEND Y1 expr",
"parmset : LEGEND CHAR SIZE NUMBER",
"parmset : LEGEND FONTP NUMBER",
"parmset : LEGEND LINESTYLE NUMBER",
"parmset : LEGEND LINEWIDTH NUMBER",
"parmset : LEGEND COLOR NUMBER",
"parmset : LEGEND STRING NUMBER CHRSTR",
"parmset : FRAMEP onoff",
"parmset : FRAMEP TYPE NUMBER",
"parmset : FRAMEP LINESTYLE NUMBER",
"parmset : FRAMEP LINEWIDTH NUMBER",
"parmset : FRAMEP COLOR NUMBER",
"parmset : FRAMEP FILL onoff",
"parmset : FRAMEP BACKGROUND COLOR NUMBER",
"parmset : GRAPHNO onoff",
"parmset : GRAPHNO LABEL onoff",
"parmset : GRAPHNO AUTOSCALE TYPE AUTO",
"parmset : GRAPHNO AUTOSCALE TYPE SPEC",
"parmset : GRAPHNO AUTOSCALE torf",
"parmset : GRAPHNO HIDDEN torf",
"parmset : GRAPHNO TYPE graphtype",
"parmset : GRAPHNO BAR SIZE NUMBER",
"parmset : GRAPHNO STACKEDBAR SIZE NUMBER",
"parmset : GRAPHNO FIXEDPOINT onoff",
"parmset : GRAPHNO FIXEDPOINT FORMAT formatchoice formatchoice",
"parmset : GRAPHNO FIXEDPOINT PREC NUMBER ',' NUMBER",
"parmset : GRAPHNO FIXEDPOINT XY expr ',' expr",
"parmset : GRAPHNO FIXEDPOINT TYPE NUMBER",
"parmset : GRAPHNO MAXP SETS NUMBER",
"setvelocity : VELOCITY SCALE NUMBER",
"setvelocity : VELOCITY LEGEND onoff",
"setvelocity : VELOCITY LINEWIDTH NUMBER",
"setvelocity : VELOCITY LINESTYLE NUMBER",
"setvelocity : VELOCITY COLOR NUMBER",
"setvelocity : VELOCITY LOCTYPE worldview",
"setvelocity : VELOCITY ARROW TYPE NUMBER",
"xytype : XY",
"xytype : XYARC",
"xytype : XYBOX",
"xytype : XYBOXPLOT",
"xytype : XYHILO",
"xytype : XYRT",
"xytype : XYSEG",
"xytype : XYSTRING",
"xytype : XYDX",
"xytype : XYDY",
"xytype : XYDXDX",
"xytype : XYDYDY",
"xytype : XYDXDY",
"xytype : XYX2Y2",
"xytype : XYXX",
"xytype : XYYY",
"xytype : XYZ",
"xytype : XYZW",
"xytype : XYUV",
"xytype : NXY",
"xytype : BIN",
"xytype : RAWSPICE",
"graphtype : XY",
"graphtype : LOGX",
"graphtype : LOGY",
"graphtype : LOGXY",
"graphtype : BAR",
"graphtype : HBAR",
"graphtype : STACKEDBAR",
"graphtype : STACKEDHBAR",
"graphtype : POLAR",
"graphtype : XYFIXED",
"graphtype : BOXPLOT",
"graphtype : HBOXPLOT",
"pagelayout : FREE",
"pagelayout : LANDSCAPE",
"pagelayout : PORTRAIT",
"pagelayout : FIXED",
"regiontype : ABOVE",
"regiontype : BELOW",
"regiontype : LEFT",
"regiontype : RIGHT",
"regiontype : POLYI",
"regiontype : POLYO",
"set_setprop : selectsets setprop",
"setprop : onoff",
"setprop : IGNORE",
"setprop : TYPE xytype",
"setprop : MISSINGP expr",
"setprop : PREC NUMBER",
"setprop : FORMAT formatchoice",
"setprop : SYMBOL expr",
"setprop : SYMBOL FILL NUMBER",
"setprop : SYMBOL CENTER torf",
"setprop : SYMBOL SIZE expr",
"setprop : SYMBOL CHAR NUMBER",
"setprop : SYMBOL SKIP NUMBER",
"setprop : SYMBOL COLOR expr",
"setprop : SYMBOL LINEWIDTH NUMBER",
"setprop : SYMBOL LINESTYLE NUMBER",
"setprop : prop NUMBER",
"setprop : FILL NUMBER",
"setprop : FILL WITH colpat",
"setprop : FILL colpat NUMBER",
"setprop : SKIP NUMBER",
"setprop : ERRORBAR LENGTH NUMBER",
"setprop : ERRORBAR TYPE opchoice",
"setprop : ERRORBAR LINEWIDTH NUMBER",
"setprop : ERRORBAR LINESTYLE NUMBER",
"setprop : ERRORBAR RISER onoff",
"setprop : ERRORBAR RISER LINEWIDTH NUMBER",
"setprop : ERRORBAR RISER LINESTYLE NUMBER",
"setprop : XYZ expr ',' expr",
"setprop : COMMENT CHRSTR",
"setaxis : axis",
"setaxis : axis axisfeature",
"setaxis : allaxes",
"setaxis : GRAPHS axis",
"setaxis : GRAPHS axis axisfeature",
"setaxis : GRAPHS allaxes",
"axis : XAXIS",
"axis : YAXIS",
"axis : ALTXAXIS",
"axis : ALTYAXIS",
"axis : ZEROXAXIS",
"axis : ZEROYAXIS",
"allaxes : AXES axesprops",
"allaxes : XAXES axesprops",
"allaxes : YAXES axesprops",
"axesprops : onoff",
"axesprops : COLOR NUMBER",
"axesprops : LINEWIDTH NUMBER",
"axesprops : LINESTYLE NUMBER",
"axesprops : FONTP NUMBER",
"axesprops : CHAR SIZE NUMBER",
"axesprops : GRID onoff",
"axisfeature : TICKP tickdesc",
"axisfeature : TICKLABEL ticklabeldesc",
"axisfeature : LABEL axislabeldesc",
"axisfeature : BAR axisbardesc",
"axisfeature : onoff",
"tickdesc : tickattr",
"tickdesc : tickdesc tickattr",
"tickattr : onoff",
"tickattr : MAJOR onoff",
"tickattr : MINOR onoff",
"tickattr : MAJOR expr",
"tickattr : MINOR expr",
"tickattr : OFFSETX expr",
"tickattr : OFFSETY expr",
"tickattr : ALT onoff",
"tickattr : MINP expr",
"tickattr : MAXP expr",
"tickattr : DEFAULT NUMBER",
"tickattr : inoutchoice",
"tickattr : LOG onoff",
"tickattr : SIZE NUMBER",
"tickattr : MAJOR SIZE NUMBER",
"tickattr : MINOR SIZE NUMBER",
"tickattr : COLOR NUMBER",
"tickattr : LINEWIDTH NUMBER",
"tickattr : MAJOR COLOR NUMBER",
"tickattr : MINOR COLOR NUMBER",
"tickattr : MAJOR LINEWIDTH NUMBER",
"tickattr : MINOR LINEWIDTH NUMBER",
"tickattr : MAJOR LINESTYLE NUMBER",
"tickattr : MINOR LINESTYLE NUMBER",
"tickattr : MAJOR GRID onoff",
"tickattr : MINOR GRID onoff",
"tickattr : OP opchoice",
"tickattr : TYPE AUTO",
"tickattr : TYPE SPEC",
"tickattr : SPEC NUMBER",
"tickattr : NUMBER ',' expr",
"ticklabeldesc : ticklabelattr",
"ticklabeldesc : ticklabeldesc ticklabelattr",
"ticklabelattr : onoff",
"ticklabelattr : TYPE AUTO",
"ticklabelattr : TYPE SPEC",
"ticklabelattr : PREC NUMBER",
"ticklabelattr : FORMAT formatchoice",
"ticklabelattr : FORMAT NUMBER",
"ticklabelattr : APPEND CHRSTR",
"ticklabelattr : PREPEND CHRSTR",
"ticklabelattr : LAYOUT HORIZONTAL",
"ticklabelattr : LAYOUT VERTICAL",
"ticklabelattr : LAYOUT SPEC",
"ticklabelattr : ANGLE NUMBER",
"ticklabelattr : JUST justchoice",
"ticklabelattr : SKIP NUMBER",
"ticklabelattr : STAGGER NUMBER",
"ticklabelattr : OP opchoice",
"ticklabelattr : SIGN signchoice",
"ticklabelattr : START expr",
"ticklabelattr : STOP expr",
"ticklabelattr : START TYPE SPEC",
"ticklabelattr : START TYPE AUTO",
"ticklabelattr : STOP TYPE SPEC",
"ticklabelattr : STOP TYPE AUTO",
"ticklabelattr : VGAP NUMBER",
"ticklabelattr : HGAP NUMBER",
"ticklabelattr : CHAR SIZE NUMBER",
"ticklabelattr : FONTP NUMBER",
"ticklabelattr : COLOR NUMBER",
"ticklabelattr : LINEWIDTH NUMBER",
"ticklabelattr : NUMBER ',' CHRSTR",
"axislabeldesc : CHRSTR",
"axislabeldesc : LAYOUT PERP",
"axislabeldesc : LAYOUT PARA",
"axislabeldesc : PLACE AUTO",
"axislabeldesc : PLACE SPEC",
"axislabeldesc : PLACE NUMBER ',' NUMBER",
"axislabeldesc : JUST justchoice",
"axislabeldesc : CHAR SIZE NUMBER",
"axislabeldesc : FONTP NUMBER",
"axislabeldesc : COLOR NUMBER",
"axislabeldesc : LINEWIDTH NUMBER",
"axisbardesc : onoff",
"axisbardesc : COLOR NUMBER",
"axisbardesc : LINESTYLE NUMBER",
"axisbardesc : LINEWIDTH NUMBER",
"selectsets : GRAPHNO '.' SETNUM",
"selectsets : SETNUM",
"selectsets : SETS",
"selectsets : GRAPHNO SETS",
"selectsets : GRAPHS SETS",
"selectsets : GRAPHS SETNUM",
"prop : LINESTYLE",
"prop : LINEWIDTH",
"prop : FONTP",
"prop : COLOR",
"prop : SIZE",
"onoff : ON",
"onoff : OFF",
"colpat : COLOR",
"colpat : PATTERN",
"runtype : RUNAVG",
"runtype : RUNSTD",
"runtype : RUNMED",
"runtype : RUNMAX",
"runtype : RUNMIN",
"ffttype : DFT",
"ffttype : FFT",
"ffttype : INVDFT",
"ffttype : INVFFT",
"sourcetype : DISK",
"sourcetype : PIPE",
"filltype : PATTERN",
"filltype : COLOR",
"filltype : NONE",
"opchoice : TOP",
"opchoice : BOTTOM",
"opchoice : LEFT",
"opchoice : RIGHT",
"opchoice : BOTH",
"justchoice : RIGHT",
"justchoice : LEFT",
"justchoice : CENTER",
"extremetype : MINP",
"extremetype : MAXP",
"torf : TRUEP",
"torf : FALSEP",
"inoutchoice : IN",
"inoutchoice : OUT",
"inoutchoice : BOTH",
"formatchoice : DECIMAL",
"formatchoice : EXPONENTIAL",
"formatchoice : POWER",
"formatchoice : GENERAL",
"formatchoice : DDMMYY",
"formatchoice : MMDDYY",
"formatchoice : MMYY",
"formatchoice : MMDD",
"formatchoice : MONTHDAY",
"formatchoice : DAYMONTH",
"formatchoice : MONTHS",
"formatchoice : MONTHL",
"formatchoice : DAYOFWEEKS",
"formatchoice : DAYOFWEEKL",
"formatchoice : DAYOFYEAR",
"formatchoice : HMS",
"formatchoice : MMDDHMS",
"formatchoice : MMDDYYHMS",
"formatchoice : DEGREESLON",
"formatchoice : DEGREESMMLON",
"formatchoice : DEGREESMMSSLON",
"formatchoice : MMSSLON",
"formatchoice : DEGREESLAT",
"formatchoice : DEGREESMMLAT",
"formatchoice : DEGREESMMSSLAT",
"formatchoice : MMSSLAT",
"signchoice : NORMAL",
"signchoice : ABSOLUTE",
"signchoice : NEGATE",
"direction : UP",
"direction : DOWN",
"direction : RIGHT",
"direction : LEFT",
"direction : IN",
"direction : OUT",
"worldview : WORLD",
"worldview : VIEW",
"vector : X",
"vector : Y",
"vector : X0",
"vector : Y0",
"vector : Y1",
"vector : Y2",
"vector : Y3",
"vector : Y4",
"vector : Y5",
"asgn : VAR '[' expr ']' '=' expr",
"asgn : vector '[' expr ']' '=' expr",
"asgn : SETNUM '.' vector '[' expr ']' '=' expr",
"asgn : SETNUM '.' SYMBOL '=' expr",
"asgn : GRAPHNO '.' SETNUM '.' vector '[' expr ']' '=' expr",
"rasgn : REGNUM '.' vector '=' expr",
"vasgn : VAR '=' vexpr",
"vasgn : vector '=' vexpr",
"vasgn : SETNUM '.' vector '=' vexpr",
"vasgn : GRAPHNO '.' SETNUM '.' vector '=' vexpr",
"vasgn : VAR '=' expr",
"vasgn : vector '=' expr",
"vasgn : SETNUM '.' vector '=' expr",
"vasgn : GRAPHNO '.' SETNUM '.' vector '=' expr",
"vexpr : VAR",
"vexpr : vector",
"vexpr : SETNUM '.' vector",
"vexpr : GRAPHNO '.' SETNUM '.' vector",
"vexpr : expr",
"vexpr : expr '+' expr",
"vexpr : vexpr '+' vexpr",
"vexpr : expr '+' vexpr",
"vexpr : vexpr '+' expr",
"vexpr : expr '-' expr",
"vexpr : vexpr '-' vexpr",
"vexpr : expr '-' vexpr",
"vexpr : vexpr '-' expr",
"vexpr : expr '*' expr",
"vexpr : vexpr '*' vexpr",
"vexpr : expr '*' vexpr",
"vexpr : vexpr '*' expr",
"vexpr : expr '/' expr",
"vexpr : vexpr '/' vexpr",
"vexpr : expr '/' vexpr",
"vexpr : vexpr '/' expr",
"vexpr : expr '^' expr",
"vexpr : expr '^' vexpr",
"vexpr : vexpr '^' expr",
"vexpr : vexpr '^' vexpr",
"vexpr : ABS '(' expr ')'",
"vexpr : ABS '(' vexpr ')'",
"vexpr : ACOS '(' vexpr ')'",
"vexpr : ASIN '(' vexpr ')'",
"vexpr : ATAN '(' vexpr ')'",
"vexpr : ATAN2 '(' vexpr ',' vexpr ')'",
"vexpr : CEIL '(' vexpr ')'",
"vexpr : COS '(' vexpr ')'",
"vexpr : DEG",
"vexpr : ERF '(' vexpr ')'",
"vexpr : ERFC '(' vexpr ')'",
"vexpr : EXP '(' vexpr ')'",
"vexpr : FLOOR '(' vexpr ')'",
"vexpr : HYPOT '(' vexpr ',' vexpr ')'",
"vexpr : HYPOT '(' expr ',' vexpr ')'",
"vexpr : HYPOT '(' vexpr ',' expr ')'",
"vexpr : HYPOT '(' expr ',' expr ')'",
"vexpr : INDEX",
"vexpr : SETNO",
"vexpr : INT '(' vexpr ')'",
"vexpr : INVN '(' vexpr ')'",
"vexpr : INVT '(' expr ',' NUMBER ')'",
"vexpr : INVT '(' vexpr ',' NUMBER ')'",
"vexpr : IRAND '(' NUMBER ')'",
"vexpr : LGAMMA '(' vexpr ')'",
"vexpr : LN '(' vexpr ')'",
"vexpr : LOG '(' vexpr ')'",
"vexpr : LOGISTIC '(' vexpr ',' expr ',' expr ')'",
"vexpr : MAXP '(' vexpr ',' vexpr ')'",
"vexpr : MINP '(' vexpr ',' vexpr ')'",
"vexpr : MOD '(' vexpr ',' vexpr ')'",
"vexpr : NORM '(' vexpr ')'",
"vexpr : NORMP '(' vexpr ')'",
"vexpr : PI",
"vexpr : RAD",
"vexpr : RAND",
"vexpr : RNORM '(' vexpr ',' vexpr ')'",
"vexpr : RNORM '(' expr ',' vexpr ')'",
"vexpr : RNORM '(' vexpr ',' expr ')'",
"vexpr : RNORM '(' expr ',' expr ')'",
"vexpr : SIN '(' vexpr ')'",
"vexpr : SQR '(' vexpr ')'",
"vexpr : SQRT '(' vexpr ')'",
"vexpr : TAN '(' vexpr ')'",
"vexpr : vexpr '?' vexpr ':' vexpr",
"vexpr : vexpr GT vexpr",
"vexpr : vexpr LT vexpr",
"vexpr : vexpr LE vexpr",
"vexpr : vexpr GE vexpr",
"vexpr : vexpr EQ vexpr",
"vexpr : vexpr NE vexpr",
"vexpr : vexpr AND vexpr",
"vexpr : vexpr OR vexpr",
"vexpr : NOT vexpr",
"vexpr : '(' vexpr ')'",
"vexpr : '-' vexpr",
"expr : NUMBER",
"expr : FITPARM",
"expr : VAR '[' expr ']'",
"expr : REGNUM '.' vector",
"expr : vector '[' expr ']'",
"expr : SETNUM '.' vector '[' expr ']'",
"expr : GRAPHNO '.' SETNUM '.' vector '[' expr ']'",
"expr : SETNUM '.' vector '.' extremetype",
"expr : GRAPHNO '.' SETNUM '.' vector '.' extremetype",
"expr : SETNUM '.' LENGTH",
"expr : SETNUM '.' vector '.' AVG",
"expr : expr '+' expr",
"expr : expr '-' expr",
"expr : expr '*' expr",
"expr : expr '/' expr",
"expr : expr '%' expr",
"expr : expr '^' expr",
"expr : ABS '(' expr ')'",
"expr : ACOS '(' expr ')'",
"expr : ASIN '(' expr ')'",
"expr : ATAN '(' expr ')'",
"expr : ATAN2 '(' expr ',' expr ')'",
"expr : CEIL '(' expr ')'",
"expr : COS '(' expr ')'",
"expr : DEG",
"expr : ERF '(' expr ')'",
"expr : ERFC '(' expr ')'",
"expr : EXP '(' expr ')'",
"expr : FLOOR '(' expr ')'",
"expr : HYPOT '(' expr ',' expr ')'",
"expr : GRAPHNO '.' VX1",
"expr : GRAPHNO '.' VX2",
"expr : GRAPHNO '.' VY1",
"expr : GRAPHNO '.' VY2",
"expr : GRAPHNO '.' WX1",
"expr : GRAPHNO '.' WX2",
"expr : GRAPHNO '.' WY1",
"expr : GRAPHNO '.' WY2",
"expr : VX1",
"expr : VX2",
"expr : VY1",
"expr : VY2",
"expr : WX1",
"expr : WX2",
"expr : WY1",
"expr : WY2",
"expr : DX",
"expr : DY",
"expr : INDEX",
"expr : SETNO",
"expr : INT '(' expr ')'",
"expr : INVN '(' expr ')'",
"expr : INVT '(' expr ',' NUMBER ')'",
"expr : IRAND '(' NUMBER ')'",
"expr : LGAMMA '(' expr ')'",
"expr : LN '(' expr ')'",
"expr : LOG '(' expr ')'",
"expr : LOGISTIC '(' expr ',' expr ',' expr ')'",
"expr : MAXP '(' expr ',' expr ')'",
"expr : MINP '(' expr ',' expr ')'",
"expr : MOD '(' expr ',' expr ')'",
"expr : NORM '(' expr ')'",
"expr : NORMP '(' expr ')'",
"expr : PI",
"expr : RAD",
"expr : RAND",
"expr : RNORM '(' expr ',' expr ')'",
"expr : SIN '(' expr ')'",
"expr : SQR '(' expr ')'",
"expr : SQRT '(' expr ')'",
"expr : TAN '(' expr ')'",
"expr : expr '?' expr ':' expr",
"expr : expr GT expr",
"expr : expr LT expr",
"expr : expr LE expr",
"expr : expr GE expr",
"expr : expr EQ expr",
"expr : expr NE expr",
"expr : expr AND expr",
"expr : expr OR expr",
"expr : NOT expr",
"expr : '(' expr ')'",
"expr : '-' expr",
};
#endif
#define yyclearin (yychar=(-1))
#define yyerrok (yyerrflag=0)
#ifdef YYSTACKSIZE
#ifndef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#endif
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH 500
#endif
#endif
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short yyss[YYSTACKSIZE];
YYSTYPE yyvs[YYSTACKSIZE];
#define yystacksize YYSTACKSIZE
#line 3707 "pars.yacc"

void fixupstr(char *val)
{
    int vl = strlen(val);
    lowtoupper(val);
    val[vl + 1] = 0;
    val[vl] = '\n';
}

void scanner(char *s, double *x, double *y, int len, double *a, double *b, double *c, double *d, int lenscr, int i, int setno, int *errpos)
{
    interr = 0;
    whichgraph = cg;
    whichset = setno;
    if (s[0] == '#') {
	return;
    }
    pos = 0;
    aa = a;
    bb = b;
    cc = c;
    dd = d;
    xx = x;
    yy = y;
    lxy = len;
    ls = lenscr;
    setindex = i + 1;
    curset = setsetno = setno;
    strcpy(f_string, s);
    fcnt = 0;
    yyparse();
    *errpos = interr;
    for (i = 0; i < fcnt; i++) {
	cfree(freelist[i]);
	freelist[i] = NULL;
    }
}

void runbatch(char *bfile)
{
    double x, y, a, b, c, d;
    int i, setno, errpos, lcnt = 1;
    char stext[256];
    FILE *fp;
    if (strcmp("stdin", bfile)) {
	fp = fopen(bfile, "r");
    }
    else {
	fp = stdin;
    }
    if (fp == NULL) {
        fprintf(stderr, "Error opening batch file \"%s\"\n", bfile);
        exit(1);
    }
    while(fgets(stext, 255, fp) != NULL) {
        if (stext[0] == '#') {
            continue;
        }
	if (strlen(stext) == 0) {
	    continue;
	}
        lowtoupper(stext);
/* TODO check on 0, 0 here for index and setno */
        scanner(stext, &x, &y, 1, ax, bx, cx, dx, 1, 0, 0, &errpos);
        stext[0] = 0;
        if (gotparams && paramfile[0]) {
            if (!getparms(cg, paramfile)) {
            }
            gotparams = 0;
        } else if (gotread && readfile[0]) {
            if (getdata(cg, readfile, readsrc, readtype)) {
                drawgraph();
            }
            gotread = 0;
        }
    }
    if (fp != stdin) {
	fclose(fp);
    }
}

#define MAXFUN 383

int maxparms = MAXFUN;
int maxfunc = MAXFUN;

symtab_entry key[] = {
	"A", VAR,
	"A0", FITPARM,
	"A1", FITPARM,
	"A2", FITPARM,
	"A3", FITPARM,
	"A4", FITPARM,
	"A5", FITPARM,
	"A6", FITPARM,
	"A7", FITPARM,
	"A8", FITPARM,
	"A9", FITPARM,
	"ABORT", ABORT,
	"ABOVE", ABOVE,
	"ABS", ABS,
	"ABSOLUTE", ABSOLUTE,
	"ACOS", ACOS,
	"ACTIVATE", ACTIVATE,
	"ACTIVE", ACTIVE,
	"ALT", ALT,
	"ALTERNATE", ALTERNATE,
	"ALTXAXIS", ALTXAXIS,
	"ALTYAXIS", ALTYAXIS,
	"AND", AND,
	"ANGLE", ANGLE,
	"ANNOTATE", ANNOTATE,
	"APPEND", APPEND,
	"AREA", AREA,
	"ARROW", ARROW,
	"ASIN", ASIN,
	"ATAN", ATAN,
	"ATAN2", ATAN2,
	"AUTO", AUTO,
	"AUTOSCALE", AUTOSCALE,
	"AUTOTICKS", AUTOTICKS,
	"AVG", AVG,
	"AXES", AXES,
	"AXIS", AXIS,
	"B", VAR,
	"BACKBUFFER", BACKBUFFER,
	"BACKGROUND", BACKGROUND,
	"BAR", BAR,
	"BATCH", BATCH,
	"BELOW", BELOW,
	"BIN", BIN,
	"BLOCK", BLOCK,
	"BOTH", BOTH,
	"BOTTOM", BOTTOM,
	"BOX", BOX,
	"BOXPLOT", BOXPLOT,
	"C", VAR,
	"CD", CD,
	"CEIL", CEIL,
	"CELLS", CELLS,
	"CENTER", CENTER,
	"CHAR", CHAR,
	"CHRSTR", CHRSTR,
	"CLEAR", CLEAR,
	"CLICK", CLICK,
	"CMAP", CMAP,
	"CO", COLOR,
	"COLOR", COLOR,
	"COMMENT", COMMENT,
	"COPY", COPY,
	"COS", COS,
	"CYCLE", CYCLE,
	"D", VAR,
	"DAYMONTH", DAYMONTH,
	"DAYOFWEEKL", DAYOFWEEKL,
	"DAYOFWEEKS", DAYOFWEEKS,
	"DAYOFYEAR", DAYOFYEAR,
	"DDMMYY", DDMMYY,
	"DECIMAL", DECIMAL,
	"DEF", DEF,
	"DEFAULT", DEFAULT,
	"DEG", DEG,
	"DEGREESLAT", DEGREESLAT,
	"DEGREESLON", DEGREESLON,
	"DEGREESMMLAT", DEGREESMMLAT,
	"DEGREESMMLON", DEGREESMMLON,
	"DEGREESMMSSLAT", DEGREESMMSSLAT,
	"DEGREESMMSSLON", DEGREESMMSSLON,
	"DELAY", DELAYP,
	"DELETE", DELETE,
	"DEVICE", DEVICE,
	"DFT", DFT,
	"DIFF", DIFFERENCE,
	"DIFFERENCE", DIFFERENCE,
	"DISK", DISK,
	"DOUBLEBUFFER", DOUBLEBUFFER,
	"DOWN", DOWN,
	"DRAW2", DRAW2,
	"DROP", DROP,
	"DX", DX,
	"DXDX", DXDX,
	"DY", DY,
	"DYDY", DYDY,
	"ECHO", ECHO,
	"EDIT", EDIT,
	"ELSE", ELSE,
	"END", END,
	"EQ", EQ,
	"ER", ERRORBAR,
	"ERF", ERF,
	"ERFC", ERFC,
	"ERRORBAR", ERRORBAR,
	"EXIT", EXIT,
	"EXP", EXP,
	"EXPONENTIAL", EXPONENTIAL,
	"FALSE", FALSEP,
	"FFT", FFT,
	"FILE", FILEP,
	"FILL", FILL,
	"FIND", FIND,
	"FIXED", FIXED,
	"FIXEDPOINT", FIXEDPOINT,
	"FLOOR", FLOOR,
	"FLUSH", FLUSH,
	"FOCUS", FOCUS,
	"FOLLOWS", FOLLOWS,
	"FONT", FONTP,
	"FOREGROUND", FOREGROUND,
	"FORMAT", FORMAT,
	"FRAME", FRAMEP,
	"FREE", FREE,
	"FRONTBUFFER", FRONTBUFFER,
	"GE", GE,
	"GENERAL", GENERAL,
	"GETP", GETP,
	"GRAPH", GRAPH,
	"GRAPHS", GRAPHS,
	"GRAPHTYPE", GRAPHTYPE,
	"GRID", GRID,
	"GT", GT,
	"HARDCOPY", HARDCOPY,
	"HBAR", HBAR,
	"HBOXPLOT", HBOXPLOT,
	"HGAP", HGAP,
	"HIDDEN", HIDDEN,
	"HISTO", HISTO,
	"HMS", HMS,
	"HORIZONTAL", HORIZONTAL,
	"HPGLL", HPGLL,
	"HPGLP", HPGLP,
	"HYPOT", HYPOT,
	"IF", IF,
	"IGNORE", IGNORE,
	"IHL", IHL,
	"IMAGE", IMAGE,
	"IN", IN,
	"INDEX", INDEX,
	"INIT", INIT,
	"INITGRAPHICS", INITGRAPHICS,
	"INOUT", INOUT,
	"INT", INT,
	"INTEGRATE", INT,
	"INTERP", INTERP,
	"INUM", INUM,
	"INVDFT", INVDFT,
	"INVFFT", INVFFT,
	"INVN", INVN,
	"INVT", INVT,
	"IRAND", IRAND,
	"JUST", JUST,
	"KILL", KILL,
	"LABEL", LABEL,
	"LANDSCAPE", LANDSCAPE,
	"LAYOUT", LAYOUT,
	"LE", LE,
	"LEAVE", LEAVE,
	"LEAVEGRAPHICS", LEAVEGRAPHICS,
	"LEFT", LEFT,
	"LEGEND", LEGEND,
	"LENGTH", LENGTH,
	"LEVEL", LEVEL,
	"LEVELS", LEVELS,
	"LGAMMA", LGAMMA,
	"LINE", LINE,
	"LINESTYLE", LINESTYLE,
	"LINETO", LINETO,
	"LINEWIDTH", LINEWIDTH,
	"LINK", LINK,
	"LN", LN,
	"LOAD", LOAD,
	"LOCATOR", LOCATOR,
	"LOCATORBAR", LOCATORBAR,
	"LOCTYPE", LOCTYPE,
	"LOG", LOG,
	"LOGISTIC", LOGISTIC,
	"LOGX", LOGX,
	"LOGXY", LOGXY,
	"LOGY", LOGY,
	"LS", LINESTYLE,
	"LT", LT,
	"LW", LINEWIDTH,
	"MAJOR", MAJOR,
	"MAX", MAXP,
	"MIFL", MIFL,
	"MIFP", MIFP,
	"MIN", MINP,
	"MINOR", MINOR,
	"MISSING", MISSINGP,
	"MMDD", MMDD,
	"MMDDHMS", MMDDHMS,
	"MMDDYY", MMDDYY,
	"MMDDYYHMS", MMDDYYHMS,
	"MMSSLAT", MMSSLAT,
	"MMSSLON", MMSSLON,
	"MMYY", MMYY,
	"MOD", MOD,
	"MONTHDAY", MONTHDAY,
	"MONTHL", MONTHL,
	"MONTHS", MONTHS,
	"MOVE", MOVE,
	"MOVE2", MOVE2,
	"MOVETO", MOVETO,
	"NE", NE,
	"NEGATE", NEGATE,
	"NO", NO,
	"NONE", NONE,
	"NORM", NORM,
	"NORMAL", NORMAL,
	"NORMP", NORMP,
	"NOT", NOT,
	"NUMBER", NUMBER,
	"NXY", NXY,
	"OFF", OFF,
	"OFFSETX", OFFSETX,
	"OFFSETY", OFFSETY,
	"ON", ON,
	"OP", OP,
	"OR", OR,
	"ORIENT", ORIENT,
	"OUT", OUT,
	"PAGE", PAGE,
	"PARA", PARA,
	"PARALLEL", PARALLEL,
	"PARAMETERS", PARAMETERS,
	"PARAMS", PARAMS,
	"PATTERN", PATTERN,
	"PERIMETER", PERIMETER,
	"PERP", PERP,
	"PERPENDICULAR", PERPENDICULAR,
	"PI", PI,
	"PIE", PIE,
	"PIPE", PIPE,
	"PLACE", PLACE,
	"POINT", POINT,
	"POLAR", POLAR,
	"POLYI", POLYI,
	"POLYO", POLYO,
	"POP", POP,
	"PORTRAIT", PORTRAIT,
	"POWER", POWER,
	"PREC", PREC,
	"PREPEND", PREPEND,
	"PRINT", PRINT,
	"PS", PS,
	"PSCOLORL", PSCOLORL,
	"PSCOLORP", PSCOLORP,
	"PSMONOL", PSMONOL,
	"PSMONOP", PSMONOP,
	"PUSH", PUSH,
	"PUTP", PUTP,
	"RAD", RAD,
	"RAND", RAND,
	"RAWSPICE", RAWSPICE,
	"READ", READ,
	"REDRAW", REDRAW,
	"REGRESS", REGRESS,
	"RENDER", RENDER,
	"REVERSE", REVERSE,
	"RIGHT", RIGHT,
	"RISER", RISER,
	"RNORM", RNORM,
	"ROT", ROT,
	"RUNAVG", RUNAVG,
	"RUNMAX", RUNMAX,
	"RUNMED", RUNMED,
	"RUNMIN", RUNMIN,
	"RUNSTD", RUNSTD,
	"SAMPLE", SAMPLE,
	"SAVEALL", SAVEALL,
	"SCALE", SCALE,
	"SCIENTIFIC", SCIENTIFIC,
	"SET", SET,
	"SETNO", SETNO,
	"SETS", SETS,
	"SIGN", SIGN,
	"SIN", SIN,
	"SIZE", SIZE,
	"SKIP", SKIP,
	"SLEEP", SLEEP,
	"SLICE", SLICE,
	"SOURCE", SOURCE,
	"SPEC", SPEC,
	"SPECIFIED", SPECIFIED,
	"SPECTRUM", SPECTRUM,
	"SPLINE", SPLINE,
	"SQR", SQR,
	"SQRT", SQRT,
	"STACK", STACK,
	"STACKEDBAR", STACKEDBAR,
	"STACKEDHBAR", STACKEDHBAR,
	"STACKEDLINE", STACKEDLINE,
	"STAGGER", STAGGER,
	"START", START,
	"STARTTYPE", STARTTYPE,
	"STATUS", STATUS,
	"STATUSBAR", STATUSBAR,
	"STOP", STOP,
	"STRING", STRING,
	"SUBTITLE", SUBTITLE,
	"SWAPBUFFER", SWAPBUFFER,
	"SYMBOL", SYMBOL,
	"TAN", TAN,
	"TICK", TICKP,
	"TICKLABEL", TICKLABEL,
	"TICKMARKS", TICKMARKS,
	"TITLE", TITLE,
	"TO", TO,
	"TOOLBAR", TOOLBAR,
	"TOP", TOP,
	"TRUE", TRUEP,
	"TYPE", TYPE,
	"UP", UP,
	"VAR", VAR,
	"VELOCITY", VELOCITY,
	"VERTICAL", VERTICAL,
	"VGAP", VGAP,
	"VIEW", VIEW,
	"VX1", VX1,
	"VX2", VX2,
	"VY1", VY1,
	"VY2", VY2,
	"WITH", WITH,
	"WORLD", WORLD,
	"WRITE", WRITE,
	"WX1", WX1,
	"WX2", WX2,
	"WY1", WY1,
	"WY2", WY2,
	"X", X,
	"X0", X0,
	"X1", X1,
	"XAXES", XAXES,
	"XAXIS", XAXIS,
	"XCOR", XCOR,
	"XMAX", XMAX,
	"XMIN", XMIN,
	"XY", XY,
	"XYARC", XYARC,
	"XYBOX", XYBOX,
	"XYBOXPLOT", XYBOXPLOT,
	"XYDX", XYDX,
	"XYDXDX", XYDXDX,
	"XYDXDY", XYDXDY,
	"XYDY", XYDY,
	"XYDYDY", XYDYDY,
	"XYFIXED", XYFIXED,
	"XYHILO", XYHILO,
	"XYRT", XYRT,
	"XYSEG", XYSEG,
	"XYSTRING", XYSTRING,
	"XYUV", XYUV,
	"XYX2Y2", XYX2Y2,
	"XYXX", XYXX,
	"XYYY", XYYY,
	"XYZ", XYZ,
	"XYZW", XYZW,
	"Y", Y,
	"Y0", Y0,
	"Y1", Y1,
	"Y2", Y2,
	"Y3", Y3,
	"Y4", Y4,
	"Y5", Y5,
	"YAXES", YAXES,
	"YAXIS", YAXIS,
	"YES", YES,
	"YMAX", YMAX,
	"YMIN", YMIN,
	"ZEROXAXIS", ZEROXAXIS,
	"ZEROYAXIS", ZEROYAXIS,
};

int findf(symtab_entry *key, char *s, int tlen)
{

    int low, high, mid;

    low = 0;
    high = tlen - 1;
    while (low <= high) {
	mid = (low + high) / 2;
	if (strcmp(s, key[mid].s) < 0) {
	    high = mid - 1;
	} else {
	    if (strcmp(s, key[mid].s) > 0) {
		low = mid + 1;
	    } else {
		return (mid);
	    }
	}
    }
    return (-1);
}

int getcharstr(void)
{
    if (pos >= strlen(f_string))
	 return EOF;
    return (f_string[pos++]);
}

void ungetchstr(void)
{
    if (pos > 0)
	pos--;
}

int yylex(void)
{
    int c, i;
    int found;
    static char s[256];
    char sbuf[256];
    char *str;

    while ((c = getcharstr()) == ' ' || c == '\t');
    if (c == EOF) {
	return (0);
    }
    if (c == '"') {
	i = 0;
	while ((c = getcharstr()) != '"' && c != EOF) {
	    if (c == '\\') {
		int ctmp;
		ctmp = getcharstr();
		if (ctmp != '"') {
		    ungetchstr();
		}
		else {
		    c = ctmp;
		}
	    }
	    s[i] = c;
	    i++;
	}
	if (c == EOF) {
	    sprintf(sbuf, "Nonterminating string\n");
	    yyerror(sbuf);
	    return 0;
	}
	s[i] = '\0';
	str = (char *) malloc(strlen(s) + 1);
	strcpy(str, s);
	yylval.str = str;
	return CHRSTR;
    }
    if (c == '.' || isdigit(c)) {
	char stmp[80];
	double d;
	int i, gotdot = 0;

	i = 0;
	while (c == '.' || isdigit(c)) {
	    if (c == '.') {
		if (gotdot) {
		    yyerror("Reading number, too many dots");
	    	    return 0;
		} else {
		    gotdot = 1;
		}
	    }
	    stmp[i++] = c;
	    c = getcharstr();
	}
	if (c == 'E' || c == 'e') {
	    stmp[i++] = c;
	    c = getcharstr();
	    if (c == '+' || c == '-') {
		stmp[i++] = c;
		c = getcharstr();
	    }
	    while (isdigit(c)) {
		stmp[i++] = c;
		c = getcharstr();
	    }
	}
	if (gotdot && i == 1) {
	    ungetchstr();
	    return '.';
	}
	stmp[i] = '\0';
	ungetchstr();
	sscanf(stmp, "%lf", &d);
	yylval.val = d;
	return NUMBER;
    }
/* graphs, sets, regions resp. */
    if (c == 'G' || c == 'S' || c == 'R') {
	char stmp[80];
	double d;
	int i = 0, ctmp = c, gn, sn, rn;
	c = getcharstr();
	while (isdigit(c)) {
	    stmp[i++] = c;
	    c = getcharstr();
	}
	if (i == 0) {
	    c = ctmp;
	    ungetchstr();
	} else {
	    ungetchstr();
	    if (ctmp == 'G') {
	        stmp[i] = '\0';
		gn = atoi(stmp);
		if (gn >= 0 && gn < maxgraph) {
		    yylval.ival = gn;
		    whichgraph = gn;
		    return GRAPHNO;
		}
	    } else if (ctmp == 'S') {
	        stmp[i] = '\0';
		sn = atoi(stmp);
		if (sn >= 0 && sn < g[cg].maxplot) {
		    lxy = getsetlength(cg, sn);
		    yylval.ival = sn;
		    whichset = sn;
		    return SETNUM;
		}
	    } else if (ctmp == 'R') {
	        stmp[i] = '\0';
		rn = atoi(stmp);
		if (rn >= 0 && rn < MAXREGION) {
		    yylval.ival = rn;
		    return REGNUM;
		}
	    }
	}
    }
    if (isalpha(c)) {
	char *p = sbuf;
	int gno = -1, setno = -1, xy = -1, elno = -1;

	do {
	    *p++ = c;
	} while ((c = getcharstr()) != EOF && isalnum(c));
	ungetchstr();
	*p = '\0';
        if (debuglevel == 2) {
	    printf("->%s<-\n", sbuf);
	}
	if ((found = findf(key, sbuf, MAXFUN)) >= 0) {
	    if (key[found].type == VAR) {
		switch (sbuf[0]) {
		case 'A':
		    yylval.ptr = aa;
		    return VAR;
		case 'B':
		    yylval.ptr = bb;
		    return VAR;
		case 'C':
		    yylval.ptr = cc;
		    return VAR;
		case 'D':
		    yylval.ptr = dd;
		    return VAR;
		}
	    }
	    else if (key[found].type == FITPARM) {
		int index = sbuf[1] - '0';
		yylval.val = nonl_parms[index];
		return FITPARM;
	    }
	    else { /* set up special cases */
		switch (key[found].type) {
		case XAXIS:
		    naxis = 0;
		    break;
		case YAXIS:
		    naxis = 1;
		    break;
		case ZEROXAXIS:
		    naxis = 2;
		    break;
		case ZEROYAXIS:
		    naxis = 3;
		    break;
		case ALTXAXIS:
		    naxis = 4;
		    break;
		case ALTYAXIS:
		    naxis = 5;
		    break;
		case AXES:
		    naxis = 6;
		    break;
		case XAXES:
		    naxis = 7;
		    break;
		case YAXES:
		    naxis = 8;
		    break;
		case GRAPHS:
		    yylval.ival = -1;
		    whichgraph = -1;
		    return GRAPHS;
		    break;
		case SETS:
		    yylval.ival = -1;
		    whichset = -1;
		    return SETS;
		    break;
		default:
		    break;
		}
	    }
	    yylval.func = key[found].type;
	    return key[found].type;
	} else {
	    strcat(sbuf, ": No such function or variable");
	    yyerror(sbuf);
	    return 0;
	}
    }
    switch (c) {
    case '>':
	return follow('=', GE, GT);
    case '<':
	return follow('=', LE, LT);
    case '=':
	return follow('=', EQ, '=');
    case '!':
	return follow('=', NE, NOT);
    case '|':
	return follow('|', OR, '|');
    case '&':
	return follow('&', AND, '&');
    case '\n':
	return '\n';
    default:
	return c;
    }
}

int follow(int expect, int ifyes, int ifno)
{
    int c = getcharstr();

    if (c == expect) {
	return ifyes;
    }
    ungetchstr();
    return ifno;
}

void yyerror(char *s)
{
    int i;
    char buf[256];
    sprintf(buf, "Error: %s: %s", s, f_string);
    i = strlen(buf);
    buf[i - 1] = 0;
    errwin(buf);
    interr = 1;
}

#define C1 0.1978977093962766
#define C2 0.1352915131768107

double rnorm(double mean, double sdev)
{
    double u = drand48();

    return mean + sdev * (pow(u, C2) - pow(1.0 - u, C2)) / C1;
}

double fx(double x)
{
    return 1.0 / sqrt(2.0 * M_PI) * exp(-x * x * 0.5);
}

double normp(double b, double *s)
{
    double sum, dx, a = -8.0, fx(double x);
    int i, n = 48;

    sum = fx(a) + fx(b);
    dx = (b - a) / n;
    for (i = 1; i <= ((n - 1) / 2); i++)
	sum = sum + 4.0 * fx(a + (2.0 * i - 1.0) * dx) + 2.0 * fx(a + 2.0 * i * dx);
    sum = sum + 4.0 * fx(b - dx);
    *s = fx(b);
    return sum * dx / 3.0;
}

double invnorm(double p)
{
    double s, x, z, temp, normp(double b, double *s);

    if (p > 0.5)
	x = 1.0 - p;
    else
	x = p;
    s = sqrt(-2.0 * log(x));
    x = ((-7.49101 * s - 448.047) * s - 1266.846);
    x = x / (((s + 109.8371) * s + 748.189) * s + 498.003) + s;
    if (p < 0.5)
	x = -x;
    z = p - normp(x, &s);
    z = z / s;
    s = x * x;
    return (((((((((720.0 * s + 2556.0) * s + 1740.0) * s + 127.0) * z / 7.0 +
		 ((120.0 * s + 326.0) * s + 127.0) * x) * z / 6.0 + (24 * s + 46.0) * s + 7.0) * z / 40.0 +
	       (0.75 * s + 0.875) * x) * z + s + 0.5) * z / 3.0 + x * 0.5) * z + 1.0) * z + x + 0.832e-24 * x;
}

double invt(double p, int n)
{
    double sign, temp, a, b, c, d, x, y;

    sign = 1.0;
    if (p < 0.5) {
	p = 1.0 - p;
	sign = -1.0;
    }
    p = (1 - p) * 2;
    if (n == 2) {
	temp = sqrt(2.0 / (p * (2.0 - p)) - 2.0);
	temp = sign * temp;
	return temp;
    } else if (n == 1) {
	p = p * M_PI / 2.0;
	return sign * cos(p) / sin(p);
    } else {
	a = 1.0 / (n - 0.5);
	b = 48.0 / (a * a);
	c = ((20700 * a / b - 98.0) * a - 16.0) * a + 96.36;
	d = ((94.5 / (b + c) - 3.0) / b + 1.0) * sqrt(a * M_PI / 2.0) * n;
	x = d * p;
	y = exp((2.0 / n) * log(x));
	if (y > (0.05 + a)) {
	    x = invnorm(p * 0.5);
	    y = x * x;
	    if (n < 5)
		c = c + 0.3 * (n - 4.5) * (x + 0.6);
	    c = (((0.05 * d * x - 5.0) * x - 7.0) * x - 2.0) * x + b + c;
	    y = (((((0.4 * y + 6.3) * y + 36.0) * y + 94.5) / c - y - 3.0) / b + 1.0) * x;
	    y = a * y * y;
	    if (y > 0.002)
		y = exp(y) - 1.0;
	    else
		y = 0.5 * y * y + y;
	} else
	    y = ((1.0 / (((n + 0.6) / (n * y) - 0.089 * d - 0.822) * (n + 2.0) * 3.0) + 0.5 / (n + 4.0)) * y - 1.0) * (n + 1.0) / (n + 2.0) + 1.0 / y;
	return sign * sqrt(n * y);
    }
}

/*
 * return a pointer to the array given by v
 */
double *getvptr(int gno, int setno, int v)
{
    switch (v) {
    case X:
    case X0:
	return g[gno].p[setno].ex[0];
	break;
    case Y:
    case Y0:
	return g[gno].p[setno].ex[1];
	break;
    case Y1:
	return g[gno].p[setno].ex[2];
	break;
    case Y2:
	return g[gno].p[setno].ex[3];
	break;
    case Y3:
	return g[gno].p[setno].ex[4];
	break;
    case Y4:
	return g[gno].p[setno].ex[5];
	break;
    case Y5:
	return g[gno].p[setno].ex[6];
	break;
    }
    return NULL;
}
#line 5343 "y.tab.c"
#define YYABORT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab
int
yyparse()
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register char *yys;
    extern char *getenv();

    if (yys = getenv("YYDEBUG"))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if (yyn = yydefred[yystate]) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, reading %d (%s)\n", yystate,
                    yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: state %d, shifting to state %d\n",
                    yystate, yytable[yyn]);
#endif
        if (yyssp >= yyss + yystacksize - 1)
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#ifdef lint
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#ifdef lint
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: state %d, error recovery shifting\
 to state %d\n", *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yyss + yystacksize - 1)
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("yydebug: error recovery discarding state %d\n",
                            *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("yydebug: state %d, error recovery discards token %d (%s)\n",
                    yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("yydebug: state %d, reducing by rule %d (%s)\n",
                yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 5:
#line 504 "pars.yacc"
{
	    result = yyvsp[-1].val;
	}
break;
case 6:
#line 507 "pars.yacc"
{
	    result = *yyvsp[-1].ptr;
	}
break;
case 13:
#line 516 "pars.yacc"
{
	    return 1;
	}
break;
case 14:
#line 522 "pars.yacc"
{
	    if (yyvsp[-1].pset == FILEP) {
		set_printer(FILEP, yyvsp[0].pset);
	    }
	    else {
		set_printer(yyvsp[-1].pset, yyvsp[0].pset);
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 15:
#line 531 "pars.yacc"
{
	    if (yyvsp[-1].pset == FILEP) {
		set_printer(FILEP, yyvsp[0].pset);
	    }
	    else {
		set_printer(yyvsp[-1].pset, yyvsp[0].pset);
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 16:
#line 540 "pars.yacc"
{
	    if (yyvsp[0].pset == FILEP) {
		set_printer(FILEP, NULL);
	    }
	    else {
		set_printer(yyvsp[0].pset, NULL);
	    }
	}
break;
case 17:
#line 548 "pars.yacc"
{
	    tdevice = (int) yyvsp[0].val;
	}
break;
case 18:
#line 551 "pars.yacc"
{
	    hdevice = (int) yyvsp[0].val;
	}
break;
case 19:
#line 554 "pars.yacc"
{
	    do_hardcopy();
	}
break;
case 20:
#line 558 "pars.yacc"
{ 
	    extern int pslwfactor; /* fudge factor for linewidths in the PS driver */
	    pslwfactor = yyvsp[0].val; 
	}
break;
case 21:
#line 565 "pars.yacc"
{ yyval.pset = GR_PS_P; }
break;
case 22:
#line 566 "pars.yacc"
{ yyval.pset = GR_PS_L; }
break;
case 23:
#line 567 "pars.yacc"
{ yyval.pset = GR_MIF_P; }
break;
case 24:
#line 568 "pars.yacc"
{ yyval.pset = GR_MIF_L; }
break;
case 25:
#line 569 "pars.yacc"
{ yyval.pset = GR_HPGL_P; }
break;
case 26:
#line 570 "pars.yacc"
{ yyval.pset = GR_HPGL_L; }
break;
case 27:
#line 571 "pars.yacc"
{ yyval.pset = hdevice; }
break;
case 28:
#line 572 "pars.yacc"
{ yyval.pset = FILEP; }
break;
case 29:
#line 576 "pars.yacc"
{
	    rg[yyvsp[-1].pset].active = yyvsp[0].pset;
	}
break;
case 30:
#line 579 "pars.yacc"
{
	    rg[yyvsp[-2].pset].type = yyvsp[0].pset;
	}
break;
case 31:
#line 582 "pars.yacc"
{
	    rg[yyvsp[-2].pset].color = checkon(COLOR, rg[yyvsp[-2].pset].color, (int) yyvsp[0].val);
	}
break;
case 32:
#line 585 "pars.yacc"
{
	    rg[yyvsp[-2].pset].lines = checkon(LINESTYLE, rg[yyvsp[-2].pset].lines, (int) yyvsp[0].val);
	}
break;
case 33:
#line 588 "pars.yacc"
{
	    rg[yyvsp[-2].pset].linew = checkon(LINEWIDTH, rg[yyvsp[-2].pset].linew, (int) yyvsp[0].val);
	}
break;
case 34:
#line 592 "pars.yacc"
{
	    rg[yyvsp[-8].pset].x1 = yyvsp[-6].val;
	    rg[yyvsp[-8].pset].y1 = yyvsp[-4].val;
	    rg[yyvsp[-8].pset].x2 = yyvsp[-2].val;
	    rg[yyvsp[-8].pset].y2 = yyvsp[0].val;
	}
break;
case 35:
#line 599 "pars.yacc"
{
	    if (rg[yyvsp[-4].pset].x == NULL || rg[yyvsp[-4].pset].n == 0) {
		rg[yyvsp[-4].pset].n = 0;
		rg[yyvsp[-4].pset].x = (double *) calloc(1, sizeof(double));
		rg[yyvsp[-4].pset].y = (double *) calloc(1, sizeof(double));
	    } else {
		rg[yyvsp[-4].pset].x = (double *) realloc(rg[yyvsp[-4].pset].x, (rg[yyvsp[-4].pset].n + 1) * sizeof(double));
		rg[yyvsp[-4].pset].y = (double *) realloc(rg[yyvsp[-4].pset].y, (rg[yyvsp[-4].pset].n + 1) * sizeof(double));
	    }
	    rg[yyvsp[-4].pset].x[rg[yyvsp[-4].pset].n] = yyvsp[-2].val;
	    rg[yyvsp[-4].pset].y[rg[yyvsp[-4].pset].n] = yyvsp[0].val;
	    rg[yyvsp[-4].pset].n++;
	}
break;
case 36:
#line 612 "pars.yacc"
{
	    rg[yyvsp[-2].pset].linkto[yyvsp[0].pset] = TRUE;
	}
break;
case 37:
#line 618 "pars.yacc"
{
	    drawgraph();
	}
break;
case 38:
#line 621 "pars.yacc"
{
	    auto_redraw = (yyvsp[0].pset == ON);
	}
break;
case 39:
#line 624 "pars.yacc"
{
	    char buf[MAXPATHLEN];
	    strcpy(buf, (char *) yyvsp[0].pset);
	    expand_tilde(buf); 
	    if (chdir(buf) >= 0) {
		strcpy(workingdir, buf);
	    	if (inwin) {
		    set_title(workingdir);
	        }
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 40:
#line 636 "pars.yacc"
{
	    if (inwin) {
		set_left_footer(yyvsp[0].pset);
	    }
	    else {
		printf("%s\n", yyvsp[0].pset);
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 41:
#line 645 "pars.yacc"
{
	    setbgcolor((int) yyvsp[0].val);
	}
break;
case 42:
#line 648 "pars.yacc"
{
	    xlibsetcmap((int) yyvsp[-6].val, (int) yyvsp[-4].val, (int) yyvsp[-2].val, (int) yyvsp[0].val);
	}
break;
case 43:
#line 651 "pars.yacc"
{
	    exit(0);
	}
break;
case 44:
#line 655 "pars.yacc"
{
            set_pagelayout(yyvsp[0].pset);
        }
break;
case 45:
#line 659 "pars.yacc"
{
            set_toolbars(yyvsp[-1].pset, yyvsp[0].pset == ON);
        }
break;
case 46:
#line 663 "pars.yacc"
{
            set_toolbars(yyvsp[-1].pset, yyvsp[0].pset == ON);
        }
break;
case 47:
#line 667 "pars.yacc"
{
            set_toolbars(yyvsp[-1].pset, yyvsp[0].pset == ON);
        }
break;
case 48:
#line 671 "pars.yacc"
{
	    if (inwin) {
		my_draw2((double) yyvsp[-2].val, (double) yyvsp[0].val);
		flush_pending();
	    }
	}
break;
case 49:
#line 677 "pars.yacc"
{
	    if (inwin) {
		my_move2((double) yyvsp[-2].val, (double) yyvsp[0].val);
	    }
	}
break;
case 50:
#line 682 "pars.yacc"
{
	    if (inwin) {
		double x = (double) yyvsp[-4].val;
		double y = (double) yyvsp[-2].val;
		drawpolysym(&x, &y, 1, (int) yyvsp[0].val, 0, 0, 1.0);
		flush_pending();
	    }
	}
break;
case 51:
#line 690 "pars.yacc"
{
	    if (inwin) {
		setcolor((int) yyvsp[0].val);
	    }
	}
break;
case 52:
#line 695 "pars.yacc"
{
	    if (inwin) {
		setlinewidth((int) yyvsp[0].val);
	    }
	}
break;
case 53:
#line 700 "pars.yacc"
{
	    if (inwin) {
		setlinestyle((int) yyvsp[0].val);
	    }
	}
break;
case 54:
#line 705 "pars.yacc"
{
	}
break;
case 55:
#line 709 "pars.yacc"
{
	    switch (yyvsp[0].pset) {
	    case UP:
		gwindup_proc();
		break;
	    case DOWN:
		gwinddown_proc();
		break;
	    case RIGHT:
		gwindright_proc();
		break;
	    case LEFT:
		gwindleft_proc();
		break;
	    case IN:
		gwindshrink_proc();
		break;
	    case OUT:
		gwindexpand_proc();
		break;
	    }
	}
break;
case 56:
#line 731 "pars.yacc"
{
	    scroll_proc((int) yyvsp[0].val);
	}
break;
case 57:
#line 734 "pars.yacc"
{
	    scrollinout_proc((int) yyvsp[0].val);
	}
break;
case 58:
#line 737 "pars.yacc"
{
	    scrolling_islinked = yyvsp[0].pset == ON;
	}
break;
case 59:
#line 740 "pars.yacc"
{
	    my_doublebuffer(yyvsp[0].pset == TRUEP);
	}
break;
case 60:
#line 743 "pars.yacc"
{
	    my_frontbuffer(yyvsp[0].pset == TRUEP);
	}
break;
case 61:
#line 746 "pars.yacc"
{
	    my_backbuffer(yyvsp[0].pset == TRUEP);
	}
break;
case 62:
#line 749 "pars.yacc"
{
	    my_swapbuffer();
	}
break;
case 63:
#line 752 "pars.yacc"
{
	    sleep((int) yyvsp[0].val);
	}
break;
case 64:
#line 755 "pars.yacc"
{	/* TODO add delay function */
	}
break;
case 65:
#line 757 "pars.yacc"
{		/* TODO add abort flag and function */
	}
break;
case 66:
#line 760 "pars.yacc"
{
	    gotparams = TRUE;
	    strcpy(paramfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 67:
#line 766 "pars.yacc"
{
	    if (!fexists((char *) yyvsp[0].pset)) {
		FILE *pp = fopen((char *) yyvsp[0].pset, "w");
		if (pp != NULL) {
		    putparms(cg, pp, 0);
		    fclose(pp);
		} else {
		    errwin("Unable to write parameter file");
		}
	    }
	    free((char *) yyvsp[0].pset);
	}
break;
case 68:
#line 778 "pars.yacc"
{
	    cg = (int) yyvsp[0].pset;
	    g[cg].parmsread = TRUE;
	    change_gno = cg;
	}
break;
case 69:
#line 783 "pars.yacc"
{
	    curset = (int) yyvsp[0].pset;
	}
break;
case 70:
#line 788 "pars.yacc"
{
	    set_hotlink(cg, yyvsp[-3].pset, 1, (char *) yyvsp[0].pset, yyvsp[-1].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 71:
#line 792 "pars.yacc"
{
	    set_hotlink(yyvsp[-5].pset, yyvsp[-3].pset, 1, (char *) yyvsp[0].pset, yyvsp[-1].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 72:
#line 796 "pars.yacc"
{
	    set_hotlink(cg, yyvsp[-2].pset, yyvsp[0].pset == ON, NULL);
	}
break;
case 73:
#line 799 "pars.yacc"
{
	    set_hotlink(yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset == ON, NULL, 0);
	}
break;
case 74:
#line 803 "pars.yacc"
{
	    do_activateset(cg, yyvsp[-1].pset, (int) yyvsp[0].val);
	}
break;
case 75:
#line 806 "pars.yacc"
{
	    add_point(cg, yyvsp[-4].pset, yyvsp[-2].val, yyvsp[0].val, 0.0, 0.0, XY);
	}
break;
case 76:
#line 809 "pars.yacc"
{
	    add_point(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].val, yyvsp[0].val, 0.0, 0.0, XY);
	}
break;
case 77:
#line 813 "pars.yacc"
{
	    int start = (int) yyvsp[-2].val - 1;
	    int stop = (int) yyvsp[0].val - 1;
	    int dist = stop - start + 1;
	    if (dist > 0 && start >= 0) {
	        droppoints(cg, yyvsp[-4].pset, start, stop, dist);
	    }
	}
break;
case 78:
#line 821 "pars.yacc"
{
	    int start = (int) yyvsp[-2].val - 1;
	    int stop = (int) yyvsp[0].val - 1;
	    int dist = stop - start + 1;
	    if (dist > 0 && start >= 0) {
	        droppoints(yyvsp[-6].pset, yyvsp[-4].pset, start, stop, dist);
	    }
	}
break;
case 79:
#line 829 "pars.yacc"
{
	    do_copyset(cg, yyvsp[-2].pset, cg, yyvsp[0].pset);
	}
break;
case 80:
#line 832 "pars.yacc"
{
	    do_copyset(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset);
	}
break;
case 81:
#line 835 "pars.yacc"
{
	    do_moveset(cg, yyvsp[-2].pset, cg, yyvsp[0].pset, 0);
	}
break;
case 82:
#line 838 "pars.yacc"
{
	    do_moveset(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset);
	}
break;
case 83:
#line 842 "pars.yacc"
{
	    killset(cg, yyvsp[0].pset);
	}
break;
case 84:
#line 846 "pars.yacc"
{
	    int i;
	    for (i = 0; i < g[cg].maxplot; i++) {
		killset(cg, i);
	    }
	}
break;
case 85:
#line 853 "pars.yacc"
{
	    kill_graph(yyvsp[0].pset);
	}
break;
case 86:
#line 857 "pars.yacc"
{
	    kill_graph(maxgraph);
	}
break;
case 87:
#line 861 "pars.yacc"
{
	    wipeout(0);
	}
break;
case 88:
#line 865 "pars.yacc"
{
	    int i;
	    for (i = 0; i < (int) yyvsp[-4].val; i++) {
		yyvsp[-5].ptr[i] = yyvsp[-2].val + yyvsp[0].val * i;
	    }
	}
break;
case 89:
#line 872 "pars.yacc"
{
	    int setno = yyvsp[-3].pset, ideg = (int) yyvsp[-1].val;
	    do_regress(setno, ideg, 0, -1, 0);
	}
break;
case 90:
#line 877 "pars.yacc"
{
	    do_running_command(yyvsp[-5].pset, yyvsp[-3].pset, (int) yyvsp[-1].val);
	}
break;
case 91:
#line 881 "pars.yacc"
{
	    do_fourier_command(yyvsp[-5].pset, yyvsp[-3].pset, (int) yyvsp[-1].val);
	}
break;
case 92:
#line 885 "pars.yacc"
{
	    do_spline(yyvsp[-7].pset, yyvsp[-5].val, yyvsp[-3].val, (int) yyvsp[-1].val);
	}
break;
case 93:
#line 889 "pars.yacc"
{
	    do_histo_command(yyvsp[-7].pset, -1, -1, yyvsp[-5].val, yyvsp[-3].val, (int) yyvsp[-1].val);
	}
break;
case 94:
#line 893 "pars.yacc"
{
	    do_differ(yyvsp[-3].pset, (int) yyvsp[-1].val);
	}
break;
case 95:
#line 897 "pars.yacc"
{
	    do_int(yyvsp[-1].pset, 0);
	}
break;
case 96:
#line 901 "pars.yacc"
{
	    if (activeset(cg)) {
		defaultgraph(cg);
		default_axis(cg, g[cg].auto_type, X_AXIS);
		default_axis(cg, g[cg].auto_type, ZX_AXIS);
		default_axis(cg, g[cg].auto_type, Y_AXIS);
		default_axis(cg, g[cg].auto_type, ZY_AXIS);
		update_world(cg);
		drawgraph();
	    } else {
		errwin("No active sets!");
	    }
	}
break;
case 97:
#line 915 "pars.yacc"
{
	    if (activeset(cg)) {
		defaultx(cg, -1);
		default_axis(cg, g[cg].auto_type, X_AXIS);
		default_axis(cg, g[cg].auto_type, ZX_AXIS);
		update_world(cg);
		drawgraph();
	    } else {
		errwin("No active sets!");
	    }
	}
break;
case 98:
#line 927 "pars.yacc"
{
	    if (activeset(cg)) {
		defaulty(cg, -1);
		default_axis(cg, g[cg].auto_type, Y_AXIS);
		default_axis(cg, g[cg].auto_type, ZY_AXIS);
		update_world(cg);
		drawgraph();
	    } else {
		errwin("No active sets!");
	    }
	}
break;
case 99:
#line 939 "pars.yacc"
{
	    if (isactive_set(cg, yyvsp[0].pset)) {
		defaultsetgraph(cg, yyvsp[0].pset);
		default_axis(cg, g[cg].auto_type, X_AXIS);
		default_axis(cg, g[cg].auto_type, ZX_AXIS);
		default_axis(cg, g[cg].auto_type, Y_AXIS);
		default_axis(cg, g[cg].auto_type, ZY_AXIS);
		update_world(cg);
		drawgraph();
	    } else {
		errwin("Set not active");
	    }
	}
break;
case 100:
#line 953 "pars.yacc"
{
	    extern int go_locateflag;
	    go_locateflag = (yyvsp[0].pset == ON);
	}
break;
case 101:
#line 958 "pars.yacc"
{
	    draw_focus(cg);
	    cg = (int) yyvsp[0].pset;
	    defineworld(g[cg].w.xg1, g[cg].w.yg1, g[cg].w.xg2, g[cg].w.yg2, 
			islogx(cg), islogy(cg));
	    viewport(g[cg].v.xv1, g[cg].v.yv1, g[cg].v.xv2, g[cg].v.yv2);
	    draw_focus(cg);
	    update_all(cg);
	}
break;
case 102:
#line 967 "pars.yacc"
{
	    draw_focus_flag = yyvsp[0].pset;
	}
break;
case 103:
#line 970 "pars.yacc"
{
	    focus_policy = yyvsp[0].pset;
	}
break;
case 104:
#line 973 "pars.yacc"
{
	    focus_policy = yyvsp[0].pset;
	}
break;
case 105:
#line 976 "pars.yacc"
{
	    focus_policy = yyvsp[0].pset;
	}
break;
case 106:
#line 979 "pars.yacc"
{
	    cursource = yyvsp[0].pset;
	}
break;
case 107:
#line 982 "pars.yacc"
{
	    curtype = yyvsp[0].pset;
	    change_type = curtype;
	}
break;
case 108:
#line 987 "pars.yacc"
{
	    gotread = TRUE;
	    readtype = curtype;
	    readsrc = cursource;
	    strcpy(readfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 109:
#line 995 "pars.yacc"
{
	    gotbatch = TRUE;
	    strcpy(batchfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 110:
#line 1001 "pars.yacc"
{
	    getdata(cg, (char *) yyvsp[0].pset, DISK, BLOCK);
	    free((char *) yyvsp[0].pset);
	}
break;
case 111:
#line 1006 "pars.yacc"
{
	    getdata(cg, (char *) yyvsp[0].pset, yyvsp[-1].pset, BLOCK);
	    free((char *) yyvsp[0].pset);
	}
break;
case 112:
#line 1011 "pars.yacc"
{
	    create_set_fromblock(cg, yyvsp[-1].pset, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 113:
#line 1016 "pars.yacc"
{
	    gotread = TRUE;
	    readtype = yyvsp[-1].pset;
	    readsrc = cursource;
	    strcpy(readfile, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 114:
#line 1024 "pars.yacc"
{
	    gotread = TRUE;
	    strcpy(readfile, (char *) yyvsp[0].pset);
	    readtype = yyvsp[-2].pset;
	    readsrc = yyvsp[-1].pset;
	    free((char *) yyvsp[0].pset);
	}
break;
case 115:
#line 1032 "pars.yacc"
{
	    read_image((char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 116:
#line 1037 "pars.yacc"
{
	    write_image((char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 117:
#line 1042 "pars.yacc"
{
	    imagex = (int) yyvsp[-2].val;
	    imagey = (int) yyvsp[0].val;
	}
break;
case 118:
#line 1047 "pars.yacc"
{
	    outputset(cg, yyvsp[0].pset, (char *) NULL, (char *) NULL);
	}
break;
case 119:
#line 1051 "pars.yacc"
{
	    outputset(cg, yyvsp[-2].pset, (char *) NULL, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 120:
#line 1056 "pars.yacc"
{
	    outputset(cg, yyvsp[-2].pset, (char *) yyvsp[0].pset, (char *) NULL);
	    free((char *) yyvsp[0].pset);
	}
break;
case 121:
#line 1061 "pars.yacc"
{
	    outputset(cg, yyvsp[-4].pset, (char *) yyvsp[-2].pset, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[-2].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 122:
#line 1067 "pars.yacc"
{
            extern char sformat[];
            do_writesets(maxgraph, -1, 1, (char *) yyvsp[0].pset, sformat);
            free((char *) yyvsp[0].pset);
        }
break;
case 123:
#line 1072 "pars.yacc"
{
	    push_world();
	}
break;
case 124:
#line 1075 "pars.yacc"
{
	    pop_world();
	}
break;
case 125:
#line 1078 "pars.yacc"
{
	    cycle_world_stack();
	}
break;
case 126:
#line 1081 "pars.yacc"
{
	    if ((int) yyvsp[0].val > 0)
		show_world_stack((int) yyvsp[0].val - 1);
	}
break;
case 127:
#line 1086 "pars.yacc"
{
	    add_world(cg, yyvsp[-14].val, yyvsp[-12].val, yyvsp[-10].val, yyvsp[-8].val, yyvsp[-6].val, yyvsp[-4].val, yyvsp[-2].val, yyvsp[0].val);
	}
break;
case 128:
#line 1089 "pars.yacc"
{
	    clear_world_stack();
	}
break;
case 129:
#line 1092 "pars.yacc"
{
	    do_clear_boxes();
	}
break;
case 130:
#line 1095 "pars.yacc"
{
	    curbox = next_box();
	}
break;
case 131:
#line 1098 "pars.yacc"
{
	    curbox = (int) yyvsp[0].val;
	}
break;
case 132:
#line 1101 "pars.yacc"
{
	    boxes[curbox].active = yyvsp[0].pset;
	}
break;
case 133:
#line 1104 "pars.yacc"
{
	    boxes[curbox].gno = yyvsp[0].pset;
	}
break;
case 134:
#line 1108 "pars.yacc"
{
	    if (curbox >= 0 && curbox < MAXBOXES) {
		boxes[curbox].x1 = yyvsp[-6].val;
		boxes[curbox].y1 = yyvsp[-4].val;
		boxes[curbox].x2 = yyvsp[-2].val;
		boxes[curbox].y2 = yyvsp[0].val;
	    }
	}
break;
case 135:
#line 1116 "pars.yacc"
{
	    box_loctype = yyvsp[0].pset;
	}
break;
case 136:
#line 1119 "pars.yacc"
{
	    box_lines = checkon(LINESTYLE, box_lines, (int) yyvsp[0].val);
	}
break;
case 137:
#line 1122 "pars.yacc"
{
	    box_linew = checkon(LINEWIDTH, box_linew, (int) yyvsp[0].val);
	}
break;
case 138:
#line 1125 "pars.yacc"
{
	    box_color = checkon(COLOR, box_color, (int) yyvsp[0].val);
	}
break;
case 139:
#line 1128 "pars.yacc"
{
	    box_fill = yyvsp[0].pset;
	}
break;
case 140:
#line 1131 "pars.yacc"
{
	    box_fillcolor = checkon(COLOR, box_fillcolor, (int) yyvsp[0].val);
	}
break;
case 141:
#line 1134 "pars.yacc"
{
	    box_fillpat = checkon(PATTERN, box_fillpat, (int) yyvsp[0].val);
	}
break;
case 142:
#line 1138 "pars.yacc"
{
	    if (curbox >= 0 && curbox < MAXBOXES) {
		boxes[curbox].lines = box_lines;
		boxes[curbox].linew = box_linew;
		boxes[curbox].color = box_color;
		boxes[curbox].fill = box_fill;
		boxes[curbox].fillcolor = box_fillcolor;
		boxes[curbox].fillpattern = box_fillpat;
		boxes[curbox].loctype = box_loctype;
	    }
	}
break;
case 143:
#line 1149 "pars.yacc"
{
	    curline = next_line();
	}
break;
case 144:
#line 1152 "pars.yacc"
{
	    curline = (int) yyvsp[0].val;
	}
break;
case 145:
#line 1155 "pars.yacc"
{
	    do_clear_lines();
	}
break;
case 146:
#line 1158 "pars.yacc"
{
	    lines[curline].active = yyvsp[0].pset;
	}
break;
case 147:
#line 1161 "pars.yacc"
{
	    lines[curline].gno = yyvsp[0].pset;
	}
break;
case 148:
#line 1165 "pars.yacc"
{
	    lines[curline].x1 = yyvsp[-6].val;
	    lines[curline].y1 = yyvsp[-4].val;
	    lines[curline].x2 = yyvsp[-2].val;
	    lines[curline].y2 = yyvsp[0].val;
	}
break;
case 149:
#line 1171 "pars.yacc"
{
	    line_loctype = yyvsp[0].pset;
	}
break;
case 150:
#line 1174 "pars.yacc"
{
	    line_linew = checkon(LINEWIDTH, line_linew, (int) yyvsp[0].val);
	}
break;
case 151:
#line 1177 "pars.yacc"
{
	    line_lines = checkon(LINESTYLE, line_lines, (int) yyvsp[0].val);
	}
break;
case 152:
#line 1180 "pars.yacc"
{
	    line_color = checkon(COLOR, line_color, (int) yyvsp[0].val);
	}
break;
case 153:
#line 1183 "pars.yacc"
{
	    line_arrow = checkon(ARROW, line_arrow, (int) yyvsp[0].val);
	}
break;
case 154:
#line 1186 "pars.yacc"
{
	    line_asize = yyvsp[0].val;
	}
break;
case 155:
#line 1189 "pars.yacc"
{
	    line_atype = (int) yyvsp[0].val;
	}
break;
case 156:
#line 1193 "pars.yacc"
{
	    if (curline >= 0 && curline < MAXLINES) {
		lines[curline].lines = line_lines;
		lines[curline].linew = line_linew;
		lines[curline].color = line_color;
		lines[curline].arrow = line_arrow;
		lines[curline].asize = line_asize;
		lines[curline].atype = line_atype;
		lines[curline].loctype = line_loctype;
	    }
	}
break;
case 157:
#line 1204 "pars.yacc"
{
	    do_clear_text();
	}
break;
case 158:
#line 1207 "pars.yacc"
{
	    curstring = next_string();
	}
break;
case 159:
#line 1210 "pars.yacc"
{
	    curstring = (int) yyvsp[0].val;
	}
break;
case 160:
#line 1213 "pars.yacc"
{
	    pstr[curstring].active = yyvsp[0].pset;
	}
break;
case 161:
#line 1216 "pars.yacc"
{
	    pstr[curstring].gno = yyvsp[0].pset;
	}
break;
case 162:
#line 1220 "pars.yacc"
{
	    pstr[curstring].x = yyvsp[-2].val;
	    pstr[curstring].y = yyvsp[0].val;
	}
break;
case 163:
#line 1224 "pars.yacc"
{
	    string_loctype = yyvsp[0].pset;
	}
break;
case 164:
#line 1227 "pars.yacc"
{
	    string_linew = checkon(LINEWIDTH, string_linew, (int) yyvsp[0].val);
	}
break;
case 165:
#line 1230 "pars.yacc"
{
	    string_color = checkon(COLOR, string_color, (int) yyvsp[0].val);
	}
break;
case 166:
#line 1233 "pars.yacc"
{
	    string_rot = (int) yyvsp[0].val;
	}
break;
case 167:
#line 1236 "pars.yacc"
{
	    string_font = checkon(FONTP, string_font, (int) yyvsp[0].val);
	}
break;
case 168:
#line 1239 "pars.yacc"
{
	    string_just = checkon(JUST, string_just, (int) yyvsp[0].val);
	}
break;
case 169:
#line 1242 "pars.yacc"
{
	    string_size = yyvsp[0].val;
	}
break;
case 170:
#line 1246 "pars.yacc"
{
	    set_plotstr_string(&pstr[curstring], (char *) yyvsp[0].pset);
	    pstr[curstring].linew = string_linew;
	    pstr[curstring].color = string_color;
	    pstr[curstring].font = string_font;
	    pstr[curstring].just = string_just;
	    pstr[curstring].loctype = string_loctype;
	    pstr[curstring].rot = string_rot;
	    pstr[curstring].charsize = string_size;
	    free((char *) yyvsp[0].pset);
	}
break;
case 171:
#line 1257 "pars.yacc"
{
	    grdefaults.lines = (int) yyvsp[0].val;
	}
break;
case 172:
#line 1260 "pars.yacc"
{
	    grdefaults.linew = (int) yyvsp[0].val;
	}
break;
case 173:
#line 1263 "pars.yacc"
{
	    grdefaults.color = (int) yyvsp[0].val;
	}
break;
case 174:
#line 1266 "pars.yacc"
{
	    grdefaults.charsize = yyvsp[0].val;
	}
break;
case 175:
#line 1269 "pars.yacc"
{
	    grdefaults.font = (int) yyvsp[0].val;
	}
break;
case 176:
#line 1272 "pars.yacc"
{
	    grdefaults.fontsrc = (int) yyvsp[0].val;
	}
break;
case 177:
#line 1275 "pars.yacc"
{
	    grdefaults.symsize = yyvsp[0].val;
	}
break;
case 178:
#line 1279 "pars.yacc"
{
	    g[cg].w.xg1 = yyvsp[-6].val;
	    g[cg].w.yg1 = yyvsp[-4].val;
	    g[cg].w.xg2 = yyvsp[-2].val;
	    g[cg].w.yg2 = yyvsp[0].val;
	}
break;
case 179:
#line 1285 "pars.yacc"
{
	    g[cg].w.xg1 = yyvsp[0].val;
	}
break;
case 180:
#line 1288 "pars.yacc"
{
	    g[cg].w.xg2 = yyvsp[0].val;
	}
break;
case 181:
#line 1291 "pars.yacc"
{
	    g[cg].w.yg1 = yyvsp[0].val;
	}
break;
case 182:
#line 1294 "pars.yacc"
{
	    g[cg].w.yg2 = yyvsp[0].val;
	}
break;
case 183:
#line 1298 "pars.yacc"
{
	    g[cg].v.xv1 = yyvsp[-6].val;
	    g[cg].v.yv1 = yyvsp[-4].val;
	    g[cg].v.xv2 = yyvsp[-2].val;
	    g[cg].v.yv2 = yyvsp[0].val;
	}
break;
case 184:
#line 1304 "pars.yacc"
{
	    g[cg].v.xv1 = yyvsp[0].val;
	}
break;
case 185:
#line 1307 "pars.yacc"
{
	    g[cg].v.xv2 = yyvsp[0].val;
	}
break;
case 186:
#line 1310 "pars.yacc"
{
	    g[cg].v.yv1 = yyvsp[0].val;
	}
break;
case 187:
#line 1313 "pars.yacc"
{
	    g[cg].v.yv2 = yyvsp[0].val;
	}
break;
case 188:
#line 1316 "pars.yacc"
{
	    set_plotstr_string(&g[cg].labs.title, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 189:
#line 1320 "pars.yacc"
{
	    g[cg].labs.title.font = checkon(FONTP, g[cg].labs.title.font, (int) yyvsp[0].val);
	}
break;
case 190:
#line 1323 "pars.yacc"
{
	    g[cg].labs.title.charsize = yyvsp[0].val;
	}
break;
case 191:
#line 1326 "pars.yacc"
{
	    g[cg].labs.title.color = checkon(COLOR, g[cg].labs.title.color, (int) yyvsp[0].val);
	}
break;
case 192:
#line 1330 "pars.yacc"
{
	    g[cg].labs.title.linew = checkon(LINEWIDTH, g[cg].labs.title.linew, (int) yyvsp[0].val);
	}
break;
case 193:
#line 1333 "pars.yacc"
{
	    set_plotstr_string(&g[cg].labs.stitle, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 194:
#line 1338 "pars.yacc"
{
	    g[cg].labs.stitle.font = checkon(FONTP, g[cg].labs.stitle.font, (int) yyvsp[0].val);
	}
break;
case 195:
#line 1341 "pars.yacc"
{
	    g[cg].labs.stitle.charsize = yyvsp[0].val;
	}
break;
case 196:
#line 1345 "pars.yacc"
{
	    g[cg].labs.stitle.color = checkon(COLOR, g[cg].labs.stitle.color, (int) yyvsp[0].val);
	}
break;
case 197:
#line 1349 "pars.yacc"
{
	    g[cg].labs.stitle.linew = checkon(LINEWIDTH, g[cg].labs.stitle.color, (int) yyvsp[0].val);
	}
break;
case 198:
#line 1352 "pars.yacc"
{
	    realloc_plots((int) yyvsp[0].val);
	}
break;
case 199:
#line 1355 "pars.yacc"
{
	    g[cg].l.active = yyvsp[0].pset;
	}
break;
case 200:
#line 1358 "pars.yacc"
{
	    g[cg].l.loctype = yyvsp[0].pset;
	}
break;
case 201:
#line 1361 "pars.yacc"
{
	    g[cg].l.layout = (int) yyvsp[0].val;
	}
break;
case 202:
#line 1364 "pars.yacc"
{
	    g[cg].l.vgap = (int) yyvsp[0].val;
	}
break;
case 203:
#line 1367 "pars.yacc"
{
	    g[cg].l.hgap = (int) yyvsp[0].val;
	}
break;
case 204:
#line 1370 "pars.yacc"
{
	    g[cg].l.len = (int) yyvsp[0].val;
	}
break;
case 205:
#line 1373 "pars.yacc"
{
	    g[cg].l.box = yyvsp[0].pset;
	}
break;
case 206:
#line 1376 "pars.yacc"
{
	    g[cg].l.boxfill = yyvsp[0].pset;
	}
break;
case 207:
#line 1379 "pars.yacc"
{
	    g[cg].l.boxfillusing = yyvsp[0].pset;
	}
break;
case 208:
#line 1383 "pars.yacc"
{
	    if (yyvsp[-1].pset == COLOR) {
		g[cg].l.boxfillcolor = (int) yyvsp[0].val;
	    } else {
		g[cg].l.boxfillpat = (int) yyvsp[0].val;
	    }
	}
break;
case 209:
#line 1390 "pars.yacc"
{
	    g[cg].l.boxlcolor = checkon(COLOR, g[cg].l.boxlcolor, (int) yyvsp[0].val);
	}
break;
case 210:
#line 1393 "pars.yacc"
{
	    g[cg].l.boxlines = checkon(LINESTYLE, g[cg].l.boxlines, (int) yyvsp[0].val);
	}
break;
case 211:
#line 1396 "pars.yacc"
{
	    g[cg].l.boxlinew = checkon(LINEWIDTH, g[cg].l.boxlinew, (int) yyvsp[0].val);
	}
break;
case 212:
#line 1399 "pars.yacc"
{
	    g[cg].l.legx = yyvsp[-2].val;
	    g[cg].l.legy = yyvsp[0].val;
	}
break;
case 213:
#line 1403 "pars.yacc"
{
	    g[cg].l.legx = yyvsp[0].val;
	}
break;
case 214:
#line 1406 "pars.yacc"
{
	    g[cg].l.legy = yyvsp[0].val;
	}
break;
case 215:
#line 1409 "pars.yacc"
{
	    g[cg].l.charsize = yyvsp[0].val;
	}
break;
case 216:
#line 1412 "pars.yacc"
{
	    g[cg].l.font = checkon(FONTP, g[cg].l.font, (int) yyvsp[0].val);
	}
break;
case 217:
#line 1415 "pars.yacc"
{
	    g[cg].l.lines = checkon(LINESTYLE, g[cg].l.lines, (int) yyvsp[0].val);
	}
break;
case 218:
#line 1418 "pars.yacc"
{
	    g[cg].l.linew = checkon(LINEWIDTH, g[cg].l.linew, (int) yyvsp[0].val);
	}
break;
case 219:
#line 1421 "pars.yacc"
{
	    g[cg].l.color = checkon(COLOR, g[cg].l.color, (int) yyvsp[0].val);
	}
break;
case 220:
#line 1424 "pars.yacc"
{
	    set_plotstr_string(&g[cg].l.str[(int) yyvsp[-1].val], (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 221:
#line 1428 "pars.yacc"
{
	    g[cg].f.active = yyvsp[0].pset;
	}
break;
case 222:
#line 1431 "pars.yacc"
{
	    g[cg].f.type = (int) yyvsp[0].val;
	}
break;
case 223:
#line 1434 "pars.yacc"
{
	    g[cg].f.lines = checkon(LINESTYLE, g[cg].f.lines, (int) yyvsp[0].val);
	}
break;
case 224:
#line 1437 "pars.yacc"
{
	    g[cg].f.linew = checkon(LINEWIDTH, g[cg].f.linew, (int) yyvsp[0].val);
	}
break;
case 225:
#line 1440 "pars.yacc"
{
	    g[cg].f.color = checkon(COLOR, g[cg].f.color, (int) yyvsp[0].val);
	}
break;
case 226:
#line 1443 "pars.yacc"
{
	    g[cg].f.fillbg = yyvsp[0].pset;
	}
break;
case 227:
#line 1446 "pars.yacc"
{
	    g[cg].f.bgcolor = (int) yyvsp[0].val;
	}
break;
case 228:
#line 1449 "pars.yacc"
{
	    g[yyvsp[-1].pset].active = yyvsp[0].pset;
	}
break;
case 229:
#line 1452 "pars.yacc"
{
	    g[yyvsp[-2].pset].label = yyvsp[0].pset;
	}
break;
case 230:
#line 1455 "pars.yacc"
{
	    g[yyvsp[-3].pset].auto_type = yyvsp[0].pset;
	}
break;
case 231:
#line 1458 "pars.yacc"
{
	    g[yyvsp[-3].pset].auto_type = yyvsp[0].pset;
	}
break;
case 232:
#line 1461 "pars.yacc"
{
	    g[yyvsp[-2].pset].parmsread = (yyvsp[0].pset == FALSEP);
	}
break;
case 233:
#line 1464 "pars.yacc"
{
	    g[yyvsp[-2].pset].hidden = (yyvsp[0].pset == TRUEP);
	}
break;
case 234:
#line 1467 "pars.yacc"
{
	    g[yyvsp[-2].pset].type = yyvsp[0].pset;
	}
break;
case 235:
#line 1470 "pars.yacc"
{
	    g[yyvsp[-3].pset].barwid = yyvsp[0].val;
	}
break;
case 236:
#line 1473 "pars.yacc"
{
	    g[yyvsp[-3].pset].sbarwid = yyvsp[0].val;
	}
break;
case 237:
#line 1476 "pars.yacc"
{
	    g[yyvsp[-2].pset].pointset = (yyvsp[0].pset == ON);
	}
break;
case 238:
#line 1480 "pars.yacc"
{
	    g[yyvsp[-4].pset].fx = yyvsp[-1].pset;
	    g[yyvsp[-4].pset].fy = yyvsp[0].pset;
	}
break;
case 239:
#line 1485 "pars.yacc"
{
	    g[yyvsp[-5].pset].px = yyvsp[-2].val;
	    g[yyvsp[-5].pset].py = yyvsp[0].val;
	}
break;
case 240:
#line 1490 "pars.yacc"
{
	    g[yyvsp[-5].pset].dsx = yyvsp[-2].val;
	    g[yyvsp[-5].pset].dsy = yyvsp[0].val;
	}
break;
case 241:
#line 1494 "pars.yacc"
{
	    g[yyvsp[-3].pset].pt_type = (int) yyvsp[0].val;
	}
break;
case 242:
#line 1497 "pars.yacc"
{
	    realloc_graph_plots(yyvsp[-3].pset, (int) yyvsp[0].val);
	}
break;
case 243:
#line 1503 "pars.yacc"
{ g[cg].vp.vscale = yyvsp[0].val; }
break;
case 244:
#line 1504 "pars.yacc"
{ g[cg].vp.active = yyvsp[0].pset; }
break;
case 245:
#line 1505 "pars.yacc"
{ g[cg].vp.linew = (int) yyvsp[0].val; }
break;
case 246:
#line 1506 "pars.yacc"
{ g[cg].vp.lines = (int) yyvsp[0].val; }
break;
case 247:
#line 1507 "pars.yacc"
{ g[cg].vp.color = (int) yyvsp[0].val; }
break;
case 248:
#line 1508 "pars.yacc"
{ g[cg].vp.loctype = yyvsp[0].pset; }
break;
case 249:
#line 1509 "pars.yacc"
{ g[cg].vp.arrowtype = (int) yyvsp[0].val; }
break;
case 250:
#line 1513 "pars.yacc"
{
	    yyval.pset = XY;
	}
break;
case 251:
#line 1516 "pars.yacc"
{
	    yyval.pset = XYARC;
	}
break;
case 252:
#line 1519 "pars.yacc"
{
	    yyval.pset = XYBOX;
	}
break;
case 253:
#line 1522 "pars.yacc"
{
	    yyval.pset = XYBOXPLOT;
	}
break;
case 254:
#line 1525 "pars.yacc"
{
	    yyval.pset = XYHILO;
	}
break;
case 255:
#line 1528 "pars.yacc"
{
	    yyval.pset = XYRT;
	}
break;
case 256:
#line 1531 "pars.yacc"
{
	    yyval.pset = XYSEG;
	}
break;
case 257:
#line 1534 "pars.yacc"
{
	    yyval.pset = XYSTRING;
	}
break;
case 258:
#line 1537 "pars.yacc"
{
	    yyval.pset = XYDX;
	}
break;
case 259:
#line 1540 "pars.yacc"
{
	    yyval.pset = XYDY;
	}
break;
case 260:
#line 1543 "pars.yacc"
{
	    yyval.pset = XYDXDX;
	}
break;
case 261:
#line 1546 "pars.yacc"
{
	    yyval.pset = XYDYDY;
	}
break;
case 262:
#line 1549 "pars.yacc"
{
	    yyval.pset = XYDXDY;
	}
break;
case 263:
#line 1552 "pars.yacc"
{
	    yyval.pset = XYX2Y2;
	}
break;
case 264:
#line 1555 "pars.yacc"
{
	    yyval.pset = XYXX;
	}
break;
case 265:
#line 1558 "pars.yacc"
{
	    yyval.pset = XYYY;
	}
break;
case 266:
#line 1561 "pars.yacc"
{
	    yyval.pset = XYZ;
	}
break;
case 267:
#line 1564 "pars.yacc"
{
	    yyval.pset = XYZW;
	}
break;
case 268:
#line 1567 "pars.yacc"
{
	    yyval.pset = XYUV;
	}
break;
case 269:
#line 1570 "pars.yacc"
{
	    yyval.pset = NXY;
	}
break;
case 270:
#line 1573 "pars.yacc"
{
	    yyval.pset = BIN;
	}
break;
case 271:
#line 1576 "pars.yacc"
{
	    yyval.pset = RAWSPICE;
	}
break;
case 272:
#line 1582 "pars.yacc"
{
	    yyval.pset = yyvsp[0].pset;
	}
break;
case 273:
#line 1585 "pars.yacc"
{
	    yyval.pset = yyvsp[0].pset;
	}
break;
case 274:
#line 1588 "pars.yacc"
{
	    yyval.pset = yyvsp[0].pset;
	}
break;
case 275:
#line 1591 "pars.yacc"
{
	    yyval.pset = yyvsp[0].pset;
	}
break;
case 276:
#line 1594 "pars.yacc"
{
	    yyval.pset = yyvsp[0].pset;
	}
break;
case 277:
#line 1597 "pars.yacc"
{
	    yyval.pset = yyvsp[0].pset;
	}
break;
case 278:
#line 1600 "pars.yacc"
{
	    yyval.pset = yyvsp[0].pset;
	}
break;
case 279:
#line 1603 "pars.yacc"
{
	    yyval.pset = yyvsp[0].pset;
	}
break;
case 280:
#line 1606 "pars.yacc"
{
	    yyval.pset = XY;		/* not active */
	}
break;
case 281:
#line 1609 "pars.yacc"
{
	    yyval.pset = XY;		/* not active */
	}
break;
case 282:
#line 1612 "pars.yacc"
{
	    yyval.pset = yyvsp[0].pset;
	}
break;
case 283:
#line 1615 "pars.yacc"
{
	    yyval.pset = yyvsp[0].pset;
	}
break;
case 284:
#line 1621 "pars.yacc"
{
            yyval.pset = FREE;
        }
break;
case 285:
#line 1624 "pars.yacc"
{
            yyval.pset = LANDSCAPE;
        }
break;
case 286:
#line 1627 "pars.yacc"
{
            yyval.pset = PORTRAIT;
        }
break;
case 287:
#line 1630 "pars.yacc"
{
            yyval.pset = FIXED;
        }
break;
case 295:
#line 1660 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ACTIVE, yyvsp[0].pset, 0);
	}
break;
case 296:
#line 1663 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ACTIVE, yyvsp[0].pset, 0);
	}
break;
case 297:
#line 1666 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, TYPE, yyvsp[0].pset, 0);
	}
break;
case 298:
#line 1669 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, MISSINGP, yyvsp[0].val, 0);
	}
break;
case 299:
#line 1672 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, PREC, (int) yyvsp[0].val, 0);
	}
break;
case 300:
#line 1675 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FORMAT, yyvsp[0].pset, 0);
	}
break;
case 301:
#line 1678 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, TYPE, (int) yyvsp[0].val, 0);
	}
break;
case 302:
#line 1681 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, FILL, (int) yyvsp[0].val, 0);
	}
break;
case 303:
#line 1684 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, CENTER, (yyvsp[0].pset == TRUEP), 0);
	}
break;
case 304:
#line 1687 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, SIZE, yyvsp[0].val, 0);
	}
break;
case 305:
#line 1690 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, CHAR, (int) yyvsp[0].val, 0);
	}
break;
case 306:
#line 1693 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, SKIP, (int) yyvsp[0].val, 0);
	}
break;
case 307:
#line 1696 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, COLOR, (int) yyvsp[0].val, 0);
	}
break;
case 308:
#line 1699 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, LINEWIDTH, (int) yyvsp[0].val, 0);
	}
break;
case 309:
#line 1702 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SYMBOL, LINESTYLE, (int) yyvsp[0].val, 0);
	}
break;
case 310:
#line 1705 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, yyvsp[-1].pset, (int) yyvsp[0].val, 0);
	}
break;
case 311:
#line 1708 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FILL, TYPE, (int) yyvsp[0].val, 0);
	}
break;
case 312:
#line 1711 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FILL, WITH, yyvsp[0].pset, 0);
	}
break;
case 313:
#line 1714 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, FILL, yyvsp[-1].pset, (int) yyvsp[0].val, 0);
	}
break;
case 314:
#line 1717 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, SKIP, (int) yyvsp[0].val, 0);
	}
break;
case 315:
#line 1720 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, LENGTH, yyvsp[0].val, 0);
	}
break;
case 316:
#line 1723 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, TYPE, yyvsp[0].pset, 0);
	}
break;
case 317:
#line 1726 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, LINEWIDTH, (int) yyvsp[0].val, 0);
	}
break;
case 318:
#line 1729 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, LINESTYLE, (int) yyvsp[0].val, 0);
	}
break;
case 319:
#line 1732 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, RISER, ACTIVE, yyvsp[0].pset, 0);
	}
break;
case 320:
#line 1735 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, RISER, LINEWIDTH, (int) yyvsp[0].val, 0);
	}
break;
case 321:
#line 1738 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, ERRORBAR, RISER, LINESTYLE, (int) yyvsp[0].val, 0);
	}
break;
case 322:
#line 1741 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, XYZ, yyvsp[-2].val, yyvsp[0].val, 0);
	}
break;
case 323:
#line 1744 "pars.yacc"
{
	    set_prop(whichgraph, SET, SETNUM, whichset, COMMENT, (char *) yyvsp[0].pset, 0);
	    free((char *) yyvsp[0].pset);
	}
break;
case 339:
#line 1775 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[0].pset, 0.0);
	}
break;
case 340:
#line 1778 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 341:
#line 1781 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 342:
#line 1784 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 343:
#line 1787 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].val);
	}
break;
case 344:
#line 1790 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-2].pset, yyvsp[0].val);
	}
break;
case 345:
#line 1793 "pars.yacc"
{
	    set_axis_prop(whichgraph, naxis, yyvsp[-1].pset, yyvsp[0].pset);
	}
break;
case 350:
#line 1803 "pars.yacc"
{
	    g[cg].t[naxis].active = yyvsp[0].pset;
	}
break;
case 353:
#line 1815 "pars.yacc"
{
	    g[cg].t[naxis].t_flag = yyvsp[0].pset;
	    g[cg].t[naxis].t_mflag = yyvsp[0].pset;
	}
break;
case 354:
#line 1819 "pars.yacc"
{
	    g[cg].t[naxis].t_flag = yyvsp[0].pset;
	}
break;
case 355:
#line 1822 "pars.yacc"
{
	    g[cg].t[naxis].t_mflag = yyvsp[0].pset;
	}
break;
case 356:
#line 1825 "pars.yacc"
{
	    g[cg].t[naxis].tmajor = yyvsp[0].val;
	}
break;
case 357:
#line 1828 "pars.yacc"
{
	    g[cg].t[naxis].tminor = yyvsp[0].val;
	}
break;
case 358:
#line 1831 "pars.yacc"
{
	    g[cg].t[naxis].offsx = yyvsp[0].val;
	}
break;
case 359:
#line 1834 "pars.yacc"
{
	    g[cg].t[naxis].offsy = yyvsp[0].val;
	}
break;
case 360:
#line 1837 "pars.yacc"
{
	    g[cg].t[naxis].alt = yyvsp[0].pset;
	}
break;
case 361:
#line 1840 "pars.yacc"
{
	    g[cg].t[naxis].tmin = yyvsp[0].val;
	}
break;
case 362:
#line 1843 "pars.yacc"
{
	    g[cg].t[naxis].tmax = yyvsp[0].val;
	}
break;
case 363:
#line 1846 "pars.yacc"
{
	    g[cg].t[naxis].t_num = (int) yyvsp[0].val;
	}
break;
case 364:
#line 1849 "pars.yacc"
{
	    g[cg].t[naxis].t_inout = yyvsp[0].pset;
	}
break;
case 365:
#line 1852 "pars.yacc"
{
	    g[cg].t[naxis].t_log = yyvsp[0].pset;
	}
break;
case 366:
#line 1855 "pars.yacc"
{
	    g[cg].t[naxis].t_size = yyvsp[0].val;
	}
break;
case 367:
#line 1858 "pars.yacc"
{
	    g[cg].t[naxis].t_size = yyvsp[0].val;
	}
break;
case 368:
#line 1861 "pars.yacc"
{
	    g[cg].t[naxis].t_msize = yyvsp[0].val;
	}
break;
case 369:
#line 1864 "pars.yacc"
{
	    g[cg].t[naxis].t_color = g[cg].t[naxis].t_mcolor = (int) yyvsp[0].val;
	}
break;
case 370:
#line 1867 "pars.yacc"
{
	    g[cg].t[naxis].t_linew = g[cg].t[naxis].t_mlinew = (int) yyvsp[0].val;
	}
break;
case 371:
#line 1870 "pars.yacc"
{
	    g[cg].t[naxis].t_color = (int) yyvsp[0].val;
	}
break;
case 372:
#line 1873 "pars.yacc"
{
	    g[cg].t[naxis].t_mcolor = (int) yyvsp[0].val;
	}
break;
case 373:
#line 1876 "pars.yacc"
{
	    g[cg].t[naxis].t_linew = (int) yyvsp[0].val;
	}
break;
case 374:
#line 1879 "pars.yacc"
{
	    g[cg].t[naxis].t_mlinew = (int) yyvsp[0].val;
	}
break;
case 375:
#line 1882 "pars.yacc"
{
	    g[cg].t[naxis].t_lines = (int) yyvsp[0].val;
	}
break;
case 376:
#line 1885 "pars.yacc"
{
	    g[cg].t[naxis].t_mlines = (int) yyvsp[0].val;
	}
break;
case 377:
#line 1888 "pars.yacc"
{
	    g[cg].t[naxis].t_gridflag = yyvsp[0].pset;
	}
break;
case 378:
#line 1891 "pars.yacc"
{
	    g[cg].t[naxis].t_mgridflag = yyvsp[0].pset;
	}
break;
case 379:
#line 1894 "pars.yacc"
{
	    g[cg].t[naxis].t_op = yyvsp[0].pset;
	}
break;
case 380:
#line 1897 "pars.yacc"
{
	    g[cg].t[naxis].t_type = AUTO;
	}
break;
case 381:
#line 1900 "pars.yacc"
{
	    g[cg].t[naxis].t_type = SPEC;
	}
break;
case 382:
#line 1903 "pars.yacc"
{
	    g[cg].t[naxis].t_spec = (int) yyvsp[0].val;
	}
break;
case 383:
#line 1906 "pars.yacc"
{
	    g[cg].t[naxis].t_specloc[(int) yyvsp[-2].val] = yyvsp[0].val;
	}
break;
case 386:
#line 1917 "pars.yacc"
{
	    g[cg].t[naxis].tl_flag = yyvsp[0].pset;
	}
break;
case 387:
#line 1920 "pars.yacc"
{
	    g[cg].t[naxis].tl_type = AUTO;
	}
break;
case 388:
#line 1923 "pars.yacc"
{
	    g[cg].t[naxis].tl_type = SPEC;
	}
break;
case 389:
#line 1926 "pars.yacc"
{
	    g[cg].t[naxis].tl_prec = (int) yyvsp[0].val;
	}
break;
case 390:
#line 1929 "pars.yacc"
{
	    g[cg].t[naxis].tl_format = yyvsp[0].pset;
	}
break;
case 391:
#line 1932 "pars.yacc"
{
	    g[cg].t[naxis].tl_format = yyvsp[0].val;
	}
break;
case 392:
#line 1935 "pars.yacc"
{
	    strcpy(g[cg].t[naxis].tl_appstr, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 393:
#line 1939 "pars.yacc"
{
	    strcpy(g[cg].t[naxis].tl_prestr, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 394:
#line 1943 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = HORIZONTAL;
	}
break;
case 395:
#line 1946 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = VERTICAL;
	}
break;
case 396:
#line 1949 "pars.yacc"
{
	    g[cg].t[naxis].tl_layout = SPEC;
	}
break;
case 397:
#line 1952 "pars.yacc"
{
	    g[cg].t[naxis].tl_angle = (int) yyvsp[0].val;
	}
break;
case 398:
#line 1955 "pars.yacc"
{
	    g[cg].t[naxis].tl_just = (int) yyvsp[0].pset;
	}
break;
case 399:
#line 1958 "pars.yacc"
{
	    g[cg].t[naxis].tl_skip = (int) yyvsp[0].val;
	}
break;
case 400:
#line 1961 "pars.yacc"
{
	    g[cg].t[naxis].tl_staggered = (int) yyvsp[0].val;
	}
break;
case 401:
#line 1964 "pars.yacc"
{
	    g[cg].t[naxis].tl_op = yyvsp[0].pset;
	}
break;
case 402:
#line 1967 "pars.yacc"
{
	    g[cg].t[naxis].tl_sign = yyvsp[0].pset;
	}
break;
case 403:
#line 1970 "pars.yacc"
{
	    g[cg].t[naxis].tl_start = yyvsp[0].val;
	}
break;
case 404:
#line 1973 "pars.yacc"
{
	    g[cg].t[naxis].tl_stop = yyvsp[0].val;
	}
break;
case 405:
#line 1976 "pars.yacc"
{
	    g[cg].t[naxis].tl_starttype = (int) yyvsp[0].pset;
	}
break;
case 406:
#line 1979 "pars.yacc"
{
	    g[cg].t[naxis].tl_starttype = (int) yyvsp[0].pset;
	}
break;
case 407:
#line 1982 "pars.yacc"
{
	    g[cg].t[naxis].tl_stoptype = (int) yyvsp[0].pset;
	}
break;
case 408:
#line 1985 "pars.yacc"
{
	    g[cg].t[naxis].tl_stoptype = (int) yyvsp[0].pset;
	}
break;
case 409:
#line 1988 "pars.yacc"
{
	    g[cg].t[naxis].tl_vgap = yyvsp[0].val;
	}
break;
case 410:
#line 1991 "pars.yacc"
{
	    g[cg].t[naxis].tl_hgap = yyvsp[0].val;
	}
break;
case 411:
#line 1994 "pars.yacc"
{
	    g[cg].t[naxis].tl_charsize = yyvsp[0].val;
	}
break;
case 412:
#line 1997 "pars.yacc"
{
	    g[cg].t[naxis].tl_font = (int) yyvsp[0].val;
	}
break;
case 413:
#line 2000 "pars.yacc"
{
	    g[cg].t[naxis].tl_color = (int) yyvsp[0].val;
	}
break;
case 414:
#line 2003 "pars.yacc"
{
	    g[cg].t[naxis].tl_linew = (int) yyvsp[0].val;
	}
break;
case 415:
#line 2006 "pars.yacc"
{
	    set_plotstr_string(&g[cg].t[naxis].t_speclab[(int) yyvsp[-2].val], (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 416:
#line 2013 "pars.yacc"
{
	    set_plotstr_string(&g[cg].t[naxis].label, (char *) yyvsp[0].pset);
	    free((char *) yyvsp[0].pset);
	}
break;
case 417:
#line 2017 "pars.yacc"
{
	    g[cg].t[naxis].label_layout = PERP;
	}
break;
case 418:
#line 2020 "pars.yacc"
{
	    g[cg].t[naxis].label_layout = PARA;
	}
break;
case 419:
#line 2023 "pars.yacc"
{
	    g[cg].t[naxis].label_place = yyvsp[0].pset;
	}
break;
case 420:
#line 2026 "pars.yacc"
{
	    g[cg].t[naxis].label_place = yyvsp[0].pset;
	}
break;
case 421:
#line 2029 "pars.yacc"
{
	    g[cg].t[naxis].label.x = yyvsp[-2].val;
	    g[cg].t[naxis].label.y = yyvsp[0].val;
	}
break;
case 422:
#line 2033 "pars.yacc"
{
	    g[cg].t[naxis].label.just = (int) yyvsp[0].pset;
	}
break;
case 423:
#line 2036 "pars.yacc"
{
	    g[cg].t[naxis].label.charsize = yyvsp[0].val;
	}
break;
case 424:
#line 2039 "pars.yacc"
{
	    g[cg].t[naxis].label.font = (int) yyvsp[0].val;
	}
break;
case 425:
#line 2042 "pars.yacc"
{
	    g[cg].t[naxis].label.color = (int) yyvsp[0].val;
	}
break;
case 426:
#line 2045 "pars.yacc"
{
	    g[cg].t[naxis].label.linew = (int) yyvsp[0].val;
	}
break;
case 427:
#line 2051 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbar = yyvsp[0].pset;
	}
break;
case 428:
#line 2054 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbarcolor = (int) yyvsp[0].val;
	}
break;
case 429:
#line 2057 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbarlines = (int) yyvsp[0].val;
	}
break;
case 430:
#line 2060 "pars.yacc"
{
	    g[cg].t[naxis].t_drawbarlinew = (int) yyvsp[0].val;
	}
break;
case 431:
#line 2067 "pars.yacc"
{
	    whichgraph = yyvsp[-2].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 432:
#line 2072 "pars.yacc"
{
	    whichgraph = cg;
	    whichset = yyvsp[0].pset;
	}
break;
case 433:
#line 2077 "pars.yacc"
{
	    whichgraph = cg;
	    whichset = yyvsp[0].pset;
	}
break;
case 434:
#line 2082 "pars.yacc"
{
	    whichgraph = yyvsp[-1].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 435:
#line 2087 "pars.yacc"
{
	    whichgraph = yyvsp[-1].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 436:
#line 2092 "pars.yacc"
{
	    whichgraph = yyvsp[-1].pset;
	    whichset = yyvsp[0].pset;
	}
break;
case 437:
#line 2099 "pars.yacc"
{
            yyval.pset = yyvsp[0].pset;
        }
break;
case 438:
#line 2102 "pars.yacc"
{
            yyval.pset = yyvsp[0].pset;
        }
break;
case 439:
#line 2105 "pars.yacc"
{
            yyval.pset = yyvsp[0].pset;
        }
break;
case 440:
#line 2108 "pars.yacc"
{
            yyval.pset = yyvsp[0].pset;
        }
break;
case 441:
#line 2111 "pars.yacc"
{
            yyval.pset = yyvsp[0].pset;
        }
break;
case 442:
#line 2117 "pars.yacc"
{
	    yyval.pset = ON;
	}
break;
case 443:
#line 2120 "pars.yacc"
{
	    yyval.pset = OFF;
	}
break;
case 444:
#line 2126 "pars.yacc"
{
	    yyval.pset = COLOR;
	}
break;
case 445:
#line 2129 "pars.yacc"
{
	    yyval.pset = PATTERN;
	}
break;
case 446:
#line 2135 "pars.yacc"
{
	    yyval.pset = RUNAVG;
	}
break;
case 447:
#line 2138 "pars.yacc"
{
	    yyval.pset = RUNSTD;
	}
break;
case 448:
#line 2141 "pars.yacc"
{
	    yyval.pset = RUNMED;
	}
break;
case 449:
#line 2144 "pars.yacc"
{
	    yyval.pset = RUNMAX;
	}
break;
case 450:
#line 2147 "pars.yacc"
{
	    yyval.pset = RUNMIN;
	}
break;
case 451:
#line 2153 "pars.yacc"
{
	    yyval.pset = DFT;
	}
break;
case 452:
#line 2156 "pars.yacc"
{
	    yyval.pset = FFT;
	}
break;
case 453:
#line 2159 "pars.yacc"
{
	    yyval.pset = INVDFT;
	}
break;
case 454:
#line 2162 "pars.yacc"
{
	    yyval.pset = INVFFT;
	}
break;
case 455:
#line 2168 "pars.yacc"
{
	    yyval.pset = DISK;
	}
break;
case 456:
#line 2171 "pars.yacc"
{
	    yyval.pset = PIPE;
	}
break;
case 457:
#line 2177 "pars.yacc"
{
	    yyval.pset = PATTERN;
	}
break;
case 458:
#line 2180 "pars.yacc"
{
	    yyval.pset = COLOR;
	}
break;
case 459:
#line 2183 "pars.yacc"
{
	    yyval.pset = NONE;
	}
break;
case 460:
#line 2189 "pars.yacc"
{
	    yyval.pset = TOP;
	}
break;
case 461:
#line 2192 "pars.yacc"
{
	    yyval.pset = BOTTOM;
	}
break;
case 462:
#line 2195 "pars.yacc"
{
	    yyval.pset = LEFT;
	}
break;
case 463:
#line 2198 "pars.yacc"
{
	    yyval.pset = RIGHT;
	}
break;
case 464:
#line 2201 "pars.yacc"
{
	    yyval.pset = BOTH;
	}
break;
case 465:
#line 2207 "pars.yacc"
{
	    yyval.pset = RIGHT;
	}
break;
case 466:
#line 2210 "pars.yacc"
{
	    yyval.pset = LEFT;
	}
break;
case 467:
#line 2213 "pars.yacc"
{
	    yyval.pset = CENTER;
	}
break;
case 468:
#line 2219 "pars.yacc"
{
	    yyval.pset = MINP;
	}
break;
case 469:
#line 2222 "pars.yacc"
{
	    yyval.pset = MAXP;
	}
break;
case 470:
#line 2228 "pars.yacc"
{
	    yyval.pset = TRUEP;
	}
break;
case 471:
#line 2231 "pars.yacc"
{
	    yyval.pset = FALSEP;
	}
break;
case 472:
#line 2237 "pars.yacc"
{
	    yyval.pset = IN;
	}
break;
case 473:
#line 2240 "pars.yacc"
{
	    yyval.pset = OUT;
	}
break;
case 474:
#line 2243 "pars.yacc"
{
	    yyval.pset = BOTH;
	}
break;
case 475:
#line 2249 "pars.yacc"
{
	    yyval.pset = DECIMAL;
	}
break;
case 476:
#line 2252 "pars.yacc"
{
	    yyval.pset = EXPONENTIAL;
	}
break;
case 477:
#line 2255 "pars.yacc"
{
	    yyval.pset = POWER;
	}
break;
case 478:
#line 2258 "pars.yacc"
{
	    yyval.pset = GENERAL;
	}
break;
case 479:
#line 2261 "pars.yacc"
{
	    yyval.pset = DDMMYY;
	}
break;
case 480:
#line 2264 "pars.yacc"
{
	    yyval.pset = MMDDYY;
	}
break;
case 481:
#line 2267 "pars.yacc"
{
	    yyval.pset = MMYY;
	}
break;
case 482:
#line 2270 "pars.yacc"
{
	    yyval.pset = MMDD;
	}
break;
case 483:
#line 2273 "pars.yacc"
{
	    yyval.pset = MONTHDAY;
	}
break;
case 484:
#line 2276 "pars.yacc"
{
	    yyval.pset = DAYMONTH;
	}
break;
case 485:
#line 2279 "pars.yacc"
{
	    yyval.pset = MONTHS;
	}
break;
case 486:
#line 2282 "pars.yacc"
{
	    yyval.pset = MONTHL;
	}
break;
case 487:
#line 2285 "pars.yacc"
{
	    yyval.pset = DAYOFWEEKS;
	}
break;
case 488:
#line 2288 "pars.yacc"
{
	    yyval.pset = DAYOFWEEKL;
	}
break;
case 489:
#line 2291 "pars.yacc"
{
	    yyval.pset = DAYOFYEAR;
	}
break;
case 490:
#line 2294 "pars.yacc"
{
	    yyval.pset = HMS;
	}
break;
case 491:
#line 2297 "pars.yacc"
{
	    yyval.pset = MMDDHMS;
	}
break;
case 492:
#line 2300 "pars.yacc"
{
	    yyval.pset = MMDDYYHMS;
	}
break;
case 493:
#line 2303 "pars.yacc"
{
	    yyval.pset = DEGREESLON;
	}
break;
case 494:
#line 2306 "pars.yacc"
{
	    yyval.pset = DEGREESMMLON;
	}
break;
case 495:
#line 2309 "pars.yacc"
{
	    yyval.pset = DEGREESMMSSLON;
	}
break;
case 496:
#line 2312 "pars.yacc"
{
	    yyval.pset = MMSSLON;
	}
break;
case 497:
#line 2315 "pars.yacc"
{
	    yyval.pset = DEGREESLAT;
	}
break;
case 498:
#line 2318 "pars.yacc"
{
	    yyval.pset = DEGREESMMLAT;
	}
break;
case 499:
#line 2321 "pars.yacc"
{
	    yyval.pset = DEGREESMMSSLAT;
	}
break;
case 500:
#line 2324 "pars.yacc"
{
	    yyval.pset = MMSSLAT;
	}
break;
case 501:
#line 2330 "pars.yacc"
{
	    yyval.pset = NORMAL;
	}
break;
case 502:
#line 2333 "pars.yacc"
{
	    yyval.pset = ABSOLUTE;
	}
break;
case 503:
#line 2336 "pars.yacc"
{
	    yyval.pset = NEGATE;
	}
break;
case 504:
#line 2342 "pars.yacc"
{
	    yyval.pset = UP;
	}
break;
case 505:
#line 2345 "pars.yacc"
{
	    yyval.pset = DOWN;
	}
break;
case 506:
#line 2348 "pars.yacc"
{
	    yyval.pset = RIGHT;
	}
break;
case 507:
#line 2351 "pars.yacc"
{
	    yyval.pset = LEFT;
	}
break;
case 508:
#line 2354 "pars.yacc"
{
	    yyval.pset = IN;
	}
break;
case 509:
#line 2357 "pars.yacc"
{
	    yyval.pset = OUT;
	}
break;
case 510:
#line 2363 "pars.yacc"
{
	    yyval.pset = WORLD;
	}
break;
case 511:
#line 2366 "pars.yacc"
{
	    yyval.pset = VIEW;
	}
break;
case 512:
#line 2372 "pars.yacc"
{ yyval.pset = X; }
break;
case 513:
#line 2373 "pars.yacc"
{ yyval.pset = Y; }
break;
case 514:
#line 2374 "pars.yacc"
{ yyval.pset = X0; }
break;
case 515:
#line 2375 "pars.yacc"
{ yyval.pset = Y0; }
break;
case 516:
#line 2376 "pars.yacc"
{ yyval.pset = Y1; }
break;
case 517:
#line 2377 "pars.yacc"
{ yyval.pset = Y2; }
break;
case 518:
#line 2378 "pars.yacc"
{ yyval.pset = Y3; }
break;
case 519:
#line 2379 "pars.yacc"
{ yyval.pset = Y4; }
break;
case 520:
#line 2380 "pars.yacc"
{ yyval.pset = Y5; }
break;
case 521:
#line 2385 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    if (itmp >= ls) {
		yyerror("subscript out of range");
		return 1;
	    } else {
		yyvsp[-5].ptr[itmp] = yyvsp[0].val;
		result = yyvsp[0].val;
	    }
	}
break;
case 522:
#line 2396 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    double *ptr = getvptr(cg, curset, yyvsp[-3].val);
	    if (ptr != NULL) {
	        ptr[itmp] = yyvsp[0].val;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    result = yyvsp[0].val;
	    updatesetminmax(cg, curset);
	    update_set_status(cg, curset);
	}
break;
case 523:
#line 2411 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    double *ptr = getvptr(cg, yyvsp[-7].pset, yyvsp[-5].pset);
	    if (ptr != NULL) {
	        ptr[itmp] = yyvsp[0].val;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    result = yyvsp[0].val;
	    updatesetminmax(cg, yyvsp[-7].pset);
	    update_set_status(cg, yyvsp[-7].pset);
	}
break;
case 524:
#line 2426 "pars.yacc"
{
	    set_prop(cg, SET, SETNUM, yyvsp[-4].pset, SYMBOL, TYPE, (int) yyvsp[0].val, 0);
	    result = 0;
	}
break;
case 525:
#line 2438 "pars.yacc"
{
	    int itmp = (int) yyvsp[-3].val - 1;
	    double *ptr = getvptr(yyvsp[-9].pset, yyvsp[-7].pset, yyvsp[-5].pset);
	    if (ptr != NULL) {
	        ptr[itmp] = yyvsp[0].val;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    result = yyvsp[0].val;
	    updatesetminmax(yyvsp[-9].pset, yyvsp[-7].pset);
	    update_set_status(yyvsp[-9].pset, yyvsp[-7].pset);
	}
break;
case 526:
#line 2456 "pars.yacc"
{
	    if (yyvsp[-2].pset == X) {
		*xx = yyvsp[0].val;
	    } else {
		*yy = yyvsp[0].val;
	    }
	}
break;
case 527:
#line 2467 "pars.yacc"
{
	    int i;
	    for (i = 0; i < lxy; i++) {
		yyvsp[-2].ptr[i] = yyvsp[0].ptr[i];
	    }
	    result = yyvsp[0].ptr[0];
	}
break;
case 528:
#line 2475 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, curset)) {
		activateset(cg, curset);
		setlength(cg, curset, lxy);
		setcomment(cg, curset, "Created");
	    }
	    ptr = getvptr(cg, curset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].ptr[i];
	        }
	        result = yyvsp[0].ptr[0];
	        updatesetminmax(cg, curset);
	        update_set_status(cg, curset);
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 529:
#line 2497 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, yyvsp[-4].pset)) {
		activateset(cg, yyvsp[-4].pset);
		setlength(cg, yyvsp[-4].pset, lxy);
		setcomment(cg, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].ptr[i];
	        }
	        result = yyvsp[0].ptr[0];
	        updatesetminmax(cg, yyvsp[-4].pset);
	        update_set_status(cg, yyvsp[-4].pset);
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 530:
#line 2520 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(yyvsp[-6].pset, yyvsp[-4].pset)) {
		activateset(yyvsp[-6].pset, yyvsp[-4].pset);
		setlength(yyvsp[-6].pset, yyvsp[-4].pset, lxy);
		setcomment(yyvsp[-6].pset, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].ptr[i];
	        }
	        result = yyvsp[0].ptr[0];
	        updatesetminmax(yyvsp[-6].pset, yyvsp[-4].pset);
	        update_set_status(yyvsp[-6].pset, yyvsp[-4].pset);
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 531:
#line 2543 "pars.yacc"
{
	    int i;
	    for (i = 0; i < lxy; i++) {
		yyvsp[-2].ptr[i] = yyvsp[0].val;
	    }
	    result = yyvsp[0].val;
	}
break;
case 532:
#line 2551 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, curset)) {
		activateset(cg, curset);
		setlength(cg, curset, lxy);
		setcomment(cg, curset, "Created");
	    }
	    ptr = getvptr(cg, curset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].val;
	        }
	        result = yyvsp[0].val;
	        updatesetminmax(cg, curset);
	        update_set_status(cg, curset);
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 533:
#line 2574 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(cg, yyvsp[-4].pset)) {
		activateset(cg, yyvsp[-4].pset);
		setlength(cg, yyvsp[-4].pset, lxy);
		setcomment(cg, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].val;
	        }
	        result = yyvsp[0].val;
	        updatesetminmax(cg, yyvsp[-4].pset);
	        update_set_status(cg, yyvsp[-4].pset);
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 534:
#line 2597 "pars.yacc"
{
	    int i;
	    double *ptr;
	    if (!isactive_set(yyvsp[-6].pset, yyvsp[-4].pset)) {
		activateset(yyvsp[-6].pset, yyvsp[-4].pset);
		setlength(yyvsp[-6].pset, yyvsp[-4].pset, lxy);
		setcomment(yyvsp[-6].pset, yyvsp[-4].pset, "Created");
	    }
	    ptr = getvptr(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
	        for (i = 0; i < lxy; i++) {
		    ptr[i] = yyvsp[0].val;
	        }
	        result = yyvsp[0].val;
	        updatesetminmax(yyvsp[-6].pset, yyvsp[-4].pset);
	        update_set_status(yyvsp[-6].pset, yyvsp[-4].pset);
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 535:
#line 2623 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[0].ptr[i];
	    }
	}
break;
case 536:
#line 2632 "pars.yacc"
{
	    int i;
	    double *ptr = getvptr(cg, curset, yyvsp[0].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ptr[i];
	    }
	}
break;
case 537:
#line 2646 "pars.yacc"
{
	    int i;
	    double *ptr = getvptr(cg, yyvsp[-2].pset, yyvsp[0].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ptr[i];
	    }
	}
break;
case 538:
#line 2660 "pars.yacc"
{
	    int i;
	    double *ptr = getvptr(yyvsp[-4].pset, yyvsp[-2].pset, yyvsp[0].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ptr[i];
	    }
	}
break;
case 539:
#line 2674 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[0].val;
	    }
	}
break;
case 540:
#line 2683 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val + yyvsp[0].val;
	    }
	}
break;
case 541:
#line 2692 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] + yyvsp[0].ptr[i];
	    }
	}
break;
case 542:
#line 2701 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val + yyvsp[0].ptr[i];
	    }
	}
break;
case 543:
#line 2710 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] + yyvsp[0].val;
	    }
	}
break;
case 544:
#line 2719 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val - yyvsp[0].val;
	    }
	}
break;
case 545:
#line 2728 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] - yyvsp[0].ptr[i];
	    }
	}
break;
case 546:
#line 2737 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val - yyvsp[0].ptr[i];
	    }
	}
break;
case 547:
#line 2746 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] - yyvsp[0].val;
	    }
	}
break;
case 548:
#line 2755 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val * yyvsp[0].val;
	    }
	}
break;
case 549:
#line 2764 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] * yyvsp[0].ptr[i];
	    }
	}
break;
case 550:
#line 2773 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val * yyvsp[0].ptr[i];
	    }
	}
break;
case 551:
#line 2782 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] * yyvsp[0].val;
	    }
	}
break;
case 552:
#line 2791 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    if (yyvsp[0].val == 0.0) {
		yyerror("Divide by Zero");
		return 1;
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val / yyvsp[0].val;
	    }
	}
break;
case 553:
#line 2804 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		if (yyvsp[0].ptr[i] == 0.0) {
		    yyerror("Divide by Zero");
		    return 1;
		}
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] / yyvsp[0].ptr[i];
	    }
	}
break;
case 554:
#line 2819 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		if (yyvsp[0].ptr[i] == 0.0) {
		    yyerror("Divide by Zero");
		    return 1;
		}
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].val / yyvsp[0].ptr[i];
	    }
	}
break;
case 555:
#line 2834 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    if (yyvsp[0].val == 0.0) {
		yyerror("Divide by Zero");
		return 1;
	    }
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] / yyvsp[0].val;
	    }
	}
break;
case 556:
#line 2847 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].val, yyvsp[0].val);
	    }
	}
break;
case 557:
#line 2856 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].val, yyvsp[0].ptr[i]);
	    }
	}
break;
case 558:
#line 2865 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].ptr[i], yyvsp[0].val);
	    }
	}
break;
case 559:
#line 2874 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = pow(yyvsp[-2].ptr[i], yyvsp[0].ptr[i]);
	    }
	}
break;
case 560:
#line 2883 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fabs(yyvsp[-1].val);
	    }
	}
break;
case 561:
#line 2892 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fabs(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 562:
#line 2901 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = acos(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 563:
#line 2910 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = asin(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 564:
#line 2919 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = atan(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 565:
#line 2928 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = atan2(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 566:
#line 2937 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = ceil(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 567:
#line 2946 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = cos(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 568:
#line 2955 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] *= M_PI / 180.0;
	    }
	}
break;
case 569:
#line 2964 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = erf(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 570:
#line 2973 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = erfc(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 571:
#line 2982 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = exp(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 572:
#line 2991 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = floor(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 573:
#line 3000 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 574:
#line 3009 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].val, yyvsp[-1].ptr[i]);
	    }
	}
break;
case 575:
#line 3018 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].ptr[i], yyvsp[-1].val);
	    }
	}
break;
case 576:
#line 3027 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = my_hypot(yyvsp[-3].val, yyvsp[-1].val);
	    }
	}
break;
case 577:
#line 3036 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = i + 1;
	    }
	}
break;
case 578:
#line 3045 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[0].func;
	    }
	}
break;
case 579:
#line 3054 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = (int) yyvsp[-1].ptr[i];
	    }
	}
break;
case 580:
#line 3063 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = invnorm(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 581:
#line 3072 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = invt(yyvsp[-3].val, (int) yyvsp[-1].val);
	    }
	}
break;
case 582:
#line 3081 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = invt(yyvsp[-3].ptr[i], (int) yyvsp[-1].val);
	    }
	}
break;
case 583:
#line 3090 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = lrand48() % (long) (yyvsp[-1].val);
	    }
	}
break;
case 584:
#line 3099 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = lgamma(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 585:
#line 3108 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = log(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 586:
#line 3117 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = log10(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 587:
#line 3126 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = 1.0 / (1.0 + exp(-(yyvsp[-5].ptr[i] - yyvsp[-3].val)/ yyvsp[-1].val));
	    }
	}
break;
case 588:
#line 3135 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-3].ptr[i] >= yyvsp[-1].ptr[i] ? yyvsp[-3].ptr[i] : yyvsp[-1].ptr[i];
	    }
	}
break;
case 589:
#line 3144 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-3].ptr[i] <= yyvsp[-1].ptr[i] ? yyvsp[-3].ptr[i] : yyvsp[-1].ptr[i];
	    }
	}
break;
case 590:
#line 3153 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fmod(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 591:
#line 3162 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = fx(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 592:
#line 3171 "pars.yacc"
{
	    int i;
	    double tmp;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = normp(yyvsp[-1].ptr[i], &tmp);
	    }
	}
break;
case 593:
#line 3181 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = M_PI;
	    }
	}
break;
case 594:
#line 3190 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = M_PI / 180.0;
	    }
	}
break;
case 595:
#line 3199 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = (double) drand48();
	    }
	}
break;
case 596:
#line 3208 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].ptr[i], yyvsp[-1].ptr[i]);
	    }
	}
break;
case 597:
#line 3217 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].val, yyvsp[-1].ptr[i]);
	    }
	}
break;
case 598:
#line 3226 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].ptr[i], yyvsp[-1].val);
	    }
	}
break;
case 599:
#line 3235 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = rnorm(yyvsp[-3].val, yyvsp[-1].val);
	    }
	}
break;
case 600:
#line 3244 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = sin(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 601:
#line 3253 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-1].ptr[i] * yyvsp[-1].ptr[i];
	    }
	}
break;
case 602:
#line 3262 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = sqrt(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 603:
#line 3271 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = tan(yyvsp[-1].ptr[i]);
	    }
	}
break;
case 604:
#line 3279 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
	        if ((int) yyvsp[-4].ptr[i]) {
		    yyval.ptr[i] = yyvsp[-2].ptr[i];
	        } else {
		    yyval.ptr[i] = yyvsp[0].ptr[i];
	        }
	    }
	}
break;
case 605:
#line 3292 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] > yyvsp[0].ptr[i];
	    }
	}
break;
case 606:
#line 3301 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] < yyvsp[0].ptr[i];
	    }
	}
break;
case 607:
#line 3310 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] <= yyvsp[0].ptr[i];
	    }
	}
break;
case 608:
#line 3319 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] >= yyvsp[0].ptr[i];
	    }
	}
break;
case 609:
#line 3328 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] == yyvsp[0].ptr[i];
	    }
	}
break;
case 610:
#line 3337 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] != yyvsp[0].ptr[i];
	    }
	}
break;
case 611:
#line 3346 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] && yyvsp[0].ptr[i];
	    }
	}
break;
case 612:
#line 3355 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-2].ptr[i] || yyvsp[0].ptr[i];
	    }
	}
break;
case 613:
#line 3364 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = !(yyvsp[0].ptr[i]);
	    }
	}
break;
case 614:
#line 3373 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = yyvsp[-1].ptr[i];
	    }
	}
break;
case 615:
#line 3381 "pars.yacc"
{
	    int i;
	    yyval.ptr = (double *) calloc(lxy, sizeof(double));
	    freelist[fcnt++] = yyval.ptr;
	    for (i = 0; i < lxy; i++) {
		yyval.ptr[i] = -yyvsp[0].ptr[i];
	    }
	}
break;
case 617:
#line 3392 "pars.yacc"
{
	    yyval.val = yyvsp[0].val;
	}
break;
case 618:
#line 3395 "pars.yacc"
{
	    yyval.val = yyvsp[-3].ptr[(int) yyvsp[-1].val];
	}
break;
case 619:
#line 3398 "pars.yacc"
{
	    yyval.val = (yyvsp[0].pset == X) ? *xx : *yy;
	}
break;
case 620:
#line 3401 "pars.yacc"
{
	    double *ptr = getvptr(cg, curset, yyvsp[-3].pset);
	    if (ptr != NULL) {
		yyval.val = ptr[(int) yyvsp[-1].val - 1];
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 621:
#line 3411 "pars.yacc"
{
	    double *ptr = getvptr(cg, yyvsp[-5].pset, yyvsp[-3].pset);
	    if (ptr != NULL) {
		yyval.val = ptr[(int) yyvsp[-1].val - 1];
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 622:
#line 3421 "pars.yacc"
{
	    double *ptr = getvptr(yyvsp[-7].pset, yyvsp[-5].pset, yyvsp[-3].pset);
	    if (ptr != NULL) {
		yyval.val = ptr[(int) yyvsp[-1].val - 1];
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 623:
#line 3431 "pars.yacc"
{
	    double *ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    switch (yyvsp[0].pset) {
	    case MINP:
		yyval.val = vmin(ptr, g[cg].p[yyvsp[-4].pset].len);
		break;
	    case MAXP:
		yyval.val = vmax(ptr, g[cg].p[yyvsp[-4].pset].len);
		break;
	    }
	}
break;
case 624:
#line 3446 "pars.yacc"
{
	    double *ptr = getvptr(yyvsp[-6].pset, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr == NULL) {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	    switch (yyvsp[0].pset) {
	    case MINP:
		yyval.val = vmin(ptr, g[yyvsp[-6].pset].p[yyvsp[-4].pset].len);
		break;
	    case MAXP:
		yyval.val = vmax(ptr, g[yyvsp[-6].pset].p[yyvsp[-4].pset].len);
		break;
	    }
	}
break;
case 625:
#line 3461 "pars.yacc"
{
	    yyval.val = g[cg].p[yyvsp[-2].pset].len;
	}
break;
case 626:
#line 3465 "pars.yacc"
{
	    double bar, sd;
	    double *ptr = getvptr(cg, yyvsp[-4].pset, yyvsp[-2].pset);
	    if (ptr != NULL) {
		stasum(ptr, getsetlength(cg, yyvsp[-4].pset), &bar, &sd, 0);
	        yyval.val = bar;
	    }
	    else {
		yyerror("NULL variable, check set type");
		return 1;
	    }
	}
break;
case 627:
#line 3477 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val + yyvsp[0].val;
	}
break;
case 628:
#line 3480 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val - yyvsp[0].val;
	}
break;
case 629:
#line 3483 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val * yyvsp[0].val;
	}
break;
case 630:
#line 3487 "pars.yacc"
{
	    if (yyvsp[0].val != 0.0) {
		yyval.val = yyvsp[-2].val / yyvsp[0].val;
	    } else {
		yyerror("Divide by Zero");
		return 1;
	    }
	}
break;
case 631:
#line 3495 "pars.yacc"
{
	    yyval.val = fmod(yyvsp[-2].val, yyvsp[0].val);
	}
break;
case 632:
#line 3498 "pars.yacc"
{
	    yyval.val = pow(yyvsp[-2].val, yyvsp[0].val);
	}
break;
case 633:
#line 3501 "pars.yacc"
{
	    yyval.val = fabs(yyvsp[-1].val);
	}
break;
case 634:
#line 3504 "pars.yacc"
{
	    yyval.val = acos(yyvsp[-1].val);
	}
break;
case 635:
#line 3507 "pars.yacc"
{
	    yyval.val = asin(yyvsp[-1].val);
	}
break;
case 636:
#line 3510 "pars.yacc"
{
	    yyval.val = atan(yyvsp[-1].val);
	}
break;
case 637:
#line 3513 "pars.yacc"
{
	    yyval.val = atan2(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 638:
#line 3516 "pars.yacc"
{
	    yyval.val = ceil(yyvsp[-1].val);
	}
break;
case 639:
#line 3519 "pars.yacc"
{
	    yyval.val = cos(yyvsp[-1].val);
	}
break;
case 640:
#line 3522 "pars.yacc"
{
	    yyval.val = 180.0 / M_PI;
	}
break;
case 641:
#line 3525 "pars.yacc"
{
	    yyval.val = erf(yyvsp[-1].val);
	}
break;
case 642:
#line 3528 "pars.yacc"
{
	    yyval.val = erfc(yyvsp[-1].val);
	}
break;
case 643:
#line 3531 "pars.yacc"
{
	    yyval.val = exp(yyvsp[-1].val);
	}
break;
case 644:
#line 3534 "pars.yacc"
{
	    yyval.val = floor(yyvsp[-1].val);
	}
break;
case 645:
#line 3537 "pars.yacc"
{
	    yyval.val = my_hypot(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 646:
#line 3540 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.xv1;
	}
break;
case 647:
#line 3543 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.xv2;
	}
break;
case 648:
#line 3546 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.yv1;
	}
break;
case 649:
#line 3549 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].v.yv2;
	}
break;
case 650:
#line 3552 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.xg1;
	}
break;
case 651:
#line 3555 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.xg2;
	}
break;
case 652:
#line 3558 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.yg1;
	}
break;
case 653:
#line 3561 "pars.yacc"
{
	    yyval.val = g[yyvsp[-2].pset].w.yg2;
	}
break;
case 654:
#line 3564 "pars.yacc"
{
	    yyval.val = g[cg].v.xv1;
	}
break;
case 655:
#line 3567 "pars.yacc"
{
	    yyval.val = g[cg].v.xv2;
	}
break;
case 656:
#line 3570 "pars.yacc"
{
	    yyval.val = g[cg].v.yv1;
	}
break;
case 657:
#line 3573 "pars.yacc"
{
	    yyval.val = g[cg].v.yv2;
	}
break;
case 658:
#line 3576 "pars.yacc"
{
	    yyval.val = g[cg].w.xg1;
	}
break;
case 659:
#line 3579 "pars.yacc"
{
	    yyval.val = g[cg].w.xg2;
	}
break;
case 660:
#line 3582 "pars.yacc"
{
	    yyval.val = g[cg].w.yg1;
	}
break;
case 661:
#line 3585 "pars.yacc"
{
	    yyval.val = g[cg].w.yg2;
	}
break;
case 662:
#line 3588 "pars.yacc"
{
	    yyval.val = g[cg].w.xg2 - g[cg].w.xg1;
	}
break;
case 663:
#line 3591 "pars.yacc"
{
	    yyval.val = g[cg].w.yg2 - g[cg].w.yg1;
	}
break;
case 664:
#line 3594 "pars.yacc"
{
	    yyval.val = setindex;
	}
break;
case 665:
#line 3597 "pars.yacc"
{
	    yyval.val = setsetno;
	}
break;
case 666:
#line 3600 "pars.yacc"
{
	    yyval.val = (long) yyvsp[-1].val;
	}
break;
case 667:
#line 3603 "pars.yacc"
{
	    yyval.val = invnorm(yyvsp[-1].val);
	}
break;
case 668:
#line 3606 "pars.yacc"
{
	    yyval.val = invt(yyvsp[-3].val, (int) yyvsp[-1].val);
	}
break;
case 669:
#line 3609 "pars.yacc"
{
	    yyval.val = lrand48() % (long) (yyvsp[-1].val);
	}
break;
case 670:
#line 3612 "pars.yacc"
{
	    yyval.val = lgamma(yyvsp[-1].val);
	}
break;
case 671:
#line 3615 "pars.yacc"
{
	    yyval.val = log(yyvsp[-1].val);
	}
break;
case 672:
#line 3618 "pars.yacc"
{
	    yyval.val = log10(yyvsp[-1].val);
	}
break;
case 673:
#line 3622 "pars.yacc"
{
	    yyval.val = 1.0 / (1.0 + exp(-(yyvsp[-5].val - yyvsp[-3].val)/ yyvsp[-1].val));
	}
break;
case 674:
#line 3625 "pars.yacc"
{
	    yyval.val = yyvsp[-3].val >= yyvsp[-1].val ? yyvsp[-3].val : yyvsp[-1].val;
	}
break;
case 675:
#line 3628 "pars.yacc"
{
	    yyval.val = yyvsp[-3].val <= yyvsp[-1].val ? yyvsp[-3].val : yyvsp[-1].val;
	}
break;
case 676:
#line 3631 "pars.yacc"
{
	    yyval.val = fmod(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 677:
#line 3634 "pars.yacc"
{
	    yyval.val = fx(yyvsp[-1].val);
	}
break;
case 678:
#line 3637 "pars.yacc"
{
	    double tmp;
	    yyval.val = normp(yyvsp[-1].val, &tmp);
	}
break;
case 679:
#line 3641 "pars.yacc"
{
	    yyval.val = M_PI;
	}
break;
case 680:
#line 3644 "pars.yacc"
{
	    yyval.val = M_PI / 180.0;
	}
break;
case 681:
#line 3647 "pars.yacc"
{
	    yyval.val = (double) drand48();
	}
break;
case 682:
#line 3650 "pars.yacc"
{
	    yyval.val = rnorm(yyvsp[-3].val, yyvsp[-1].val);
	}
break;
case 683:
#line 3653 "pars.yacc"
{
	    yyval.val = sin(yyvsp[-1].val);
	}
break;
case 684:
#line 3656 "pars.yacc"
{
	    yyval.val = pow(yyvsp[-1].val, 2.0);
	}
break;
case 685:
#line 3659 "pars.yacc"
{
	    yyval.val = sqrt(yyvsp[-1].val);
	}
break;
case 686:
#line 3662 "pars.yacc"
{
	    yyval.val = tan(yyvsp[-1].val);
	}
break;
case 687:
#line 3665 "pars.yacc"
{
	    if ((int) yyvsp[-4].val) {
		yyval.val = yyvsp[-2].val;
	    } else {
		yyval.val = yyvsp[0].val;
	    }
	}
break;
case 688:
#line 3672 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val > yyvsp[0].val;
	}
break;
case 689:
#line 3675 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val < yyvsp[0].val;
	}
break;
case 690:
#line 3678 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val <= yyvsp[0].val;
	}
break;
case 691:
#line 3681 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val >= yyvsp[0].val;
	}
break;
case 692:
#line 3684 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val == yyvsp[0].val;
	}
break;
case 693:
#line 3687 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val != yyvsp[0].val;
	}
break;
case 694:
#line 3690 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val && yyvsp[0].val;
	}
break;
case 695:
#line 3693 "pars.yacc"
{
	    yyval.val = yyvsp[-2].val || yyvsp[0].val;
	}
break;
case 696:
#line 3696 "pars.yacc"
{
	    yyval.val = !(yyvsp[0].val);
	}
break;
case 697:
#line 3699 "pars.yacc"
{
	    yyval.val = yyvsp[-1].val;
	}
break;
case 698:
#line 3702 "pars.yacc"
{
	    yyval.val = -yyvsp[0].val;
	}
break;
#line 10297 "y.tab.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("yydebug: after reduction, shifting from state 0 to\
 state %d\n", YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("yydebug: state %d, reading %d (%s)\n",
                        YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("yydebug: after reduction, shifting from state %d \
to state %d\n", *yyssp, yystate);
#endif
    if (yyssp >= yyss + yystacksize - 1)
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
